//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.
// DO NOT EDIT.

package armappservice

import (
	"encoding/json"
	"io"
)

// CertificateOrdersClientCreateOrUpdateCertificateResponse contains the response from method CertificateOrdersClient.CreateOrUpdateCertificate.
type CertificateOrdersClientCreateOrUpdateCertificateResponse struct {
	CertificateResource
}

// CertificateOrdersClientCreateOrUpdateResponse contains the response from method CertificateOrdersClient.CreateOrUpdate.
type CertificateOrdersClientCreateOrUpdateResponse struct {
	CertificateOrder
}

// CertificateOrdersClientDeleteCertificateResponse contains the response from method CertificateOrdersClient.DeleteCertificate.
type CertificateOrdersClientDeleteCertificateResponse struct {
	// placeholder for future response values
}

// CertificateOrdersClientDeleteResponse contains the response from method CertificateOrdersClient.Delete.
type CertificateOrdersClientDeleteResponse struct {
	// placeholder for future response values
}

// CertificateOrdersClientGetCertificateResponse contains the response from method CertificateOrdersClient.GetCertificate.
type CertificateOrdersClientGetCertificateResponse struct {
	CertificateResource
}

// CertificateOrdersClientGetResponse contains the response from method CertificateOrdersClient.Get.
type CertificateOrdersClientGetResponse struct {
	CertificateOrder
}

// CertificateOrdersClientListByResourceGroupResponse contains the response from method CertificateOrdersClient.ListByResourceGroup.
type CertificateOrdersClientListByResourceGroupResponse struct {
	CertificateOrderCollection
}

// CertificateOrdersClientListCertificatesResponse contains the response from method CertificateOrdersClient.ListCertificates.
type CertificateOrdersClientListCertificatesResponse struct {
	CertificateCollection
}

// CertificateOrdersClientListResponse contains the response from method CertificateOrdersClient.List.
type CertificateOrdersClientListResponse struct {
	CertificateOrderCollection
}

// CertificateOrdersClientReissueResponse contains the response from method CertificateOrdersClient.Reissue.
type CertificateOrdersClientReissueResponse struct {
	// placeholder for future response values
}

// CertificateOrdersClientRenewResponse contains the response from method CertificateOrdersClient.Renew.
type CertificateOrdersClientRenewResponse struct {
	// placeholder for future response values
}

// CertificateOrdersClientResendEmailResponse contains the response from method CertificateOrdersClient.ResendEmail.
type CertificateOrdersClientResendEmailResponse struct {
	// placeholder for future response values
}

// CertificateOrdersClientResendRequestEmailsResponse contains the response from method CertificateOrdersClient.ResendRequestEmails.
type CertificateOrdersClientResendRequestEmailsResponse struct {
	// placeholder for future response values
}

// CertificateOrdersClientRetrieveCertificateActionsResponse contains the response from method CertificateOrdersClient.RetrieveCertificateActions.
type CertificateOrdersClientRetrieveCertificateActionsResponse struct {
	// Array of CertificateOrderAction
	CertificateOrderActionArray []*CertificateOrderAction
}

// CertificateOrdersClientRetrieveCertificateEmailHistoryResponse contains the response from method CertificateOrdersClient.RetrieveCertificateEmailHistory.
type CertificateOrdersClientRetrieveCertificateEmailHistoryResponse struct {
	// Array of CertificateEmail
	CertificateEmailArray []*CertificateEmail
}

// CertificateOrdersClientRetrieveSiteSealResponse contains the response from method CertificateOrdersClient.RetrieveSiteSeal.
type CertificateOrdersClientRetrieveSiteSealResponse struct {
	SiteSeal
}

// CertificateOrdersClientUpdateCertificateResponse contains the response from method CertificateOrdersClient.UpdateCertificate.
type CertificateOrdersClientUpdateCertificateResponse struct {
	CertificateResource
}

// CertificateOrdersClientUpdateResponse contains the response from method CertificateOrdersClient.Update.
type CertificateOrdersClientUpdateResponse struct {
	CertificateOrder
}

// CertificateOrdersClientValidatePurchaseInformationResponse contains the response from method CertificateOrdersClient.ValidatePurchaseInformation.
type CertificateOrdersClientValidatePurchaseInformationResponse struct {
	// placeholder for future response values
}

// CertificateOrdersClientVerifyDomainOwnershipResponse contains the response from method CertificateOrdersClient.VerifyDomainOwnership.
type CertificateOrdersClientVerifyDomainOwnershipResponse struct {
	// placeholder for future response values
}

// CertificateOrdersDiagnosticsClientGetAppServiceCertificateOrderDetectorResponseResponse contains the response from method
// CertificateOrdersDiagnosticsClient.GetAppServiceCertificateOrderDetectorResponse.
type CertificateOrdersDiagnosticsClientGetAppServiceCertificateOrderDetectorResponseResponse struct {
	DetectorResponse
}

// CertificateOrdersDiagnosticsClientListAppServiceCertificateOrderDetectorResponseResponse contains the response from method
// CertificateOrdersDiagnosticsClient.ListAppServiceCertificateOrderDetectorResponse.
type CertificateOrdersDiagnosticsClientListAppServiceCertificateOrderDetectorResponseResponse struct {
	DetectorResponseCollection
}

// CertificateRegistrationProviderClientListOperationsResponse contains the response from method CertificateRegistrationProviderClient.ListOperations.
type CertificateRegistrationProviderClientListOperationsResponse struct {
	CsmOperationCollection
}

// CertificatesClientCreateOrUpdateResponse contains the response from method CertificatesClient.CreateOrUpdate.
type CertificatesClientCreateOrUpdateResponse struct {
	AppCertificate
}

// CertificatesClientDeleteResponse contains the response from method CertificatesClient.Delete.
type CertificatesClientDeleteResponse struct {
	// placeholder for future response values
}

// CertificatesClientGetResponse contains the response from method CertificatesClient.Get.
type CertificatesClientGetResponse struct {
	AppCertificate
}

// CertificatesClientListByResourceGroupResponse contains the response from method CertificatesClient.ListByResourceGroup.
type CertificatesClientListByResourceGroupResponse struct {
	AppCertificateCollection
}

// CertificatesClientListResponse contains the response from method CertificatesClient.List.
type CertificatesClientListResponse struct {
	AppCertificateCollection
}

// CertificatesClientUpdateResponse contains the response from method CertificatesClient.Update.
type CertificatesClientUpdateResponse struct {
	AppCertificate
}

// ContainerAppsClientCreateOrUpdateResponse contains the response from method ContainerAppsClient.CreateOrUpdate.
type ContainerAppsClientCreateOrUpdateResponse struct {
	ContainerApp
}

// ContainerAppsClientDeleteResponse contains the response from method ContainerAppsClient.Delete.
type ContainerAppsClientDeleteResponse struct {
	// placeholder for future response values
}

// ContainerAppsClientGetResponse contains the response from method ContainerAppsClient.Get.
type ContainerAppsClientGetResponse struct {
	ContainerApp
}

// ContainerAppsClientListByResourceGroupResponse contains the response from method ContainerAppsClient.ListByResourceGroup.
type ContainerAppsClientListByResourceGroupResponse struct {
	ContainerAppCollection
}

// ContainerAppsClientListBySubscriptionResponse contains the response from method ContainerAppsClient.ListBySubscription.
type ContainerAppsClientListBySubscriptionResponse struct {
	ContainerAppCollection
}

// ContainerAppsClientListSecretsResponse contains the response from method ContainerAppsClient.ListSecrets.
type ContainerAppsClientListSecretsResponse struct {
	SecretsCollection
}

// ContainerAppsRevisionsClientActivateRevisionResponse contains the response from method ContainerAppsRevisionsClient.ActivateRevision.
type ContainerAppsRevisionsClientActivateRevisionResponse struct {
	// placeholder for future response values
}

// ContainerAppsRevisionsClientDeactivateRevisionResponse contains the response from method ContainerAppsRevisionsClient.DeactivateRevision.
type ContainerAppsRevisionsClientDeactivateRevisionResponse struct {
	// placeholder for future response values
}

// ContainerAppsRevisionsClientGetRevisionResponse contains the response from method ContainerAppsRevisionsClient.GetRevision.
type ContainerAppsRevisionsClientGetRevisionResponse struct {
	Revision
}

// ContainerAppsRevisionsClientListRevisionsResponse contains the response from method ContainerAppsRevisionsClient.ListRevisions.
type ContainerAppsRevisionsClientListRevisionsResponse struct {
	RevisionCollection
}

// ContainerAppsRevisionsClientRestartRevisionResponse contains the response from method ContainerAppsRevisionsClient.RestartRevision.
type ContainerAppsRevisionsClientRestartRevisionResponse struct {
	// placeholder for future response values
}

// DeletedWebAppsClientGetDeletedWebAppByLocationResponse contains the response from method DeletedWebAppsClient.GetDeletedWebAppByLocation.
type DeletedWebAppsClientGetDeletedWebAppByLocationResponse struct {
	DeletedSite
}

// DeletedWebAppsClientListByLocationResponse contains the response from method DeletedWebAppsClient.ListByLocation.
type DeletedWebAppsClientListByLocationResponse struct {
	DeletedWebAppCollection
}

// DeletedWebAppsClientListResponse contains the response from method DeletedWebAppsClient.List.
type DeletedWebAppsClientListResponse struct {
	DeletedWebAppCollection
}

// DiagnosticsClientExecuteSiteAnalysisResponse contains the response from method DiagnosticsClient.ExecuteSiteAnalysis.
type DiagnosticsClientExecuteSiteAnalysisResponse struct {
	DiagnosticAnalysis
}

// DiagnosticsClientExecuteSiteAnalysisSlotResponse contains the response from method DiagnosticsClient.ExecuteSiteAnalysisSlot.
type DiagnosticsClientExecuteSiteAnalysisSlotResponse struct {
	DiagnosticAnalysis
}

// DiagnosticsClientExecuteSiteDetectorResponse contains the response from method DiagnosticsClient.ExecuteSiteDetector.
type DiagnosticsClientExecuteSiteDetectorResponse struct {
	DiagnosticDetectorResponse
}

// DiagnosticsClientExecuteSiteDetectorSlotResponse contains the response from method DiagnosticsClient.ExecuteSiteDetectorSlot.
type DiagnosticsClientExecuteSiteDetectorSlotResponse struct {
	DiagnosticDetectorResponse
}

// DiagnosticsClientGetHostingEnvironmentDetectorResponseResponse contains the response from method DiagnosticsClient.GetHostingEnvironmentDetectorResponse.
type DiagnosticsClientGetHostingEnvironmentDetectorResponseResponse struct {
	DetectorResponse
}

// DiagnosticsClientGetSiteAnalysisResponse contains the response from method DiagnosticsClient.GetSiteAnalysis.
type DiagnosticsClientGetSiteAnalysisResponse struct {
	AnalysisDefinition
}

// DiagnosticsClientGetSiteAnalysisSlotResponse contains the response from method DiagnosticsClient.GetSiteAnalysisSlot.
type DiagnosticsClientGetSiteAnalysisSlotResponse struct {
	AnalysisDefinition
}

// DiagnosticsClientGetSiteDetectorResponse contains the response from method DiagnosticsClient.GetSiteDetector.
type DiagnosticsClientGetSiteDetectorResponse struct {
	DetectorDefinitionResource
}

// DiagnosticsClientGetSiteDetectorResponseResponse contains the response from method DiagnosticsClient.GetSiteDetectorResponse.
type DiagnosticsClientGetSiteDetectorResponseResponse struct {
	DetectorResponse
}

// DiagnosticsClientGetSiteDetectorResponseSlotResponse contains the response from method DiagnosticsClient.GetSiteDetectorResponseSlot.
type DiagnosticsClientGetSiteDetectorResponseSlotResponse struct {
	DetectorResponse
}

// DiagnosticsClientGetSiteDetectorSlotResponse contains the response from method DiagnosticsClient.GetSiteDetectorSlot.
type DiagnosticsClientGetSiteDetectorSlotResponse struct {
	DetectorDefinitionResource
}

// DiagnosticsClientGetSiteDiagnosticCategoryResponse contains the response from method DiagnosticsClient.GetSiteDiagnosticCategory.
type DiagnosticsClientGetSiteDiagnosticCategoryResponse struct {
	DiagnosticCategory
}

// DiagnosticsClientGetSiteDiagnosticCategorySlotResponse contains the response from method DiagnosticsClient.GetSiteDiagnosticCategorySlot.
type DiagnosticsClientGetSiteDiagnosticCategorySlotResponse struct {
	DiagnosticCategory
}

// DiagnosticsClientListHostingEnvironmentDetectorResponsesResponse contains the response from method DiagnosticsClient.ListHostingEnvironmentDetectorResponses.
type DiagnosticsClientListHostingEnvironmentDetectorResponsesResponse struct {
	DetectorResponseCollection
}

// DiagnosticsClientListSiteAnalysesResponse contains the response from method DiagnosticsClient.ListSiteAnalyses.
type DiagnosticsClientListSiteAnalysesResponse struct {
	DiagnosticAnalysisCollection
}

// DiagnosticsClientListSiteAnalysesSlotResponse contains the response from method DiagnosticsClient.ListSiteAnalysesSlot.
type DiagnosticsClientListSiteAnalysesSlotResponse struct {
	DiagnosticAnalysisCollection
}

// DiagnosticsClientListSiteDetectorResponsesResponse contains the response from method DiagnosticsClient.ListSiteDetectorResponses.
type DiagnosticsClientListSiteDetectorResponsesResponse struct {
	DetectorResponseCollection
}

// DiagnosticsClientListSiteDetectorResponsesSlotResponse contains the response from method DiagnosticsClient.ListSiteDetectorResponsesSlot.
type DiagnosticsClientListSiteDetectorResponsesSlotResponse struct {
	DetectorResponseCollection
}

// DiagnosticsClientListSiteDetectorsResponse contains the response from method DiagnosticsClient.ListSiteDetectors.
type DiagnosticsClientListSiteDetectorsResponse struct {
	DiagnosticDetectorCollection
}

// DiagnosticsClientListSiteDetectorsSlotResponse contains the response from method DiagnosticsClient.ListSiteDetectorsSlot.
type DiagnosticsClientListSiteDetectorsSlotResponse struct {
	DiagnosticDetectorCollection
}

// DiagnosticsClientListSiteDiagnosticCategoriesResponse contains the response from method DiagnosticsClient.ListSiteDiagnosticCategories.
type DiagnosticsClientListSiteDiagnosticCategoriesResponse struct {
	DiagnosticCategoryCollection
}

// DiagnosticsClientListSiteDiagnosticCategoriesSlotResponse contains the response from method DiagnosticsClient.ListSiteDiagnosticCategoriesSlot.
type DiagnosticsClientListSiteDiagnosticCategoriesSlotResponse struct {
	DiagnosticCategoryCollection
}

// DomainRegistrationProviderClientListOperationsResponse contains the response from method DomainRegistrationProviderClient.ListOperations.
type DomainRegistrationProviderClientListOperationsResponse struct {
	CsmOperationCollection
}

// DomainsClientCheckAvailabilityResponse contains the response from method DomainsClient.CheckAvailability.
type DomainsClientCheckAvailabilityResponse struct {
	DomainAvailabilityCheckResult
}

// DomainsClientCreateOrUpdateOwnershipIdentifierResponse contains the response from method DomainsClient.CreateOrUpdateOwnershipIdentifier.
type DomainsClientCreateOrUpdateOwnershipIdentifierResponse struct {
	DomainOwnershipIdentifier
}

// DomainsClientCreateOrUpdateResponse contains the response from method DomainsClient.CreateOrUpdate.
type DomainsClientCreateOrUpdateResponse struct {
	Domain
}

// DomainsClientDeleteOwnershipIdentifierResponse contains the response from method DomainsClient.DeleteOwnershipIdentifier.
type DomainsClientDeleteOwnershipIdentifierResponse struct {
	// placeholder for future response values
}

// DomainsClientDeleteResponse contains the response from method DomainsClient.Delete.
type DomainsClientDeleteResponse struct {
	// placeholder for future response values
}

// DomainsClientGetControlCenterSsoRequestResponse contains the response from method DomainsClient.GetControlCenterSsoRequest.
type DomainsClientGetControlCenterSsoRequestResponse struct {
	DomainControlCenterSsoRequest
}

// DomainsClientGetOwnershipIdentifierResponse contains the response from method DomainsClient.GetOwnershipIdentifier.
type DomainsClientGetOwnershipIdentifierResponse struct {
	DomainOwnershipIdentifier
}

// DomainsClientGetResponse contains the response from method DomainsClient.Get.
type DomainsClientGetResponse struct {
	Domain
}

// DomainsClientListByResourceGroupResponse contains the response from method DomainsClient.ListByResourceGroup.
type DomainsClientListByResourceGroupResponse struct {
	DomainCollection
}

// DomainsClientListOwnershipIdentifiersResponse contains the response from method DomainsClient.ListOwnershipIdentifiers.
type DomainsClientListOwnershipIdentifiersResponse struct {
	DomainOwnershipIdentifierCollection
}

// DomainsClientListRecommendationsResponse contains the response from method DomainsClient.ListRecommendations.
type DomainsClientListRecommendationsResponse struct {
	NameIdentifierCollection
}

// DomainsClientListResponse contains the response from method DomainsClient.List.
type DomainsClientListResponse struct {
	DomainCollection
}

// DomainsClientRenewResponse contains the response from method DomainsClient.Renew.
type DomainsClientRenewResponse struct {
	// placeholder for future response values
}

// DomainsClientTransferOutResponse contains the response from method DomainsClient.TransferOut.
type DomainsClientTransferOutResponse struct {
	Domain
}

// DomainsClientUpdateOwnershipIdentifierResponse contains the response from method DomainsClient.UpdateOwnershipIdentifier.
type DomainsClientUpdateOwnershipIdentifierResponse struct {
	DomainOwnershipIdentifier
}

// DomainsClientUpdateResponse contains the response from method DomainsClient.Update.
type DomainsClientUpdateResponse struct {
	Domain
}

// EnvironmentsClientApproveOrRejectPrivateEndpointConnectionResponse contains the response from method EnvironmentsClient.ApproveOrRejectPrivateEndpointConnection.
type EnvironmentsClientApproveOrRejectPrivateEndpointConnectionResponse struct {
	RemotePrivateEndpointConnectionARMResource
}

// EnvironmentsClientChangeVnetResponse contains the response from method EnvironmentsClient.ChangeVnet.
type EnvironmentsClientChangeVnetResponse struct {
	WebAppCollection
}

// EnvironmentsClientCreateOrUpdateMultiRolePoolResponse contains the response from method EnvironmentsClient.CreateOrUpdateMultiRolePool.
type EnvironmentsClientCreateOrUpdateMultiRolePoolResponse struct {
	WorkerPoolResource
}

// EnvironmentsClientCreateOrUpdateResponse contains the response from method EnvironmentsClient.CreateOrUpdate.
type EnvironmentsClientCreateOrUpdateResponse struct {
	EnvironmentResource
}

// EnvironmentsClientCreateOrUpdateWorkerPoolResponse contains the response from method EnvironmentsClient.CreateOrUpdateWorkerPool.
type EnvironmentsClientCreateOrUpdateWorkerPoolResponse struct {
	WorkerPoolResource
}

// EnvironmentsClientDeleteAseCustomDNSSuffixConfigurationResponse contains the response from method EnvironmentsClient.DeleteAseCustomDNSSuffixConfiguration.
type EnvironmentsClientDeleteAseCustomDNSSuffixConfigurationResponse struct {
	// Anything
	Interface interface{}
}

// EnvironmentsClientDeletePrivateEndpointConnectionResponse contains the response from method EnvironmentsClient.DeletePrivateEndpointConnection.
type EnvironmentsClientDeletePrivateEndpointConnectionResponse struct {
	// Anything
	Interface interface{}
}

// UnmarshalJSON implements the json.Unmarshaller interface for type EnvironmentsClientDeletePrivateEndpointConnectionResponse.
func (e *EnvironmentsClientDeletePrivateEndpointConnectionResponse) UnmarshalJSON(data []byte) error {
	return json.Unmarshal(data, &e.Interface)
}

// EnvironmentsClientDeleteResponse contains the response from method EnvironmentsClient.Delete.
type EnvironmentsClientDeleteResponse struct {
	// placeholder for future response values
}

// EnvironmentsClientGetAseCustomDNSSuffixConfigurationResponse contains the response from method EnvironmentsClient.GetAseCustomDNSSuffixConfiguration.
type EnvironmentsClientGetAseCustomDNSSuffixConfigurationResponse struct {
	CustomDNSSuffixConfiguration
}

// EnvironmentsClientGetAseV3NetworkingConfigurationResponse contains the response from method EnvironmentsClient.GetAseV3NetworkingConfiguration.
type EnvironmentsClientGetAseV3NetworkingConfigurationResponse struct {
	AseV3NetworkingConfiguration
}

// EnvironmentsClientGetDiagnosticsItemResponse contains the response from method EnvironmentsClient.GetDiagnosticsItem.
type EnvironmentsClientGetDiagnosticsItemResponse struct {
	HostingEnvironmentDiagnostics
}

// EnvironmentsClientGetInboundNetworkDependenciesEndpointsResponse contains the response from method EnvironmentsClient.GetInboundNetworkDependenciesEndpoints.
type EnvironmentsClientGetInboundNetworkDependenciesEndpointsResponse struct {
	InboundEnvironmentEndpointCollection
}

// EnvironmentsClientGetMultiRolePoolResponse contains the response from method EnvironmentsClient.GetMultiRolePool.
type EnvironmentsClientGetMultiRolePoolResponse struct {
	WorkerPoolResource
}

// EnvironmentsClientGetOutboundNetworkDependenciesEndpointsResponse contains the response from method EnvironmentsClient.GetOutboundNetworkDependenciesEndpoints.
type EnvironmentsClientGetOutboundNetworkDependenciesEndpointsResponse struct {
	OutboundEnvironmentEndpointCollection
}

// EnvironmentsClientGetPrivateEndpointConnectionListResponse contains the response from method EnvironmentsClient.GetPrivateEndpointConnectionList.
type EnvironmentsClientGetPrivateEndpointConnectionListResponse struct {
	PrivateEndpointConnectionCollection
}

// EnvironmentsClientGetPrivateEndpointConnectionResponse contains the response from method EnvironmentsClient.GetPrivateEndpointConnection.
type EnvironmentsClientGetPrivateEndpointConnectionResponse struct {
	RemotePrivateEndpointConnectionARMResource
}

// EnvironmentsClientGetPrivateLinkResourcesResponse contains the response from method EnvironmentsClient.GetPrivateLinkResources.
type EnvironmentsClientGetPrivateLinkResourcesResponse struct {
	PrivateLinkResourcesWrapper
}

// EnvironmentsClientGetResponse contains the response from method EnvironmentsClient.Get.
type EnvironmentsClientGetResponse struct {
	EnvironmentResource
}

// EnvironmentsClientGetVipInfoResponse contains the response from method EnvironmentsClient.GetVipInfo.
type EnvironmentsClientGetVipInfoResponse struct {
	AddressResponse
}

// EnvironmentsClientGetWorkerPoolResponse contains the response from method EnvironmentsClient.GetWorkerPool.
type EnvironmentsClientGetWorkerPoolResponse struct {
	WorkerPoolResource
}

// EnvironmentsClientListAppServicePlansResponse contains the response from method EnvironmentsClient.ListAppServicePlans.
type EnvironmentsClientListAppServicePlansResponse struct {
	PlanCollection
}

// EnvironmentsClientListByResourceGroupResponse contains the response from method EnvironmentsClient.ListByResourceGroup.
type EnvironmentsClientListByResourceGroupResponse struct {
	EnvironmentCollection
}

// EnvironmentsClientListCapacitiesResponse contains the response from method EnvironmentsClient.ListCapacities.
type EnvironmentsClientListCapacitiesResponse struct {
	StampCapacityCollection
}

// EnvironmentsClientListDiagnosticsResponse contains the response from method EnvironmentsClient.ListDiagnostics.
type EnvironmentsClientListDiagnosticsResponse struct {
	// Array of HostingEnvironmentDiagnostics
	HostingEnvironmentDiagnosticsArray []*HostingEnvironmentDiagnostics
}

// EnvironmentsClientListMultiRoleMetricDefinitionsResponse contains the response from method EnvironmentsClient.ListMultiRoleMetricDefinitions.
type EnvironmentsClientListMultiRoleMetricDefinitionsResponse struct {
	ResourceMetricDefinitionCollection
}

// EnvironmentsClientListMultiRolePoolInstanceMetricDefinitionsResponse contains the response from method EnvironmentsClient.ListMultiRolePoolInstanceMetricDefinitions.
type EnvironmentsClientListMultiRolePoolInstanceMetricDefinitionsResponse struct {
	ResourceMetricDefinitionCollection
}

// EnvironmentsClientListMultiRolePoolSKUsResponse contains the response from method EnvironmentsClient.ListMultiRolePoolSKUs.
type EnvironmentsClientListMultiRolePoolSKUsResponse struct {
	SKUInfoCollection
}

// EnvironmentsClientListMultiRolePoolsResponse contains the response from method EnvironmentsClient.ListMultiRolePools.
type EnvironmentsClientListMultiRolePoolsResponse struct {
	WorkerPoolCollection
}

// EnvironmentsClientListMultiRoleUsagesResponse contains the response from method EnvironmentsClient.ListMultiRoleUsages.
type EnvironmentsClientListMultiRoleUsagesResponse struct {
	UsageCollection
}

// EnvironmentsClientListOperationsResponse contains the response from method EnvironmentsClient.ListOperations.
type EnvironmentsClientListOperationsResponse struct {
	// Array of Operation
	OperationArray []*Operation
}

// EnvironmentsClientListResponse contains the response from method EnvironmentsClient.List.
type EnvironmentsClientListResponse struct {
	EnvironmentCollection
}

// EnvironmentsClientListUsagesResponse contains the response from method EnvironmentsClient.ListUsages.
type EnvironmentsClientListUsagesResponse struct {
	CsmUsageQuotaCollection
}

// EnvironmentsClientListWebAppsResponse contains the response from method EnvironmentsClient.ListWebApps.
type EnvironmentsClientListWebAppsResponse struct {
	WebAppCollection
}

// EnvironmentsClientListWebWorkerMetricDefinitionsResponse contains the response from method EnvironmentsClient.ListWebWorkerMetricDefinitions.
type EnvironmentsClientListWebWorkerMetricDefinitionsResponse struct {
	ResourceMetricDefinitionCollection
}

// EnvironmentsClientListWebWorkerUsagesResponse contains the response from method EnvironmentsClient.ListWebWorkerUsages.
type EnvironmentsClientListWebWorkerUsagesResponse struct {
	UsageCollection
}

// EnvironmentsClientListWorkerPoolInstanceMetricDefinitionsResponse contains the response from method EnvironmentsClient.ListWorkerPoolInstanceMetricDefinitions.
type EnvironmentsClientListWorkerPoolInstanceMetricDefinitionsResponse struct {
	ResourceMetricDefinitionCollection
}

// EnvironmentsClientListWorkerPoolSKUsResponse contains the response from method EnvironmentsClient.ListWorkerPoolSKUs.
type EnvironmentsClientListWorkerPoolSKUsResponse struct {
	SKUInfoCollection
}

// EnvironmentsClientListWorkerPoolsResponse contains the response from method EnvironmentsClient.ListWorkerPools.
type EnvironmentsClientListWorkerPoolsResponse struct {
	WorkerPoolCollection
}

// EnvironmentsClientRebootResponse contains the response from method EnvironmentsClient.Reboot.
type EnvironmentsClientRebootResponse struct {
	// placeholder for future response values
}

// EnvironmentsClientResumeResponse contains the response from method EnvironmentsClient.Resume.
type EnvironmentsClientResumeResponse struct {
	WebAppCollection
}

// EnvironmentsClientSuspendResponse contains the response from method EnvironmentsClient.Suspend.
type EnvironmentsClientSuspendResponse struct {
	WebAppCollection
}

// EnvironmentsClientTestUpgradeAvailableNotificationResponse contains the response from method EnvironmentsClient.TestUpgradeAvailableNotification.
type EnvironmentsClientTestUpgradeAvailableNotificationResponse struct {
	// placeholder for future response values
}

// EnvironmentsClientUpdateAseCustomDNSSuffixConfigurationResponse contains the response from method EnvironmentsClient.UpdateAseCustomDNSSuffixConfiguration.
type EnvironmentsClientUpdateAseCustomDNSSuffixConfigurationResponse struct {
	CustomDNSSuffixConfiguration
}

// EnvironmentsClientUpdateAseNetworkingConfigurationResponse contains the response from method EnvironmentsClient.UpdateAseNetworkingConfiguration.
type EnvironmentsClientUpdateAseNetworkingConfigurationResponse struct {
	AseV3NetworkingConfiguration
}

// EnvironmentsClientUpdateMultiRolePoolResponse contains the response from method EnvironmentsClient.UpdateMultiRolePool.
type EnvironmentsClientUpdateMultiRolePoolResponse struct {
	WorkerPoolResource
}

// EnvironmentsClientUpdateResponse contains the response from method EnvironmentsClient.Update.
type EnvironmentsClientUpdateResponse struct {
	EnvironmentResource
}

// EnvironmentsClientUpdateWorkerPoolResponse contains the response from method EnvironmentsClient.UpdateWorkerPool.
type EnvironmentsClientUpdateWorkerPoolResponse struct {
	WorkerPoolResource
}

// EnvironmentsClientUpgradeResponse contains the response from method EnvironmentsClient.Upgrade.
type EnvironmentsClientUpgradeResponse struct {
	// placeholder for future response values
}

// GlobalClientGetDeletedWebAppResponse contains the response from method GlobalClient.GetDeletedWebApp.
type GlobalClientGetDeletedWebAppResponse struct {
	DeletedSite
}

// GlobalClientGetDeletedWebAppSnapshotsResponse contains the response from method GlobalClient.GetDeletedWebAppSnapshots.
type GlobalClientGetDeletedWebAppSnapshotsResponse struct {
	// Array of Snapshot
	SnapshotArray []*Snapshot
}

// GlobalClientGetSubscriptionOperationWithAsyncResponseResponse contains the response from method GlobalClient.GetSubscriptionOperationWithAsyncResponse.
type GlobalClientGetSubscriptionOperationWithAsyncResponseResponse struct {
	// placeholder for future response values
}

// KubeEnvironmentsClientCreateOrUpdateResponse contains the response from method KubeEnvironmentsClient.CreateOrUpdate.
type KubeEnvironmentsClientCreateOrUpdateResponse struct {
	KubeEnvironment
}

// KubeEnvironmentsClientDeleteResponse contains the response from method KubeEnvironmentsClient.Delete.
type KubeEnvironmentsClientDeleteResponse struct {
	// placeholder for future response values
}

// KubeEnvironmentsClientGetResponse contains the response from method KubeEnvironmentsClient.Get.
type KubeEnvironmentsClientGetResponse struct {
	KubeEnvironment
}

// KubeEnvironmentsClientListByResourceGroupResponse contains the response from method KubeEnvironmentsClient.ListByResourceGroup.
type KubeEnvironmentsClientListByResourceGroupResponse struct {
	KubeEnvironmentCollection
}

// KubeEnvironmentsClientListBySubscriptionResponse contains the response from method KubeEnvironmentsClient.ListBySubscription.
type KubeEnvironmentsClientListBySubscriptionResponse struct {
	KubeEnvironmentCollection
}

// KubeEnvironmentsClientUpdateResponse contains the response from method KubeEnvironmentsClient.Update.
type KubeEnvironmentsClientUpdateResponse struct {
	KubeEnvironment
}

// PlansClientCreateOrUpdateResponse contains the response from method PlansClient.CreateOrUpdate.
type PlansClientCreateOrUpdateResponse struct {
	Plan
}

// PlansClientCreateOrUpdateVnetRouteResponse contains the response from method PlansClient.CreateOrUpdateVnetRoute.
type PlansClientCreateOrUpdateVnetRouteResponse struct {
	VnetRoute
}

// PlansClientDeleteHybridConnectionResponse contains the response from method PlansClient.DeleteHybridConnection.
type PlansClientDeleteHybridConnectionResponse struct {
	// placeholder for future response values
}

// PlansClientDeleteResponse contains the response from method PlansClient.Delete.
type PlansClientDeleteResponse struct {
	// placeholder for future response values
}

// PlansClientDeleteVnetRouteResponse contains the response from method PlansClient.DeleteVnetRoute.
type PlansClientDeleteVnetRouteResponse struct {
	// placeholder for future response values
}

// PlansClientGetHybridConnectionPlanLimitResponse contains the response from method PlansClient.GetHybridConnectionPlanLimit.
type PlansClientGetHybridConnectionPlanLimitResponse struct {
	HybridConnectionLimits
}

// PlansClientGetHybridConnectionResponse contains the response from method PlansClient.GetHybridConnection.
type PlansClientGetHybridConnectionResponse struct {
	HybridConnection
}

// PlansClientGetResponse contains the response from method PlansClient.Get.
type PlansClientGetResponse struct {
	Plan
}

// PlansClientGetRouteForVnetResponse contains the response from method PlansClient.GetRouteForVnet.
type PlansClientGetRouteForVnetResponse struct {
	// Array of VnetRoute
	VnetRouteArray []*VnetRoute
}

// PlansClientGetServerFarmSKUsResponse contains the response from method PlansClient.GetServerFarmSKUs.
type PlansClientGetServerFarmSKUsResponse struct {
	// Anything
	Interface interface{}
}

// PlansClientGetVnetFromServerFarmResponse contains the response from method PlansClient.GetVnetFromServerFarm.
type PlansClientGetVnetFromServerFarmResponse struct {
	VnetInfoResource
}

// PlansClientGetVnetGatewayResponse contains the response from method PlansClient.GetVnetGateway.
type PlansClientGetVnetGatewayResponse struct {
	VnetGateway
}

// PlansClientListByResourceGroupResponse contains the response from method PlansClient.ListByResourceGroup.
type PlansClientListByResourceGroupResponse struct {
	PlanCollection
}

// PlansClientListCapabilitiesResponse contains the response from method PlansClient.ListCapabilities.
type PlansClientListCapabilitiesResponse struct {
	// Array of Capability
	CapabilityArray []*Capability
}

// PlansClientListHybridConnectionKeysResponse contains the response from method PlansClient.ListHybridConnectionKeys.
type PlansClientListHybridConnectionKeysResponse struct {
	HybridConnectionKey
}

// PlansClientListHybridConnectionsResponse contains the response from method PlansClient.ListHybridConnections.
type PlansClientListHybridConnectionsResponse struct {
	HybridConnectionCollection
}

// PlansClientListResponse contains the response from method PlansClient.List.
type PlansClientListResponse struct {
	PlanCollection
}

// PlansClientListRoutesForVnetResponse contains the response from method PlansClient.ListRoutesForVnet.
type PlansClientListRoutesForVnetResponse struct {
	// Array of VnetRoute
	VnetRouteArray []*VnetRoute
}

// PlansClientListUsagesResponse contains the response from method PlansClient.ListUsages.
type PlansClientListUsagesResponse struct {
	CsmUsageQuotaCollection
}

// PlansClientListVnetsResponse contains the response from method PlansClient.ListVnets.
type PlansClientListVnetsResponse struct {
	// Array of VnetInfoResource
	VnetInfoResourceArray []*VnetInfoResource
}

// PlansClientListWebAppsByHybridConnectionResponse contains the response from method PlansClient.ListWebAppsByHybridConnection.
type PlansClientListWebAppsByHybridConnectionResponse struct {
	ResourceCollection
}

// PlansClientListWebAppsResponse contains the response from method PlansClient.ListWebApps.
type PlansClientListWebAppsResponse struct {
	WebAppCollection
}

// PlansClientRebootWorkerResponse contains the response from method PlansClient.RebootWorker.
type PlansClientRebootWorkerResponse struct {
	// placeholder for future response values
}

// PlansClientRestartWebAppsResponse contains the response from method PlansClient.RestartWebApps.
type PlansClientRestartWebAppsResponse struct {
	// placeholder for future response values
}

// PlansClientUpdateResponse contains the response from method PlansClient.Update.
type PlansClientUpdateResponse struct {
	Plan
}

// PlansClientUpdateVnetGatewayResponse contains the response from method PlansClient.UpdateVnetGateway.
type PlansClientUpdateVnetGatewayResponse struct {
	VnetGateway
}

// PlansClientUpdateVnetRouteResponse contains the response from method PlansClient.UpdateVnetRoute.
type PlansClientUpdateVnetRouteResponse struct {
	VnetRoute
}

// ProviderClientGetAvailableStacksOnPremResponse contains the response from method ProviderClient.GetAvailableStacksOnPrem.
type ProviderClientGetAvailableStacksOnPremResponse struct {
	ApplicationStackCollection
}

// ProviderClientGetAvailableStacksResponse contains the response from method ProviderClient.GetAvailableStacks.
type ProviderClientGetAvailableStacksResponse struct {
	ApplicationStackCollection
}

// ProviderClientGetFunctionAppStacksForLocationResponse contains the response from method ProviderClient.GetFunctionAppStacksForLocation.
type ProviderClientGetFunctionAppStacksForLocationResponse struct {
	FunctionAppStackCollection
}

// ProviderClientGetFunctionAppStacksResponse contains the response from method ProviderClient.GetFunctionAppStacks.
type ProviderClientGetFunctionAppStacksResponse struct {
	FunctionAppStackCollection
}

// ProviderClientGetWebAppStacksForLocationResponse contains the response from method ProviderClient.GetWebAppStacksForLocation.
type ProviderClientGetWebAppStacksForLocationResponse struct {
	WebAppStackCollection
}

// ProviderClientGetWebAppStacksResponse contains the response from method ProviderClient.GetWebAppStacks.
type ProviderClientGetWebAppStacksResponse struct {
	WebAppStackCollection
}

// ProviderClientListOperationsResponse contains the response from method ProviderClient.ListOperations.
type ProviderClientListOperationsResponse struct {
	CsmOperationCollection
}

// RecommendationsClientDisableAllForHostingEnvironmentResponse contains the response from method RecommendationsClient.DisableAllForHostingEnvironment.
type RecommendationsClientDisableAllForHostingEnvironmentResponse struct {
	// placeholder for future response values
}

// RecommendationsClientDisableAllForWebAppResponse contains the response from method RecommendationsClient.DisableAllForWebApp.
type RecommendationsClientDisableAllForWebAppResponse struct {
	// placeholder for future response values
}

// RecommendationsClientDisableRecommendationForHostingEnvironmentResponse contains the response from method RecommendationsClient.DisableRecommendationForHostingEnvironment.
type RecommendationsClientDisableRecommendationForHostingEnvironmentResponse struct {
	// placeholder for future response values
}

// RecommendationsClientDisableRecommendationForSiteResponse contains the response from method RecommendationsClient.DisableRecommendationForSite.
type RecommendationsClientDisableRecommendationForSiteResponse struct {
	// placeholder for future response values
}

// RecommendationsClientDisableRecommendationForSubscriptionResponse contains the response from method RecommendationsClient.DisableRecommendationForSubscription.
type RecommendationsClientDisableRecommendationForSubscriptionResponse struct {
	// placeholder for future response values
}

// RecommendationsClientGetRuleDetailsByHostingEnvironmentResponse contains the response from method RecommendationsClient.GetRuleDetailsByHostingEnvironment.
type RecommendationsClientGetRuleDetailsByHostingEnvironmentResponse struct {
	RecommendationRule
}

// RecommendationsClientGetRuleDetailsByWebAppResponse contains the response from method RecommendationsClient.GetRuleDetailsByWebApp.
type RecommendationsClientGetRuleDetailsByWebAppResponse struct {
	RecommendationRule
}

// RecommendationsClientListHistoryForHostingEnvironmentResponse contains the response from method RecommendationsClient.ListHistoryForHostingEnvironment.
type RecommendationsClientListHistoryForHostingEnvironmentResponse struct {
	RecommendationCollection
}

// RecommendationsClientListHistoryForWebAppResponse contains the response from method RecommendationsClient.ListHistoryForWebApp.
type RecommendationsClientListHistoryForWebAppResponse struct {
	RecommendationCollection
}

// RecommendationsClientListRecommendedRulesForHostingEnvironmentResponse contains the response from method RecommendationsClient.ListRecommendedRulesForHostingEnvironment.
type RecommendationsClientListRecommendedRulesForHostingEnvironmentResponse struct {
	RecommendationCollection
}

// RecommendationsClientListRecommendedRulesForWebAppResponse contains the response from method RecommendationsClient.ListRecommendedRulesForWebApp.
type RecommendationsClientListRecommendedRulesForWebAppResponse struct {
	RecommendationCollection
}

// RecommendationsClientListResponse contains the response from method RecommendationsClient.List.
type RecommendationsClientListResponse struct {
	RecommendationCollection
}

// RecommendationsClientResetAllFiltersForHostingEnvironmentResponse contains the response from method RecommendationsClient.ResetAllFiltersForHostingEnvironment.
type RecommendationsClientResetAllFiltersForHostingEnvironmentResponse struct {
	// placeholder for future response values
}

// RecommendationsClientResetAllFiltersForWebAppResponse contains the response from method RecommendationsClient.ResetAllFiltersForWebApp.
type RecommendationsClientResetAllFiltersForWebAppResponse struct {
	// placeholder for future response values
}

// RecommendationsClientResetAllFiltersResponse contains the response from method RecommendationsClient.ResetAllFilters.
type RecommendationsClientResetAllFiltersResponse struct {
	// placeholder for future response values
}

// ResourceHealthMetadataClientGetBySiteResponse contains the response from method ResourceHealthMetadataClient.GetBySite.
type ResourceHealthMetadataClientGetBySiteResponse struct {
	ResourceHealthMetadata
}

// ResourceHealthMetadataClientGetBySiteSlotResponse contains the response from method ResourceHealthMetadataClient.GetBySiteSlot.
type ResourceHealthMetadataClientGetBySiteSlotResponse struct {
	ResourceHealthMetadata
}

// ResourceHealthMetadataClientListByResourceGroupResponse contains the response from method ResourceHealthMetadataClient.ListByResourceGroup.
type ResourceHealthMetadataClientListByResourceGroupResponse struct {
	ResourceHealthMetadataCollection
}

// ResourceHealthMetadataClientListBySiteResponse contains the response from method ResourceHealthMetadataClient.ListBySite.
type ResourceHealthMetadataClientListBySiteResponse struct {
	ResourceHealthMetadataCollection
}

// ResourceHealthMetadataClientListBySiteSlotResponse contains the response from method ResourceHealthMetadataClient.ListBySiteSlot.
type ResourceHealthMetadataClientListBySiteSlotResponse struct {
	ResourceHealthMetadataCollection
}

// ResourceHealthMetadataClientListResponse contains the response from method ResourceHealthMetadataClient.List.
type ResourceHealthMetadataClientListResponse struct {
	ResourceHealthMetadataCollection
}

// StaticSitesClientApproveOrRejectPrivateEndpointConnectionResponse contains the response from method StaticSitesClient.ApproveOrRejectPrivateEndpointConnection.
type StaticSitesClientApproveOrRejectPrivateEndpointConnectionResponse struct {
	RemotePrivateEndpointConnectionARMResource
}

// StaticSitesClientCreateOrUpdateStaticSiteAppSettingsResponse contains the response from method StaticSitesClient.CreateOrUpdateStaticSiteAppSettings.
type StaticSitesClientCreateOrUpdateStaticSiteAppSettingsResponse struct {
	StringDictionary
}

// StaticSitesClientCreateOrUpdateStaticSiteBuildAppSettingsResponse contains the response from method StaticSitesClient.CreateOrUpdateStaticSiteBuildAppSettings.
type StaticSitesClientCreateOrUpdateStaticSiteBuildAppSettingsResponse struct {
	StringDictionary
}

// StaticSitesClientCreateOrUpdateStaticSiteBuildFunctionAppSettingsResponse contains the response from method StaticSitesClient.CreateOrUpdateStaticSiteBuildFunctionAppSettings.
type StaticSitesClientCreateOrUpdateStaticSiteBuildFunctionAppSettingsResponse struct {
	StringDictionary
}

// StaticSitesClientCreateOrUpdateStaticSiteCustomDomainResponse contains the response from method StaticSitesClient.CreateOrUpdateStaticSiteCustomDomain.
type StaticSitesClientCreateOrUpdateStaticSiteCustomDomainResponse struct {
	StaticSiteCustomDomainOverviewARMResource
}

// StaticSitesClientCreateOrUpdateStaticSiteFunctionAppSettingsResponse contains the response from method StaticSitesClient.CreateOrUpdateStaticSiteFunctionAppSettings.
type StaticSitesClientCreateOrUpdateStaticSiteFunctionAppSettingsResponse struct {
	StringDictionary
}

// StaticSitesClientCreateOrUpdateStaticSiteResponse contains the response from method StaticSitesClient.CreateOrUpdateStaticSite.
type StaticSitesClientCreateOrUpdateStaticSiteResponse struct {
	StaticSiteARMResource
}

// StaticSitesClientCreateUserRolesInvitationLinkResponse contains the response from method StaticSitesClient.CreateUserRolesInvitationLink.
type StaticSitesClientCreateUserRolesInvitationLinkResponse struct {
	StaticSiteUserInvitationResponseResource
}

// StaticSitesClientCreateZipDeploymentForStaticSiteBuildResponse contains the response from method StaticSitesClient.CreateZipDeploymentForStaticSiteBuild.
type StaticSitesClientCreateZipDeploymentForStaticSiteBuildResponse struct {
	// placeholder for future response values
}

// StaticSitesClientCreateZipDeploymentForStaticSiteResponse contains the response from method StaticSitesClient.CreateZipDeploymentForStaticSite.
type StaticSitesClientCreateZipDeploymentForStaticSiteResponse struct {
	// placeholder for future response values
}

// StaticSitesClientDeletePrivateEndpointConnectionResponse contains the response from method StaticSitesClient.DeletePrivateEndpointConnection.
type StaticSitesClientDeletePrivateEndpointConnectionResponse struct {
	// Anything
	Interface interface{}
}

// UnmarshalJSON implements the json.Unmarshaller interface for type StaticSitesClientDeletePrivateEndpointConnectionResponse.
func (s *StaticSitesClientDeletePrivateEndpointConnectionResponse) UnmarshalJSON(data []byte) error {
	return json.Unmarshal(data, &s.Interface)
}

// StaticSitesClientDeleteStaticSiteBuildResponse contains the response from method StaticSitesClient.DeleteStaticSiteBuild.
type StaticSitesClientDeleteStaticSiteBuildResponse struct {
	// placeholder for future response values
}

// StaticSitesClientDeleteStaticSiteCustomDomainResponse contains the response from method StaticSitesClient.DeleteStaticSiteCustomDomain.
type StaticSitesClientDeleteStaticSiteCustomDomainResponse struct {
	// placeholder for future response values
}

// StaticSitesClientDeleteStaticSiteResponse contains the response from method StaticSitesClient.DeleteStaticSite.
type StaticSitesClientDeleteStaticSiteResponse struct {
	// placeholder for future response values
}

// StaticSitesClientDeleteStaticSiteUserResponse contains the response from method StaticSitesClient.DeleteStaticSiteUser.
type StaticSitesClientDeleteStaticSiteUserResponse struct {
	// placeholder for future response values
}

// StaticSitesClientDetachStaticSiteResponse contains the response from method StaticSitesClient.DetachStaticSite.
type StaticSitesClientDetachStaticSiteResponse struct {
	// placeholder for future response values
}

// StaticSitesClientDetachUserProvidedFunctionAppFromStaticSiteBuildResponse contains the response from method StaticSitesClient.DetachUserProvidedFunctionAppFromStaticSiteBuild.
type StaticSitesClientDetachUserProvidedFunctionAppFromStaticSiteBuildResponse struct {
	// placeholder for future response values
}

// StaticSitesClientDetachUserProvidedFunctionAppFromStaticSiteResponse contains the response from method StaticSitesClient.DetachUserProvidedFunctionAppFromStaticSite.
type StaticSitesClientDetachUserProvidedFunctionAppFromStaticSiteResponse struct {
	// placeholder for future response values
}

// StaticSitesClientGetLinkedBackendForBuildResponse contains the response from method StaticSitesClient.GetLinkedBackendForBuild.
type StaticSitesClientGetLinkedBackendForBuildResponse struct {
	StaticSiteLinkedBackendARMResource
}

// StaticSitesClientGetLinkedBackendResponse contains the response from method StaticSitesClient.GetLinkedBackend.
type StaticSitesClientGetLinkedBackendResponse struct {
	StaticSiteLinkedBackendARMResource
}

// StaticSitesClientGetLinkedBackendsForBuildResponse contains the response from method StaticSitesClient.GetLinkedBackendsForBuild.
type StaticSitesClientGetLinkedBackendsForBuildResponse struct {
	StaticSiteLinkedBackendsCollection
}

// StaticSitesClientGetLinkedBackendsResponse contains the response from method StaticSitesClient.GetLinkedBackends.
type StaticSitesClientGetLinkedBackendsResponse struct {
	StaticSiteLinkedBackendsCollection
}

// StaticSitesClientGetPrivateEndpointConnectionListResponse contains the response from method StaticSitesClient.GetPrivateEndpointConnectionList.
type StaticSitesClientGetPrivateEndpointConnectionListResponse struct {
	PrivateEndpointConnectionCollection
}

// StaticSitesClientGetPrivateEndpointConnectionResponse contains the response from method StaticSitesClient.GetPrivateEndpointConnection.
type StaticSitesClientGetPrivateEndpointConnectionResponse struct {
	RemotePrivateEndpointConnectionARMResource
}

// StaticSitesClientGetPrivateLinkResourcesResponse contains the response from method StaticSitesClient.GetPrivateLinkResources.
type StaticSitesClientGetPrivateLinkResourcesResponse struct {
	PrivateLinkResourcesWrapper
}

// StaticSitesClientGetStaticSiteBuildResponse contains the response from method StaticSitesClient.GetStaticSiteBuild.
type StaticSitesClientGetStaticSiteBuildResponse struct {
	StaticSiteBuildARMResource
}

// StaticSitesClientGetStaticSiteBuildsResponse contains the response from method StaticSitesClient.GetStaticSiteBuilds.
type StaticSitesClientGetStaticSiteBuildsResponse struct {
	StaticSiteBuildCollection
}

// StaticSitesClientGetStaticSiteCustomDomainResponse contains the response from method StaticSitesClient.GetStaticSiteCustomDomain.
type StaticSitesClientGetStaticSiteCustomDomainResponse struct {
	StaticSiteCustomDomainOverviewARMResource
}

// StaticSitesClientGetStaticSiteResponse contains the response from method StaticSitesClient.GetStaticSite.
type StaticSitesClientGetStaticSiteResponse struct {
	StaticSiteARMResource
}

// StaticSitesClientGetStaticSitesByResourceGroupResponse contains the response from method StaticSitesClient.GetStaticSitesByResourceGroup.
type StaticSitesClientGetStaticSitesByResourceGroupResponse struct {
	StaticSiteCollection
}

// StaticSitesClientGetUserProvidedFunctionAppForStaticSiteBuildResponse contains the response from method StaticSitesClient.GetUserProvidedFunctionAppForStaticSiteBuild.
type StaticSitesClientGetUserProvidedFunctionAppForStaticSiteBuildResponse struct {
	StaticSiteUserProvidedFunctionAppARMResource
}

// StaticSitesClientGetUserProvidedFunctionAppForStaticSiteResponse contains the response from method StaticSitesClient.GetUserProvidedFunctionAppForStaticSite.
type StaticSitesClientGetUserProvidedFunctionAppForStaticSiteResponse struct {
	StaticSiteUserProvidedFunctionAppARMResource
}

// StaticSitesClientGetUserProvidedFunctionAppsForStaticSiteBuildResponse contains the response from method StaticSitesClient.GetUserProvidedFunctionAppsForStaticSiteBuild.
type StaticSitesClientGetUserProvidedFunctionAppsForStaticSiteBuildResponse struct {
	StaticSiteUserProvidedFunctionAppsCollection
}

// StaticSitesClientGetUserProvidedFunctionAppsForStaticSiteResponse contains the response from method StaticSitesClient.GetUserProvidedFunctionAppsForStaticSite.
type StaticSitesClientGetUserProvidedFunctionAppsForStaticSiteResponse struct {
	StaticSiteUserProvidedFunctionAppsCollection
}

// StaticSitesClientLinkBackendResponse contains the response from method StaticSitesClient.LinkBackend.
type StaticSitesClientLinkBackendResponse struct {
	StaticSiteLinkedBackendARMResource
}

// StaticSitesClientLinkBackendToBuildResponse contains the response from method StaticSitesClient.LinkBackendToBuild.
type StaticSitesClientLinkBackendToBuildResponse struct {
	StaticSiteLinkedBackendARMResource
}

// StaticSitesClientListResponse contains the response from method StaticSitesClient.List.
type StaticSitesClientListResponse struct {
	StaticSiteCollection
}

// StaticSitesClientListStaticSiteAppSettingsResponse contains the response from method StaticSitesClient.ListStaticSiteAppSettings.
type StaticSitesClientListStaticSiteAppSettingsResponse struct {
	StringDictionary
}

// StaticSitesClientListStaticSiteBuildAppSettingsResponse contains the response from method StaticSitesClient.ListStaticSiteBuildAppSettings.
type StaticSitesClientListStaticSiteBuildAppSettingsResponse struct {
	StringDictionary
}

// StaticSitesClientListStaticSiteBuildFunctionAppSettingsResponse contains the response from method StaticSitesClient.ListStaticSiteBuildFunctionAppSettings.
type StaticSitesClientListStaticSiteBuildFunctionAppSettingsResponse struct {
	StringDictionary
}

// StaticSitesClientListStaticSiteBuildFunctionsResponse contains the response from method StaticSitesClient.ListStaticSiteBuildFunctions.
type StaticSitesClientListStaticSiteBuildFunctionsResponse struct {
	StaticSiteFunctionOverviewCollection
}

// StaticSitesClientListStaticSiteConfiguredRolesResponse contains the response from method StaticSitesClient.ListStaticSiteConfiguredRoles.
type StaticSitesClientListStaticSiteConfiguredRolesResponse struct {
	StringList
}

// StaticSitesClientListStaticSiteCustomDomainsResponse contains the response from method StaticSitesClient.ListStaticSiteCustomDomains.
type StaticSitesClientListStaticSiteCustomDomainsResponse struct {
	StaticSiteCustomDomainOverviewCollection
}

// StaticSitesClientListStaticSiteFunctionAppSettingsResponse contains the response from method StaticSitesClient.ListStaticSiteFunctionAppSettings.
type StaticSitesClientListStaticSiteFunctionAppSettingsResponse struct {
	StringDictionary
}

// StaticSitesClientListStaticSiteFunctionsResponse contains the response from method StaticSitesClient.ListStaticSiteFunctions.
type StaticSitesClientListStaticSiteFunctionsResponse struct {
	StaticSiteFunctionOverviewCollection
}

// StaticSitesClientListStaticSiteSecretsResponse contains the response from method StaticSitesClient.ListStaticSiteSecrets.
type StaticSitesClientListStaticSiteSecretsResponse struct {
	StringDictionary
}

// StaticSitesClientListStaticSiteUsersResponse contains the response from method StaticSitesClient.ListStaticSiteUsers.
type StaticSitesClientListStaticSiteUsersResponse struct {
	StaticSiteUserCollection
}

// StaticSitesClientPreviewWorkflowResponse contains the response from method StaticSitesClient.PreviewWorkflow.
type StaticSitesClientPreviewWorkflowResponse struct {
	StaticSitesWorkflowPreview
}

// StaticSitesClientRegisterUserProvidedFunctionAppWithStaticSiteBuildResponse contains the response from method StaticSitesClient.RegisterUserProvidedFunctionAppWithStaticSiteBuild.
type StaticSitesClientRegisterUserProvidedFunctionAppWithStaticSiteBuildResponse struct {
	StaticSiteUserProvidedFunctionAppARMResource
}

// StaticSitesClientRegisterUserProvidedFunctionAppWithStaticSiteResponse contains the response from method StaticSitesClient.RegisterUserProvidedFunctionAppWithStaticSite.
type StaticSitesClientRegisterUserProvidedFunctionAppWithStaticSiteResponse struct {
	StaticSiteUserProvidedFunctionAppARMResource
}

// StaticSitesClientResetStaticSiteAPIKeyResponse contains the response from method StaticSitesClient.ResetStaticSiteAPIKey.
type StaticSitesClientResetStaticSiteAPIKeyResponse struct {
	// placeholder for future response values
}

// StaticSitesClientUnlinkBackendFromBuildResponse contains the response from method StaticSitesClient.UnlinkBackendFromBuild.
type StaticSitesClientUnlinkBackendFromBuildResponse struct {
	// placeholder for future response values
}

// StaticSitesClientUnlinkBackendResponse contains the response from method StaticSitesClient.UnlinkBackend.
type StaticSitesClientUnlinkBackendResponse struct {
	// placeholder for future response values
}

// StaticSitesClientUpdateStaticSiteResponse contains the response from method StaticSitesClient.UpdateStaticSite.
type StaticSitesClientUpdateStaticSiteResponse struct {
	StaticSiteARMResource
}

// StaticSitesClientUpdateStaticSiteUserResponse contains the response from method StaticSitesClient.UpdateStaticSiteUser.
type StaticSitesClientUpdateStaticSiteUserResponse struct {
	StaticSiteUserARMResource
}

// StaticSitesClientValidateBackendForBuildResponse contains the response from method StaticSitesClient.ValidateBackendForBuild.
type StaticSitesClientValidateBackendForBuildResponse struct {
	// placeholder for future response values
}

// StaticSitesClientValidateBackendResponse contains the response from method StaticSitesClient.ValidateBackend.
type StaticSitesClientValidateBackendResponse struct {
	// placeholder for future response values
}

// StaticSitesClientValidateCustomDomainCanBeAddedToStaticSiteResponse contains the response from method StaticSitesClient.ValidateCustomDomainCanBeAddedToStaticSite.
type StaticSitesClientValidateCustomDomainCanBeAddedToStaticSiteResponse struct {
	// placeholder for future response values
}

// TopLevelDomainsClientGetResponse contains the response from method TopLevelDomainsClient.Get.
type TopLevelDomainsClientGetResponse struct {
	TopLevelDomain
}

// TopLevelDomainsClientListAgreementsResponse contains the response from method TopLevelDomainsClient.ListAgreements.
type TopLevelDomainsClientListAgreementsResponse struct {
	TldLegalAgreementCollection
}

// TopLevelDomainsClientListResponse contains the response from method TopLevelDomainsClient.List.
type TopLevelDomainsClientListResponse struct {
	TopLevelDomainCollection
}

// WebAppsClientAddPremierAddOnResponse contains the response from method WebAppsClient.AddPremierAddOn.
type WebAppsClientAddPremierAddOnResponse struct {
	PremierAddOn
}

// WebAppsClientAddPremierAddOnSlotResponse contains the response from method WebAppsClient.AddPremierAddOnSlot.
type WebAppsClientAddPremierAddOnSlotResponse struct {
	PremierAddOn
}

// WebAppsClientAnalyzeCustomHostnameResponse contains the response from method WebAppsClient.AnalyzeCustomHostname.
type WebAppsClientAnalyzeCustomHostnameResponse struct {
	CustomHostnameAnalysisResult
}

// WebAppsClientAnalyzeCustomHostnameSlotResponse contains the response from method WebAppsClient.AnalyzeCustomHostnameSlot.
type WebAppsClientAnalyzeCustomHostnameSlotResponse struct {
	CustomHostnameAnalysisResult
}

// WebAppsClientApplySlotConfigToProductionResponse contains the response from method WebAppsClient.ApplySlotConfigToProduction.
type WebAppsClientApplySlotConfigToProductionResponse struct {
	// placeholder for future response values
}

// WebAppsClientApplySlotConfigurationSlotResponse contains the response from method WebAppsClient.ApplySlotConfigurationSlot.
type WebAppsClientApplySlotConfigurationSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientApproveOrRejectPrivateEndpointConnectionResponse contains the response from method WebAppsClient.ApproveOrRejectPrivateEndpointConnection.
type WebAppsClientApproveOrRejectPrivateEndpointConnectionResponse struct {
	RemotePrivateEndpointConnectionARMResource
}

// WebAppsClientApproveOrRejectPrivateEndpointConnectionSlotResponse contains the response from method WebAppsClient.ApproveOrRejectPrivateEndpointConnectionSlot.
type WebAppsClientApproveOrRejectPrivateEndpointConnectionSlotResponse struct {
	RemotePrivateEndpointConnectionARMResource
}

// WebAppsClientBackupResponse contains the response from method WebAppsClient.Backup.
type WebAppsClientBackupResponse struct {
	BackupItem
}

// WebAppsClientBackupSlotResponse contains the response from method WebAppsClient.BackupSlot.
type WebAppsClientBackupSlotResponse struct {
	BackupItem
}

// WebAppsClientCreateDeploymentResponse contains the response from method WebAppsClient.CreateDeployment.
type WebAppsClientCreateDeploymentResponse struct {
	Deployment
}

// WebAppsClientCreateDeploymentSlotResponse contains the response from method WebAppsClient.CreateDeploymentSlot.
type WebAppsClientCreateDeploymentSlotResponse struct {
	Deployment
}

// WebAppsClientCreateFunctionResponse contains the response from method WebAppsClient.CreateFunction.
type WebAppsClientCreateFunctionResponse struct {
	FunctionEnvelope
}

// WebAppsClientCreateInstanceFunctionSlotResponse contains the response from method WebAppsClient.CreateInstanceFunctionSlot.
type WebAppsClientCreateInstanceFunctionSlotResponse struct {
	FunctionEnvelope
}

// WebAppsClientCreateInstanceMSDeployOperationResponse contains the response from method WebAppsClient.CreateInstanceMSDeployOperation.
type WebAppsClientCreateInstanceMSDeployOperationResponse struct {
	MSDeployStatus
}

// WebAppsClientCreateInstanceMSDeployOperationSlotResponse contains the response from method WebAppsClient.CreateInstanceMSDeployOperationSlot.
type WebAppsClientCreateInstanceMSDeployOperationSlotResponse struct {
	MSDeployStatus
}

// WebAppsClientCreateMSDeployOperationResponse contains the response from method WebAppsClient.CreateMSDeployOperation.
type WebAppsClientCreateMSDeployOperationResponse struct {
	MSDeployStatus
}

// WebAppsClientCreateMSDeployOperationSlotResponse contains the response from method WebAppsClient.CreateMSDeployOperationSlot.
type WebAppsClientCreateMSDeployOperationSlotResponse struct {
	MSDeployStatus
}

// WebAppsClientCreateOneDeployOperationResponse contains the response from method WebAppsClient.CreateOneDeployOperation.
type WebAppsClientCreateOneDeployOperationResponse struct {
	// Anything
	Interface interface{}
}

// WebAppsClientCreateOrUpdateConfigurationResponse contains the response from method WebAppsClient.CreateOrUpdateConfiguration.
type WebAppsClientCreateOrUpdateConfigurationResponse struct {
	SiteConfigResource
}

// WebAppsClientCreateOrUpdateConfigurationSlotResponse contains the response from method WebAppsClient.CreateOrUpdateConfigurationSlot.
type WebAppsClientCreateOrUpdateConfigurationSlotResponse struct {
	SiteConfigResource
}

// WebAppsClientCreateOrUpdateDomainOwnershipIdentifierResponse contains the response from method WebAppsClient.CreateOrUpdateDomainOwnershipIdentifier.
type WebAppsClientCreateOrUpdateDomainOwnershipIdentifierResponse struct {
	Identifier
}

// WebAppsClientCreateOrUpdateDomainOwnershipIdentifierSlotResponse contains the response from method WebAppsClient.CreateOrUpdateDomainOwnershipIdentifierSlot.
type WebAppsClientCreateOrUpdateDomainOwnershipIdentifierSlotResponse struct {
	Identifier
}

// WebAppsClientCreateOrUpdateFunctionSecretResponse contains the response from method WebAppsClient.CreateOrUpdateFunctionSecret.
type WebAppsClientCreateOrUpdateFunctionSecretResponse struct {
	KeyInfo
}

// WebAppsClientCreateOrUpdateFunctionSecretSlotResponse contains the response from method WebAppsClient.CreateOrUpdateFunctionSecretSlot.
type WebAppsClientCreateOrUpdateFunctionSecretSlotResponse struct {
	KeyInfo
}

// WebAppsClientCreateOrUpdateHostNameBindingResponse contains the response from method WebAppsClient.CreateOrUpdateHostNameBinding.
type WebAppsClientCreateOrUpdateHostNameBindingResponse struct {
	HostNameBinding
}

// WebAppsClientCreateOrUpdateHostNameBindingSlotResponse contains the response from method WebAppsClient.CreateOrUpdateHostNameBindingSlot.
type WebAppsClientCreateOrUpdateHostNameBindingSlotResponse struct {
	HostNameBinding
}

// WebAppsClientCreateOrUpdateHostSecretResponse contains the response from method WebAppsClient.CreateOrUpdateHostSecret.
type WebAppsClientCreateOrUpdateHostSecretResponse struct {
	KeyInfo
}

// WebAppsClientCreateOrUpdateHostSecretSlotResponse contains the response from method WebAppsClient.CreateOrUpdateHostSecretSlot.
type WebAppsClientCreateOrUpdateHostSecretSlotResponse struct {
	KeyInfo
}

// WebAppsClientCreateOrUpdateHybridConnectionResponse contains the response from method WebAppsClient.CreateOrUpdateHybridConnection.
type WebAppsClientCreateOrUpdateHybridConnectionResponse struct {
	HybridConnection
}

// WebAppsClientCreateOrUpdateHybridConnectionSlotResponse contains the response from method WebAppsClient.CreateOrUpdateHybridConnectionSlot.
type WebAppsClientCreateOrUpdateHybridConnectionSlotResponse struct {
	HybridConnection
}

// WebAppsClientCreateOrUpdatePublicCertificateResponse contains the response from method WebAppsClient.CreateOrUpdatePublicCertificate.
type WebAppsClientCreateOrUpdatePublicCertificateResponse struct {
	PublicCertificate
}

// WebAppsClientCreateOrUpdatePublicCertificateSlotResponse contains the response from method WebAppsClient.CreateOrUpdatePublicCertificateSlot.
type WebAppsClientCreateOrUpdatePublicCertificateSlotResponse struct {
	PublicCertificate
}

// WebAppsClientCreateOrUpdateRelayServiceConnectionResponse contains the response from method WebAppsClient.CreateOrUpdateRelayServiceConnection.
type WebAppsClientCreateOrUpdateRelayServiceConnectionResponse struct {
	RelayServiceConnectionEntity
}

// WebAppsClientCreateOrUpdateRelayServiceConnectionSlotResponse contains the response from method WebAppsClient.CreateOrUpdateRelayServiceConnectionSlot.
type WebAppsClientCreateOrUpdateRelayServiceConnectionSlotResponse struct {
	RelayServiceConnectionEntity
}

// WebAppsClientCreateOrUpdateResponse contains the response from method WebAppsClient.CreateOrUpdate.
type WebAppsClientCreateOrUpdateResponse struct {
	Site
}

// WebAppsClientCreateOrUpdateSlotResponse contains the response from method WebAppsClient.CreateOrUpdateSlot.
type WebAppsClientCreateOrUpdateSlotResponse struct {
	Site
}

// WebAppsClientCreateOrUpdateSourceControlResponse contains the response from method WebAppsClient.CreateOrUpdateSourceControl.
type WebAppsClientCreateOrUpdateSourceControlResponse struct {
	SiteSourceControl
}

// WebAppsClientCreateOrUpdateSourceControlSlotResponse contains the response from method WebAppsClient.CreateOrUpdateSourceControlSlot.
type WebAppsClientCreateOrUpdateSourceControlSlotResponse struct {
	SiteSourceControl
}

// WebAppsClientCreateOrUpdateSwiftVirtualNetworkConnectionWithCheckResponse contains the response from method WebAppsClient.CreateOrUpdateSwiftVirtualNetworkConnectionWithCheck.
type WebAppsClientCreateOrUpdateSwiftVirtualNetworkConnectionWithCheckResponse struct {
	SwiftVirtualNetwork
}

// WebAppsClientCreateOrUpdateSwiftVirtualNetworkConnectionWithCheckSlotResponse contains the response from method WebAppsClient.CreateOrUpdateSwiftVirtualNetworkConnectionWithCheckSlot.
type WebAppsClientCreateOrUpdateSwiftVirtualNetworkConnectionWithCheckSlotResponse struct {
	SwiftVirtualNetwork
}

// WebAppsClientCreateOrUpdateVnetConnectionGatewayResponse contains the response from method WebAppsClient.CreateOrUpdateVnetConnectionGateway.
type WebAppsClientCreateOrUpdateVnetConnectionGatewayResponse struct {
	VnetGateway
}

// WebAppsClientCreateOrUpdateVnetConnectionGatewaySlotResponse contains the response from method WebAppsClient.CreateOrUpdateVnetConnectionGatewaySlot.
type WebAppsClientCreateOrUpdateVnetConnectionGatewaySlotResponse struct {
	VnetGateway
}

// WebAppsClientCreateOrUpdateVnetConnectionResponse contains the response from method WebAppsClient.CreateOrUpdateVnetConnection.
type WebAppsClientCreateOrUpdateVnetConnectionResponse struct {
	VnetInfoResource
}

// WebAppsClientCreateOrUpdateVnetConnectionSlotResponse contains the response from method WebAppsClient.CreateOrUpdateVnetConnectionSlot.
type WebAppsClientCreateOrUpdateVnetConnectionSlotResponse struct {
	VnetInfoResource
}

// WebAppsClientDeleteBackupConfigurationResponse contains the response from method WebAppsClient.DeleteBackupConfiguration.
type WebAppsClientDeleteBackupConfigurationResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteBackupConfigurationSlotResponse contains the response from method WebAppsClient.DeleteBackupConfigurationSlot.
type WebAppsClientDeleteBackupConfigurationSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteBackupResponse contains the response from method WebAppsClient.DeleteBackup.
type WebAppsClientDeleteBackupResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteBackupSlotResponse contains the response from method WebAppsClient.DeleteBackupSlot.
type WebAppsClientDeleteBackupSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteContinuousWebJobResponse contains the response from method WebAppsClient.DeleteContinuousWebJob.
type WebAppsClientDeleteContinuousWebJobResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteContinuousWebJobSlotResponse contains the response from method WebAppsClient.DeleteContinuousWebJobSlot.
type WebAppsClientDeleteContinuousWebJobSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteDeploymentResponse contains the response from method WebAppsClient.DeleteDeployment.
type WebAppsClientDeleteDeploymentResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteDeploymentSlotResponse contains the response from method WebAppsClient.DeleteDeploymentSlot.
type WebAppsClientDeleteDeploymentSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteDomainOwnershipIdentifierResponse contains the response from method WebAppsClient.DeleteDomainOwnershipIdentifier.
type WebAppsClientDeleteDomainOwnershipIdentifierResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteDomainOwnershipIdentifierSlotResponse contains the response from method WebAppsClient.DeleteDomainOwnershipIdentifierSlot.
type WebAppsClientDeleteDomainOwnershipIdentifierSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteFunctionResponse contains the response from method WebAppsClient.DeleteFunction.
type WebAppsClientDeleteFunctionResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteFunctionSecretResponse contains the response from method WebAppsClient.DeleteFunctionSecret.
type WebAppsClientDeleteFunctionSecretResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteFunctionSecretSlotResponse contains the response from method WebAppsClient.DeleteFunctionSecretSlot.
type WebAppsClientDeleteFunctionSecretSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteHostNameBindingResponse contains the response from method WebAppsClient.DeleteHostNameBinding.
type WebAppsClientDeleteHostNameBindingResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteHostNameBindingSlotResponse contains the response from method WebAppsClient.DeleteHostNameBindingSlot.
type WebAppsClientDeleteHostNameBindingSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteHostSecretResponse contains the response from method WebAppsClient.DeleteHostSecret.
type WebAppsClientDeleteHostSecretResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteHostSecretSlotResponse contains the response from method WebAppsClient.DeleteHostSecretSlot.
type WebAppsClientDeleteHostSecretSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteHybridConnectionResponse contains the response from method WebAppsClient.DeleteHybridConnection.
type WebAppsClientDeleteHybridConnectionResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteHybridConnectionSlotResponse contains the response from method WebAppsClient.DeleteHybridConnectionSlot.
type WebAppsClientDeleteHybridConnectionSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteInstanceFunctionSlotResponse contains the response from method WebAppsClient.DeleteInstanceFunctionSlot.
type WebAppsClientDeleteInstanceFunctionSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteInstanceProcessResponse contains the response from method WebAppsClient.DeleteInstanceProcess.
type WebAppsClientDeleteInstanceProcessResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteInstanceProcessSlotResponse contains the response from method WebAppsClient.DeleteInstanceProcessSlot.
type WebAppsClientDeleteInstanceProcessSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeletePremierAddOnResponse contains the response from method WebAppsClient.DeletePremierAddOn.
type WebAppsClientDeletePremierAddOnResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeletePremierAddOnSlotResponse contains the response from method WebAppsClient.DeletePremierAddOnSlot.
type WebAppsClientDeletePremierAddOnSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeletePrivateEndpointConnectionResponse contains the response from method WebAppsClient.DeletePrivateEndpointConnection.
type WebAppsClientDeletePrivateEndpointConnectionResponse struct {
	// Anything
	Interface interface{}
}

// UnmarshalJSON implements the json.Unmarshaller interface for type WebAppsClientDeletePrivateEndpointConnectionResponse.
func (w *WebAppsClientDeletePrivateEndpointConnectionResponse) UnmarshalJSON(data []byte) error {
	return json.Unmarshal(data, &w.Interface)
}

// WebAppsClientDeletePrivateEndpointConnectionSlotResponse contains the response from method WebAppsClient.DeletePrivateEndpointConnectionSlot.
type WebAppsClientDeletePrivateEndpointConnectionSlotResponse struct {
	// Anything
	Interface interface{}
}

// UnmarshalJSON implements the json.Unmarshaller interface for type WebAppsClientDeletePrivateEndpointConnectionSlotResponse.
func (w *WebAppsClientDeletePrivateEndpointConnectionSlotResponse) UnmarshalJSON(data []byte) error {
	return json.Unmarshal(data, &w.Interface)
}

// WebAppsClientDeleteProcessResponse contains the response from method WebAppsClient.DeleteProcess.
type WebAppsClientDeleteProcessResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteProcessSlotResponse contains the response from method WebAppsClient.DeleteProcessSlot.
type WebAppsClientDeleteProcessSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeletePublicCertificateResponse contains the response from method WebAppsClient.DeletePublicCertificate.
type WebAppsClientDeletePublicCertificateResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeletePublicCertificateSlotResponse contains the response from method WebAppsClient.DeletePublicCertificateSlot.
type WebAppsClientDeletePublicCertificateSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteRelayServiceConnectionResponse contains the response from method WebAppsClient.DeleteRelayServiceConnection.
type WebAppsClientDeleteRelayServiceConnectionResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteRelayServiceConnectionSlotResponse contains the response from method WebAppsClient.DeleteRelayServiceConnectionSlot.
type WebAppsClientDeleteRelayServiceConnectionSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteResponse contains the response from method WebAppsClient.Delete.
type WebAppsClientDeleteResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteSiteExtensionResponse contains the response from method WebAppsClient.DeleteSiteExtension.
type WebAppsClientDeleteSiteExtensionResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteSiteExtensionSlotResponse contains the response from method WebAppsClient.DeleteSiteExtensionSlot.
type WebAppsClientDeleteSiteExtensionSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteSlotResponse contains the response from method WebAppsClient.DeleteSlot.
type WebAppsClientDeleteSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteSourceControlResponse contains the response from method WebAppsClient.DeleteSourceControl.
type WebAppsClientDeleteSourceControlResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteSourceControlSlotResponse contains the response from method WebAppsClient.DeleteSourceControlSlot.
type WebAppsClientDeleteSourceControlSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteSwiftVirtualNetworkResponse contains the response from method WebAppsClient.DeleteSwiftVirtualNetwork.
type WebAppsClientDeleteSwiftVirtualNetworkResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteSwiftVirtualNetworkSlotResponse contains the response from method WebAppsClient.DeleteSwiftVirtualNetworkSlot.
type WebAppsClientDeleteSwiftVirtualNetworkSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteTriggeredWebJobResponse contains the response from method WebAppsClient.DeleteTriggeredWebJob.
type WebAppsClientDeleteTriggeredWebJobResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteTriggeredWebJobSlotResponse contains the response from method WebAppsClient.DeleteTriggeredWebJobSlot.
type WebAppsClientDeleteTriggeredWebJobSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteVnetConnectionResponse contains the response from method WebAppsClient.DeleteVnetConnection.
type WebAppsClientDeleteVnetConnectionResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteVnetConnectionSlotResponse contains the response from method WebAppsClient.DeleteVnetConnectionSlot.
type WebAppsClientDeleteVnetConnectionSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientDiscoverBackupResponse contains the response from method WebAppsClient.DiscoverBackup.
type WebAppsClientDiscoverBackupResponse struct {
	RestoreRequest
}

// WebAppsClientDiscoverBackupSlotResponse contains the response from method WebAppsClient.DiscoverBackupSlot.
type WebAppsClientDiscoverBackupSlotResponse struct {
	RestoreRequest
}

// WebAppsClientGenerateNewSitePublishingPasswordResponse contains the response from method WebAppsClient.GenerateNewSitePublishingPassword.
type WebAppsClientGenerateNewSitePublishingPasswordResponse struct {
	// placeholder for future response values
}

// WebAppsClientGenerateNewSitePublishingPasswordSlotResponse contains the response from method WebAppsClient.GenerateNewSitePublishingPasswordSlot.
type WebAppsClientGenerateNewSitePublishingPasswordSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientGetAppSettingKeyVaultReferenceResponse contains the response from method WebAppsClient.GetAppSettingKeyVaultReference.
type WebAppsClientGetAppSettingKeyVaultReferenceResponse struct {
	APIKVReference
}

// WebAppsClientGetAppSettingKeyVaultReferenceSlotResponse contains the response from method WebAppsClient.GetAppSettingKeyVaultReferenceSlot.
type WebAppsClientGetAppSettingKeyVaultReferenceSlotResponse struct {
	APIKVReference
}

// WebAppsClientGetAppSettingsKeyVaultReferencesResponse contains the response from method WebAppsClient.GetAppSettingsKeyVaultReferences.
type WebAppsClientGetAppSettingsKeyVaultReferencesResponse struct {
	APIKVReferenceCollection
}

// WebAppsClientGetAppSettingsKeyVaultReferencesSlotResponse contains the response from method WebAppsClient.GetAppSettingsKeyVaultReferencesSlot.
type WebAppsClientGetAppSettingsKeyVaultReferencesSlotResponse struct {
	APIKVReferenceCollection
}

// WebAppsClientGetAuthSettingsResponse contains the response from method WebAppsClient.GetAuthSettings.
type WebAppsClientGetAuthSettingsResponse struct {
	SiteAuthSettings
}

// WebAppsClientGetAuthSettingsSlotResponse contains the response from method WebAppsClient.GetAuthSettingsSlot.
type WebAppsClientGetAuthSettingsSlotResponse struct {
	SiteAuthSettings
}

// WebAppsClientGetAuthSettingsV2Response contains the response from method WebAppsClient.GetAuthSettingsV2.
type WebAppsClientGetAuthSettingsV2Response struct {
	SiteAuthSettingsV2
}

// WebAppsClientGetAuthSettingsV2SlotResponse contains the response from method WebAppsClient.GetAuthSettingsV2Slot.
type WebAppsClientGetAuthSettingsV2SlotResponse struct {
	SiteAuthSettingsV2
}

// WebAppsClientGetAuthSettingsV2WithoutSecretsResponse contains the response from method WebAppsClient.GetAuthSettingsV2WithoutSecrets.
type WebAppsClientGetAuthSettingsV2WithoutSecretsResponse struct {
	SiteAuthSettingsV2
}

// WebAppsClientGetAuthSettingsV2WithoutSecretsSlotResponse contains the response from method WebAppsClient.GetAuthSettingsV2WithoutSecretsSlot.
type WebAppsClientGetAuthSettingsV2WithoutSecretsSlotResponse struct {
	SiteAuthSettingsV2
}

// WebAppsClientGetBackupConfigurationResponse contains the response from method WebAppsClient.GetBackupConfiguration.
type WebAppsClientGetBackupConfigurationResponse struct {
	BackupRequest
}

// WebAppsClientGetBackupConfigurationSlotResponse contains the response from method WebAppsClient.GetBackupConfigurationSlot.
type WebAppsClientGetBackupConfigurationSlotResponse struct {
	BackupRequest
}

// WebAppsClientGetBackupStatusResponse contains the response from method WebAppsClient.GetBackupStatus.
type WebAppsClientGetBackupStatusResponse struct {
	BackupItem
}

// WebAppsClientGetBackupStatusSlotResponse contains the response from method WebAppsClient.GetBackupStatusSlot.
type WebAppsClientGetBackupStatusSlotResponse struct {
	BackupItem
}

// WebAppsClientGetConfigurationResponse contains the response from method WebAppsClient.GetConfiguration.
type WebAppsClientGetConfigurationResponse struct {
	SiteConfigResource
}

// WebAppsClientGetConfigurationSlotResponse contains the response from method WebAppsClient.GetConfigurationSlot.
type WebAppsClientGetConfigurationSlotResponse struct {
	SiteConfigResource
}

// WebAppsClientGetConfigurationSnapshotResponse contains the response from method WebAppsClient.GetConfigurationSnapshot.
type WebAppsClientGetConfigurationSnapshotResponse struct {
	SiteConfigResource
}

// WebAppsClientGetConfigurationSnapshotSlotResponse contains the response from method WebAppsClient.GetConfigurationSnapshotSlot.
type WebAppsClientGetConfigurationSnapshotSlotResponse struct {
	SiteConfigResource
}

// WebAppsClientGetContainerLogsZipResponse contains the response from method WebAppsClient.GetContainerLogsZip.
type WebAppsClientGetContainerLogsZipResponse struct {
	// Body contains the streaming response.
	Body io.ReadCloser
}

// WebAppsClientGetContainerLogsZipSlotResponse contains the response from method WebAppsClient.GetContainerLogsZipSlot.
type WebAppsClientGetContainerLogsZipSlotResponse struct {
	// Body contains the streaming response.
	Body io.ReadCloser
}

// WebAppsClientGetContinuousWebJobResponse contains the response from method WebAppsClient.GetContinuousWebJob.
type WebAppsClientGetContinuousWebJobResponse struct {
	ContinuousWebJob
}

// WebAppsClientGetContinuousWebJobSlotResponse contains the response from method WebAppsClient.GetContinuousWebJobSlot.
type WebAppsClientGetContinuousWebJobSlotResponse struct {
	ContinuousWebJob
}

// WebAppsClientGetDeploymentResponse contains the response from method WebAppsClient.GetDeployment.
type WebAppsClientGetDeploymentResponse struct {
	Deployment
}

// WebAppsClientGetDeploymentSlotResponse contains the response from method WebAppsClient.GetDeploymentSlot.
type WebAppsClientGetDeploymentSlotResponse struct {
	Deployment
}

// WebAppsClientGetDiagnosticLogsConfigurationResponse contains the response from method WebAppsClient.GetDiagnosticLogsConfiguration.
type WebAppsClientGetDiagnosticLogsConfigurationResponse struct {
	SiteLogsConfig
}

// WebAppsClientGetDiagnosticLogsConfigurationSlotResponse contains the response from method WebAppsClient.GetDiagnosticLogsConfigurationSlot.
type WebAppsClientGetDiagnosticLogsConfigurationSlotResponse struct {
	SiteLogsConfig
}

// WebAppsClientGetDomainOwnershipIdentifierResponse contains the response from method WebAppsClient.GetDomainOwnershipIdentifier.
type WebAppsClientGetDomainOwnershipIdentifierResponse struct {
	Identifier
}

// WebAppsClientGetDomainOwnershipIdentifierSlotResponse contains the response from method WebAppsClient.GetDomainOwnershipIdentifierSlot.
type WebAppsClientGetDomainOwnershipIdentifierSlotResponse struct {
	Identifier
}

// WebAppsClientGetFtpAllowedResponse contains the response from method WebAppsClient.GetFtpAllowed.
type WebAppsClientGetFtpAllowedResponse struct {
	CsmPublishingCredentialsPoliciesEntity
}

// WebAppsClientGetFtpAllowedSlotResponse contains the response from method WebAppsClient.GetFtpAllowedSlot.
type WebAppsClientGetFtpAllowedSlotResponse struct {
	CsmPublishingCredentialsPoliciesEntity
}

// WebAppsClientGetFunctionResponse contains the response from method WebAppsClient.GetFunction.
type WebAppsClientGetFunctionResponse struct {
	FunctionEnvelope
}

// WebAppsClientGetFunctionsAdminTokenResponse contains the response from method WebAppsClient.GetFunctionsAdminToken.
type WebAppsClientGetFunctionsAdminTokenResponse struct {
	Value *string
}

// WebAppsClientGetFunctionsAdminTokenSlotResponse contains the response from method WebAppsClient.GetFunctionsAdminTokenSlot.
type WebAppsClientGetFunctionsAdminTokenSlotResponse struct {
	Value *string
}

// WebAppsClientGetHostNameBindingResponse contains the response from method WebAppsClient.GetHostNameBinding.
type WebAppsClientGetHostNameBindingResponse struct {
	HostNameBinding
}

// WebAppsClientGetHostNameBindingSlotResponse contains the response from method WebAppsClient.GetHostNameBindingSlot.
type WebAppsClientGetHostNameBindingSlotResponse struct {
	HostNameBinding
}

// WebAppsClientGetHybridConnectionResponse contains the response from method WebAppsClient.GetHybridConnection.
type WebAppsClientGetHybridConnectionResponse struct {
	HybridConnection
}

// WebAppsClientGetHybridConnectionSlotResponse contains the response from method WebAppsClient.GetHybridConnectionSlot.
type WebAppsClientGetHybridConnectionSlotResponse struct {
	HybridConnection
}

// WebAppsClientGetInstanceFunctionSlotResponse contains the response from method WebAppsClient.GetInstanceFunctionSlot.
type WebAppsClientGetInstanceFunctionSlotResponse struct {
	FunctionEnvelope
}

// WebAppsClientGetInstanceInfoResponse contains the response from method WebAppsClient.GetInstanceInfo.
type WebAppsClientGetInstanceInfoResponse struct {
	WebSiteInstanceStatus
}

// WebAppsClientGetInstanceInfoSlotResponse contains the response from method WebAppsClient.GetInstanceInfoSlot.
type WebAppsClientGetInstanceInfoSlotResponse struct {
	WebSiteInstanceStatus
}

// WebAppsClientGetInstanceMSDeployLogResponse contains the response from method WebAppsClient.GetInstanceMSDeployLog.
type WebAppsClientGetInstanceMSDeployLogResponse struct {
	MSDeployLog
}

// WebAppsClientGetInstanceMSDeployLogSlotResponse contains the response from method WebAppsClient.GetInstanceMSDeployLogSlot.
type WebAppsClientGetInstanceMSDeployLogSlotResponse struct {
	MSDeployLog
}

// WebAppsClientGetInstanceMsDeployStatusResponse contains the response from method WebAppsClient.GetInstanceMsDeployStatus.
type WebAppsClientGetInstanceMsDeployStatusResponse struct {
	MSDeployStatus
}

// WebAppsClientGetInstanceMsDeployStatusSlotResponse contains the response from method WebAppsClient.GetInstanceMsDeployStatusSlot.
type WebAppsClientGetInstanceMsDeployStatusSlotResponse struct {
	MSDeployStatus
}

// WebAppsClientGetInstanceProcessDumpResponse contains the response from method WebAppsClient.GetInstanceProcessDump.
type WebAppsClientGetInstanceProcessDumpResponse struct {
	// Body contains the streaming response.
	Body io.ReadCloser
}

// WebAppsClientGetInstanceProcessDumpSlotResponse contains the response from method WebAppsClient.GetInstanceProcessDumpSlot.
type WebAppsClientGetInstanceProcessDumpSlotResponse struct {
	// Body contains the streaming response.
	Body io.ReadCloser
}

// WebAppsClientGetInstanceProcessModuleResponse contains the response from method WebAppsClient.GetInstanceProcessModule.
type WebAppsClientGetInstanceProcessModuleResponse struct {
	ProcessModuleInfo
}

// WebAppsClientGetInstanceProcessModuleSlotResponse contains the response from method WebAppsClient.GetInstanceProcessModuleSlot.
type WebAppsClientGetInstanceProcessModuleSlotResponse struct {
	ProcessModuleInfo
}

// WebAppsClientGetInstanceProcessResponse contains the response from method WebAppsClient.GetInstanceProcess.
type WebAppsClientGetInstanceProcessResponse struct {
	ProcessInfo
}

// WebAppsClientGetInstanceProcessSlotResponse contains the response from method WebAppsClient.GetInstanceProcessSlot.
type WebAppsClientGetInstanceProcessSlotResponse struct {
	ProcessInfo
}

// WebAppsClientGetMSDeployLogResponse contains the response from method WebAppsClient.GetMSDeployLog.
type WebAppsClientGetMSDeployLogResponse struct {
	MSDeployLog
}

// WebAppsClientGetMSDeployLogSlotResponse contains the response from method WebAppsClient.GetMSDeployLogSlot.
type WebAppsClientGetMSDeployLogSlotResponse struct {
	MSDeployLog
}

// WebAppsClientGetMSDeployStatusResponse contains the response from method WebAppsClient.GetMSDeployStatus.
type WebAppsClientGetMSDeployStatusResponse struct {
	MSDeployStatus
}

// WebAppsClientGetMSDeployStatusSlotResponse contains the response from method WebAppsClient.GetMSDeployStatusSlot.
type WebAppsClientGetMSDeployStatusSlotResponse struct {
	MSDeployStatus
}

// WebAppsClientGetMigrateMySQLStatusResponse contains the response from method WebAppsClient.GetMigrateMySQLStatus.
type WebAppsClientGetMigrateMySQLStatusResponse struct {
	MigrateMySQLStatus
}

// WebAppsClientGetMigrateMySQLStatusSlotResponse contains the response from method WebAppsClient.GetMigrateMySQLStatusSlot.
type WebAppsClientGetMigrateMySQLStatusSlotResponse struct {
	MigrateMySQLStatus
}

// WebAppsClientGetNetworkTraceOperationResponse contains the response from method WebAppsClient.GetNetworkTraceOperation.
type WebAppsClientGetNetworkTraceOperationResponse struct {
	// Array of NetworkTrace
	NetworkTraceArray []*NetworkTrace
}

// WebAppsClientGetNetworkTraceOperationSlotResponse contains the response from method WebAppsClient.GetNetworkTraceOperationSlot.
type WebAppsClientGetNetworkTraceOperationSlotResponse struct {
	// Array of NetworkTrace
	NetworkTraceArray []*NetworkTrace
}

// WebAppsClientGetNetworkTraceOperationSlotV2Response contains the response from method WebAppsClient.GetNetworkTraceOperationSlotV2.
type WebAppsClientGetNetworkTraceOperationSlotV2Response struct {
	// Array of NetworkTrace
	NetworkTraceArray []*NetworkTrace
}

// WebAppsClientGetNetworkTraceOperationV2Response contains the response from method WebAppsClient.GetNetworkTraceOperationV2.
type WebAppsClientGetNetworkTraceOperationV2Response struct {
	// Array of NetworkTrace
	NetworkTraceArray []*NetworkTrace
}

// WebAppsClientGetNetworkTracesResponse contains the response from method WebAppsClient.GetNetworkTraces.
type WebAppsClientGetNetworkTracesResponse struct {
	// Array of NetworkTrace
	NetworkTraceArray []*NetworkTrace
}

// WebAppsClientGetNetworkTracesSlotResponse contains the response from method WebAppsClient.GetNetworkTracesSlot.
type WebAppsClientGetNetworkTracesSlotResponse struct {
	// Array of NetworkTrace
	NetworkTraceArray []*NetworkTrace
}

// WebAppsClientGetNetworkTracesSlotV2Response contains the response from method WebAppsClient.GetNetworkTracesSlotV2.
type WebAppsClientGetNetworkTracesSlotV2Response struct {
	// Array of NetworkTrace
	NetworkTraceArray []*NetworkTrace
}

// WebAppsClientGetNetworkTracesV2Response contains the response from method WebAppsClient.GetNetworkTracesV2.
type WebAppsClientGetNetworkTracesV2Response struct {
	// Array of NetworkTrace
	NetworkTraceArray []*NetworkTrace
}

// WebAppsClientGetOneDeployStatusResponse contains the response from method WebAppsClient.GetOneDeployStatus.
type WebAppsClientGetOneDeployStatusResponse struct {
	// Anything
	Interface interface{}
}

// WebAppsClientGetPremierAddOnResponse contains the response from method WebAppsClient.GetPremierAddOn.
type WebAppsClientGetPremierAddOnResponse struct {
	PremierAddOn
}

// WebAppsClientGetPremierAddOnSlotResponse contains the response from method WebAppsClient.GetPremierAddOnSlot.
type WebAppsClientGetPremierAddOnSlotResponse struct {
	PremierAddOn
}

// WebAppsClientGetPrivateAccessResponse contains the response from method WebAppsClient.GetPrivateAccess.
type WebAppsClientGetPrivateAccessResponse struct {
	PrivateAccess
}

// WebAppsClientGetPrivateAccessSlotResponse contains the response from method WebAppsClient.GetPrivateAccessSlot.
type WebAppsClientGetPrivateAccessSlotResponse struct {
	PrivateAccess
}

// WebAppsClientGetPrivateEndpointConnectionListResponse contains the response from method WebAppsClient.GetPrivateEndpointConnectionList.
type WebAppsClientGetPrivateEndpointConnectionListResponse struct {
	PrivateEndpointConnectionCollection
}

// WebAppsClientGetPrivateEndpointConnectionListSlotResponse contains the response from method WebAppsClient.GetPrivateEndpointConnectionListSlot.
type WebAppsClientGetPrivateEndpointConnectionListSlotResponse struct {
	PrivateEndpointConnectionCollection
}

// WebAppsClientGetPrivateEndpointConnectionResponse contains the response from method WebAppsClient.GetPrivateEndpointConnection.
type WebAppsClientGetPrivateEndpointConnectionResponse struct {
	RemotePrivateEndpointConnectionARMResource
}

// WebAppsClientGetPrivateEndpointConnectionSlotResponse contains the response from method WebAppsClient.GetPrivateEndpointConnectionSlot.
type WebAppsClientGetPrivateEndpointConnectionSlotResponse struct {
	RemotePrivateEndpointConnectionARMResource
}

// WebAppsClientGetPrivateLinkResourcesResponse contains the response from method WebAppsClient.GetPrivateLinkResources.
type WebAppsClientGetPrivateLinkResourcesResponse struct {
	PrivateLinkResourcesWrapper
}

// WebAppsClientGetPrivateLinkResourcesSlotResponse contains the response from method WebAppsClient.GetPrivateLinkResourcesSlot.
type WebAppsClientGetPrivateLinkResourcesSlotResponse struct {
	PrivateLinkResourcesWrapper
}

// WebAppsClientGetProcessDumpResponse contains the response from method WebAppsClient.GetProcessDump.
type WebAppsClientGetProcessDumpResponse struct {
	// Body contains the streaming response.
	Body io.ReadCloser
}

// WebAppsClientGetProcessDumpSlotResponse contains the response from method WebAppsClient.GetProcessDumpSlot.
type WebAppsClientGetProcessDumpSlotResponse struct {
	// Body contains the streaming response.
	Body io.ReadCloser
}

// WebAppsClientGetProcessModuleResponse contains the response from method WebAppsClient.GetProcessModule.
type WebAppsClientGetProcessModuleResponse struct {
	ProcessModuleInfo
}

// WebAppsClientGetProcessModuleSlotResponse contains the response from method WebAppsClient.GetProcessModuleSlot.
type WebAppsClientGetProcessModuleSlotResponse struct {
	ProcessModuleInfo
}

// WebAppsClientGetProcessResponse contains the response from method WebAppsClient.GetProcess.
type WebAppsClientGetProcessResponse struct {
	ProcessInfo
}

// WebAppsClientGetProcessSlotResponse contains the response from method WebAppsClient.GetProcessSlot.
type WebAppsClientGetProcessSlotResponse struct {
	ProcessInfo
}

// WebAppsClientGetProductionSiteDeploymentStatusResponse contains the response from method WebAppsClient.GetProductionSiteDeploymentStatus.
type WebAppsClientGetProductionSiteDeploymentStatusResponse struct {
	CsmDeploymentStatus
}

// WebAppsClientGetPublicCertificateResponse contains the response from method WebAppsClient.GetPublicCertificate.
type WebAppsClientGetPublicCertificateResponse struct {
	PublicCertificate
}

// WebAppsClientGetPublicCertificateSlotResponse contains the response from method WebAppsClient.GetPublicCertificateSlot.
type WebAppsClientGetPublicCertificateSlotResponse struct {
	PublicCertificate
}

// WebAppsClientGetRelayServiceConnectionResponse contains the response from method WebAppsClient.GetRelayServiceConnection.
type WebAppsClientGetRelayServiceConnectionResponse struct {
	RelayServiceConnectionEntity
}

// WebAppsClientGetRelayServiceConnectionSlotResponse contains the response from method WebAppsClient.GetRelayServiceConnectionSlot.
type WebAppsClientGetRelayServiceConnectionSlotResponse struct {
	RelayServiceConnectionEntity
}

// WebAppsClientGetResponse contains the response from method WebAppsClient.Get.
type WebAppsClientGetResponse struct {
	Site
}

// WebAppsClientGetScmAllowedResponse contains the response from method WebAppsClient.GetScmAllowed.
type WebAppsClientGetScmAllowedResponse struct {
	CsmPublishingCredentialsPoliciesEntity
}

// WebAppsClientGetScmAllowedSlotResponse contains the response from method WebAppsClient.GetScmAllowedSlot.
type WebAppsClientGetScmAllowedSlotResponse struct {
	CsmPublishingCredentialsPoliciesEntity
}

// WebAppsClientGetSiteConnectionStringKeyVaultReferenceResponse contains the response from method WebAppsClient.GetSiteConnectionStringKeyVaultReference.
type WebAppsClientGetSiteConnectionStringKeyVaultReferenceResponse struct {
	APIKVReference
}

// WebAppsClientGetSiteConnectionStringKeyVaultReferenceSlotResponse contains the response from method WebAppsClient.GetSiteConnectionStringKeyVaultReferenceSlot.
type WebAppsClientGetSiteConnectionStringKeyVaultReferenceSlotResponse struct {
	APIKVReference
}

// WebAppsClientGetSiteConnectionStringKeyVaultReferencesResponse contains the response from method WebAppsClient.GetSiteConnectionStringKeyVaultReferences.
type WebAppsClientGetSiteConnectionStringKeyVaultReferencesResponse struct {
	APIKVReferenceCollection
}

// WebAppsClientGetSiteConnectionStringKeyVaultReferencesSlotResponse contains the response from method WebAppsClient.GetSiteConnectionStringKeyVaultReferencesSlot.
type WebAppsClientGetSiteConnectionStringKeyVaultReferencesSlotResponse struct {
	APIKVReferenceCollection
}

// WebAppsClientGetSiteExtensionResponse contains the response from method WebAppsClient.GetSiteExtension.
type WebAppsClientGetSiteExtensionResponse struct {
	SiteExtensionInfo
}

// WebAppsClientGetSiteExtensionSlotResponse contains the response from method WebAppsClient.GetSiteExtensionSlot.
type WebAppsClientGetSiteExtensionSlotResponse struct {
	SiteExtensionInfo
}

// WebAppsClientGetSitePhpErrorLogFlagResponse contains the response from method WebAppsClient.GetSitePhpErrorLogFlag.
type WebAppsClientGetSitePhpErrorLogFlagResponse struct {
	SitePhpErrorLogFlag
}

// WebAppsClientGetSitePhpErrorLogFlagSlotResponse contains the response from method WebAppsClient.GetSitePhpErrorLogFlagSlot.
type WebAppsClientGetSitePhpErrorLogFlagSlotResponse struct {
	SitePhpErrorLogFlag
}

// WebAppsClientGetSlotResponse contains the response from method WebAppsClient.GetSlot.
type WebAppsClientGetSlotResponse struct {
	Site
}

// WebAppsClientGetSlotSiteDeploymentStatusSlotResponse contains the response from method WebAppsClient.GetSlotSiteDeploymentStatusSlot.
type WebAppsClientGetSlotSiteDeploymentStatusSlotResponse struct {
	CsmDeploymentStatus
}

// WebAppsClientGetSourceControlResponse contains the response from method WebAppsClient.GetSourceControl.
type WebAppsClientGetSourceControlResponse struct {
	SiteSourceControl
}

// WebAppsClientGetSourceControlSlotResponse contains the response from method WebAppsClient.GetSourceControlSlot.
type WebAppsClientGetSourceControlSlotResponse struct {
	SiteSourceControl
}

// WebAppsClientGetSwiftVirtualNetworkConnectionResponse contains the response from method WebAppsClient.GetSwiftVirtualNetworkConnection.
type WebAppsClientGetSwiftVirtualNetworkConnectionResponse struct {
	SwiftVirtualNetwork
}

// WebAppsClientGetSwiftVirtualNetworkConnectionSlotResponse contains the response from method WebAppsClient.GetSwiftVirtualNetworkConnectionSlot.
type WebAppsClientGetSwiftVirtualNetworkConnectionSlotResponse struct {
	SwiftVirtualNetwork
}

// WebAppsClientGetTriggeredWebJobHistoryResponse contains the response from method WebAppsClient.GetTriggeredWebJobHistory.
type WebAppsClientGetTriggeredWebJobHistoryResponse struct {
	TriggeredJobHistory
}

// WebAppsClientGetTriggeredWebJobHistorySlotResponse contains the response from method WebAppsClient.GetTriggeredWebJobHistorySlot.
type WebAppsClientGetTriggeredWebJobHistorySlotResponse struct {
	TriggeredJobHistory
}

// WebAppsClientGetTriggeredWebJobResponse contains the response from method WebAppsClient.GetTriggeredWebJob.
type WebAppsClientGetTriggeredWebJobResponse struct {
	TriggeredWebJob
}

// WebAppsClientGetTriggeredWebJobSlotResponse contains the response from method WebAppsClient.GetTriggeredWebJobSlot.
type WebAppsClientGetTriggeredWebJobSlotResponse struct {
	TriggeredWebJob
}

// WebAppsClientGetVnetConnectionGatewayResponse contains the response from method WebAppsClient.GetVnetConnectionGateway.
type WebAppsClientGetVnetConnectionGatewayResponse struct {
	VnetGateway
}

// WebAppsClientGetVnetConnectionGatewaySlotResponse contains the response from method WebAppsClient.GetVnetConnectionGatewaySlot.
type WebAppsClientGetVnetConnectionGatewaySlotResponse struct {
	VnetGateway
}

// WebAppsClientGetVnetConnectionResponse contains the response from method WebAppsClient.GetVnetConnection.
type WebAppsClientGetVnetConnectionResponse struct {
	VnetInfoResource
}

// WebAppsClientGetVnetConnectionSlotResponse contains the response from method WebAppsClient.GetVnetConnectionSlot.
type WebAppsClientGetVnetConnectionSlotResponse struct {
	VnetInfoResource
}

// WebAppsClientGetWebJobResponse contains the response from method WebAppsClient.GetWebJob.
type WebAppsClientGetWebJobResponse struct {
	WebJob
}

// WebAppsClientGetWebJobSlotResponse contains the response from method WebAppsClient.GetWebJobSlot.
type WebAppsClientGetWebJobSlotResponse struct {
	WebJob
}

// WebAppsClientGetWebSiteContainerLogsResponse contains the response from method WebAppsClient.GetWebSiteContainerLogs.
type WebAppsClientGetWebSiteContainerLogsResponse struct {
	// Body contains the streaming response.
	Body io.ReadCloser
}

// WebAppsClientGetWebSiteContainerLogsSlotResponse contains the response from method WebAppsClient.GetWebSiteContainerLogsSlot.
type WebAppsClientGetWebSiteContainerLogsSlotResponse struct {
	// Body contains the streaming response.
	Body io.ReadCloser
}

// WebAppsClientInstallSiteExtensionResponse contains the response from method WebAppsClient.InstallSiteExtension.
type WebAppsClientInstallSiteExtensionResponse struct {
	SiteExtensionInfo
}

// WebAppsClientInstallSiteExtensionSlotResponse contains the response from method WebAppsClient.InstallSiteExtensionSlot.
type WebAppsClientInstallSiteExtensionSlotResponse struct {
	SiteExtensionInfo
}

// WebAppsClientIsCloneableResponse contains the response from method WebAppsClient.IsCloneable.
type WebAppsClientIsCloneableResponse struct {
	SiteCloneability
}

// WebAppsClientIsCloneableSlotResponse contains the response from method WebAppsClient.IsCloneableSlot.
type WebAppsClientIsCloneableSlotResponse struct {
	SiteCloneability
}

// WebAppsClientListApplicationSettingsResponse contains the response from method WebAppsClient.ListApplicationSettings.
type WebAppsClientListApplicationSettingsResponse struct {
	StringDictionary
}

// WebAppsClientListApplicationSettingsSlotResponse contains the response from method WebAppsClient.ListApplicationSettingsSlot.
type WebAppsClientListApplicationSettingsSlotResponse struct {
	StringDictionary
}

// WebAppsClientListAzureStorageAccountsResponse contains the response from method WebAppsClient.ListAzureStorageAccounts.
type WebAppsClientListAzureStorageAccountsResponse struct {
	AzureStoragePropertyDictionaryResource
}

// WebAppsClientListAzureStorageAccountsSlotResponse contains the response from method WebAppsClient.ListAzureStorageAccountsSlot.
type WebAppsClientListAzureStorageAccountsSlotResponse struct {
	AzureStoragePropertyDictionaryResource
}

// WebAppsClientListBackupStatusSecretsResponse contains the response from method WebAppsClient.ListBackupStatusSecrets.
type WebAppsClientListBackupStatusSecretsResponse struct {
	BackupItem
}

// WebAppsClientListBackupStatusSecretsSlotResponse contains the response from method WebAppsClient.ListBackupStatusSecretsSlot.
type WebAppsClientListBackupStatusSecretsSlotResponse struct {
	BackupItem
}

// WebAppsClientListBackupsResponse contains the response from method WebAppsClient.ListBackups.
type WebAppsClientListBackupsResponse struct {
	BackupItemCollection
}

// WebAppsClientListBackupsSlotResponse contains the response from method WebAppsClient.ListBackupsSlot.
type WebAppsClientListBackupsSlotResponse struct {
	BackupItemCollection
}

// WebAppsClientListBasicPublishingCredentialsPoliciesResponse contains the response from method WebAppsClient.ListBasicPublishingCredentialsPolicies.
type WebAppsClientListBasicPublishingCredentialsPoliciesResponse struct {
	PublishingCredentialsPoliciesCollection
}

// WebAppsClientListBasicPublishingCredentialsPoliciesSlotResponse contains the response from method WebAppsClient.ListBasicPublishingCredentialsPoliciesSlot.
type WebAppsClientListBasicPublishingCredentialsPoliciesSlotResponse struct {
	PublishingCredentialsPoliciesCollection
}

// WebAppsClientListByResourceGroupResponse contains the response from method WebAppsClient.ListByResourceGroup.
type WebAppsClientListByResourceGroupResponse struct {
	WebAppCollection
}

// WebAppsClientListConfigurationSnapshotInfoResponse contains the response from method WebAppsClient.ListConfigurationSnapshotInfo.
type WebAppsClientListConfigurationSnapshotInfoResponse struct {
	SiteConfigurationSnapshotInfoCollection
}

// WebAppsClientListConfigurationSnapshotInfoSlotResponse contains the response from method WebAppsClient.ListConfigurationSnapshotInfoSlot.
type WebAppsClientListConfigurationSnapshotInfoSlotResponse struct {
	SiteConfigurationSnapshotInfoCollection
}

// WebAppsClientListConfigurationsResponse contains the response from method WebAppsClient.ListConfigurations.
type WebAppsClientListConfigurationsResponse struct {
	SiteConfigResourceCollection
}

// WebAppsClientListConfigurationsSlotResponse contains the response from method WebAppsClient.ListConfigurationsSlot.
type WebAppsClientListConfigurationsSlotResponse struct {
	SiteConfigResourceCollection
}

// WebAppsClientListConnectionStringsResponse contains the response from method WebAppsClient.ListConnectionStrings.
type WebAppsClientListConnectionStringsResponse struct {
	ConnectionStringDictionary
}

// WebAppsClientListConnectionStringsSlotResponse contains the response from method WebAppsClient.ListConnectionStringsSlot.
type WebAppsClientListConnectionStringsSlotResponse struct {
	ConnectionStringDictionary
}

// WebAppsClientListContinuousWebJobsResponse contains the response from method WebAppsClient.ListContinuousWebJobs.
type WebAppsClientListContinuousWebJobsResponse struct {
	ContinuousWebJobCollection
}

// WebAppsClientListContinuousWebJobsSlotResponse contains the response from method WebAppsClient.ListContinuousWebJobsSlot.
type WebAppsClientListContinuousWebJobsSlotResponse struct {
	ContinuousWebJobCollection
}

// WebAppsClientListDeploymentLogResponse contains the response from method WebAppsClient.ListDeploymentLog.
type WebAppsClientListDeploymentLogResponse struct {
	Deployment
}

// WebAppsClientListDeploymentLogSlotResponse contains the response from method WebAppsClient.ListDeploymentLogSlot.
type WebAppsClientListDeploymentLogSlotResponse struct {
	Deployment
}

// WebAppsClientListDeploymentsResponse contains the response from method WebAppsClient.ListDeployments.
type WebAppsClientListDeploymentsResponse struct {
	DeploymentCollection
}

// WebAppsClientListDeploymentsSlotResponse contains the response from method WebAppsClient.ListDeploymentsSlot.
type WebAppsClientListDeploymentsSlotResponse struct {
	DeploymentCollection
}

// WebAppsClientListDomainOwnershipIdentifiersResponse contains the response from method WebAppsClient.ListDomainOwnershipIdentifiers.
type WebAppsClientListDomainOwnershipIdentifiersResponse struct {
	IdentifierCollection
}

// WebAppsClientListDomainOwnershipIdentifiersSlotResponse contains the response from method WebAppsClient.ListDomainOwnershipIdentifiersSlot.
type WebAppsClientListDomainOwnershipIdentifiersSlotResponse struct {
	IdentifierCollection
}

// WebAppsClientListFunctionKeysResponse contains the response from method WebAppsClient.ListFunctionKeys.
type WebAppsClientListFunctionKeysResponse struct {
	StringDictionary
}

// WebAppsClientListFunctionKeysSlotResponse contains the response from method WebAppsClient.ListFunctionKeysSlot.
type WebAppsClientListFunctionKeysSlotResponse struct {
	StringDictionary
}

// WebAppsClientListFunctionSecretsResponse contains the response from method WebAppsClient.ListFunctionSecrets.
type WebAppsClientListFunctionSecretsResponse struct {
	FunctionSecrets
}

// WebAppsClientListFunctionSecretsSlotResponse contains the response from method WebAppsClient.ListFunctionSecretsSlot.
type WebAppsClientListFunctionSecretsSlotResponse struct {
	FunctionSecrets
}

// WebAppsClientListFunctionsResponse contains the response from method WebAppsClient.ListFunctions.
type WebAppsClientListFunctionsResponse struct {
	FunctionEnvelopeCollection
}

// WebAppsClientListHostKeysResponse contains the response from method WebAppsClient.ListHostKeys.
type WebAppsClientListHostKeysResponse struct {
	HostKeys
}

// WebAppsClientListHostKeysSlotResponse contains the response from method WebAppsClient.ListHostKeysSlot.
type WebAppsClientListHostKeysSlotResponse struct {
	HostKeys
}

// WebAppsClientListHostNameBindingsResponse contains the response from method WebAppsClient.ListHostNameBindings.
type WebAppsClientListHostNameBindingsResponse struct {
	HostNameBindingCollection
}

// WebAppsClientListHostNameBindingsSlotResponse contains the response from method WebAppsClient.ListHostNameBindingsSlot.
type WebAppsClientListHostNameBindingsSlotResponse struct {
	HostNameBindingCollection
}

// WebAppsClientListHybridConnectionsResponse contains the response from method WebAppsClient.ListHybridConnections.
type WebAppsClientListHybridConnectionsResponse struct {
	HybridConnection
}

// WebAppsClientListHybridConnectionsSlotResponse contains the response from method WebAppsClient.ListHybridConnectionsSlot.
type WebAppsClientListHybridConnectionsSlotResponse struct {
	HybridConnection
}

// WebAppsClientListInstanceFunctionsSlotResponse contains the response from method WebAppsClient.ListInstanceFunctionsSlot.
type WebAppsClientListInstanceFunctionsSlotResponse struct {
	FunctionEnvelopeCollection
}

// WebAppsClientListInstanceIdentifiersResponse contains the response from method WebAppsClient.ListInstanceIdentifiers.
type WebAppsClientListInstanceIdentifiersResponse struct {
	WebAppInstanceStatusCollection
}

// WebAppsClientListInstanceIdentifiersSlotResponse contains the response from method WebAppsClient.ListInstanceIdentifiersSlot.
type WebAppsClientListInstanceIdentifiersSlotResponse struct {
	WebAppInstanceStatusCollection
}

// WebAppsClientListInstanceProcessModulesResponse contains the response from method WebAppsClient.ListInstanceProcessModules.
type WebAppsClientListInstanceProcessModulesResponse struct {
	ProcessModuleInfoCollection
}

// WebAppsClientListInstanceProcessModulesSlotResponse contains the response from method WebAppsClient.ListInstanceProcessModulesSlot.
type WebAppsClientListInstanceProcessModulesSlotResponse struct {
	ProcessModuleInfoCollection
}

// WebAppsClientListInstanceProcessThreadsResponse contains the response from method WebAppsClient.ListInstanceProcessThreads.
type WebAppsClientListInstanceProcessThreadsResponse struct {
	ProcessThreadInfoCollection
}

// WebAppsClientListInstanceProcessThreadsSlotResponse contains the response from method WebAppsClient.ListInstanceProcessThreadsSlot.
type WebAppsClientListInstanceProcessThreadsSlotResponse struct {
	ProcessThreadInfoCollection
}

// WebAppsClientListInstanceProcessesResponse contains the response from method WebAppsClient.ListInstanceProcesses.
type WebAppsClientListInstanceProcessesResponse struct {
	ProcessInfoCollection
}

// WebAppsClientListInstanceProcessesSlotResponse contains the response from method WebAppsClient.ListInstanceProcessesSlot.
type WebAppsClientListInstanceProcessesSlotResponse struct {
	ProcessInfoCollection
}

// WebAppsClientListMetadataResponse contains the response from method WebAppsClient.ListMetadata.
type WebAppsClientListMetadataResponse struct {
	StringDictionary
}

// WebAppsClientListMetadataSlotResponse contains the response from method WebAppsClient.ListMetadataSlot.
type WebAppsClientListMetadataSlotResponse struct {
	StringDictionary
}

// WebAppsClientListNetworkFeaturesResponse contains the response from method WebAppsClient.ListNetworkFeatures.
type WebAppsClientListNetworkFeaturesResponse struct {
	NetworkFeatures
}

// WebAppsClientListNetworkFeaturesSlotResponse contains the response from method WebAppsClient.ListNetworkFeaturesSlot.
type WebAppsClientListNetworkFeaturesSlotResponse struct {
	NetworkFeatures
}

// WebAppsClientListPerfMonCountersResponse contains the response from method WebAppsClient.ListPerfMonCounters.
type WebAppsClientListPerfMonCountersResponse struct {
	PerfMonCounterCollection
}

// WebAppsClientListPerfMonCountersSlotResponse contains the response from method WebAppsClient.ListPerfMonCountersSlot.
type WebAppsClientListPerfMonCountersSlotResponse struct {
	PerfMonCounterCollection
}

// WebAppsClientListPremierAddOnsResponse contains the response from method WebAppsClient.ListPremierAddOns.
type WebAppsClientListPremierAddOnsResponse struct {
	PremierAddOn
}

// WebAppsClientListPremierAddOnsSlotResponse contains the response from method WebAppsClient.ListPremierAddOnsSlot.
type WebAppsClientListPremierAddOnsSlotResponse struct {
	PremierAddOn
}

// WebAppsClientListProcessModulesResponse contains the response from method WebAppsClient.ListProcessModules.
type WebAppsClientListProcessModulesResponse struct {
	ProcessModuleInfoCollection
}

// WebAppsClientListProcessModulesSlotResponse contains the response from method WebAppsClient.ListProcessModulesSlot.
type WebAppsClientListProcessModulesSlotResponse struct {
	ProcessModuleInfoCollection
}

// WebAppsClientListProcessThreadsResponse contains the response from method WebAppsClient.ListProcessThreads.
type WebAppsClientListProcessThreadsResponse struct {
	ProcessThreadInfoCollection
}

// WebAppsClientListProcessThreadsSlotResponse contains the response from method WebAppsClient.ListProcessThreadsSlot.
type WebAppsClientListProcessThreadsSlotResponse struct {
	ProcessThreadInfoCollection
}

// WebAppsClientListProcessesResponse contains the response from method WebAppsClient.ListProcesses.
type WebAppsClientListProcessesResponse struct {
	ProcessInfoCollection
}

// WebAppsClientListProcessesSlotResponse contains the response from method WebAppsClient.ListProcessesSlot.
type WebAppsClientListProcessesSlotResponse struct {
	ProcessInfoCollection
}

// WebAppsClientListProductionSiteDeploymentStatusesResponse contains the response from method WebAppsClient.ListProductionSiteDeploymentStatuses.
type WebAppsClientListProductionSiteDeploymentStatusesResponse struct {
	CsmDeploymentStatusCollection
}

// WebAppsClientListPublicCertificatesResponse contains the response from method WebAppsClient.ListPublicCertificates.
type WebAppsClientListPublicCertificatesResponse struct {
	PublicCertificateCollection
}

// WebAppsClientListPublicCertificatesSlotResponse contains the response from method WebAppsClient.ListPublicCertificatesSlot.
type WebAppsClientListPublicCertificatesSlotResponse struct {
	PublicCertificateCollection
}

// WebAppsClientListPublishingCredentialsResponse contains the response from method WebAppsClient.ListPublishingCredentials.
type WebAppsClientListPublishingCredentialsResponse struct {
	User
}

// WebAppsClientListPublishingCredentialsSlotResponse contains the response from method WebAppsClient.ListPublishingCredentialsSlot.
type WebAppsClientListPublishingCredentialsSlotResponse struct {
	User
}

// WebAppsClientListPublishingProfileXMLWithSecretsResponse contains the response from method WebAppsClient.ListPublishingProfileXMLWithSecrets.
type WebAppsClientListPublishingProfileXMLWithSecretsResponse struct {
	// Body contains the streaming response.
	Body io.ReadCloser
}

// WebAppsClientListPublishingProfileXMLWithSecretsSlotResponse contains the response from method WebAppsClient.ListPublishingProfileXMLWithSecretsSlot.
type WebAppsClientListPublishingProfileXMLWithSecretsSlotResponse struct {
	// Body contains the streaming response.
	Body io.ReadCloser
}

// WebAppsClientListRelayServiceConnectionsResponse contains the response from method WebAppsClient.ListRelayServiceConnections.
type WebAppsClientListRelayServiceConnectionsResponse struct {
	RelayServiceConnectionEntity
}

// WebAppsClientListRelayServiceConnectionsSlotResponse contains the response from method WebAppsClient.ListRelayServiceConnectionsSlot.
type WebAppsClientListRelayServiceConnectionsSlotResponse struct {
	RelayServiceConnectionEntity
}

// WebAppsClientListResponse contains the response from method WebAppsClient.List.
type WebAppsClientListResponse struct {
	WebAppCollection
}

// WebAppsClientListSiteBackupsResponse contains the response from method WebAppsClient.ListSiteBackups.
type WebAppsClientListSiteBackupsResponse struct {
	BackupItemCollection
}

// WebAppsClientListSiteBackupsSlotResponse contains the response from method WebAppsClient.ListSiteBackupsSlot.
type WebAppsClientListSiteBackupsSlotResponse struct {
	BackupItemCollection
}

// WebAppsClientListSiteExtensionsResponse contains the response from method WebAppsClient.ListSiteExtensions.
type WebAppsClientListSiteExtensionsResponse struct {
	SiteExtensionInfoCollection
}

// WebAppsClientListSiteExtensionsSlotResponse contains the response from method WebAppsClient.ListSiteExtensionsSlot.
type WebAppsClientListSiteExtensionsSlotResponse struct {
	SiteExtensionInfoCollection
}

// WebAppsClientListSitePushSettingsResponse contains the response from method WebAppsClient.ListSitePushSettings.
type WebAppsClientListSitePushSettingsResponse struct {
	PushSettings
}

// WebAppsClientListSitePushSettingsSlotResponse contains the response from method WebAppsClient.ListSitePushSettingsSlot.
type WebAppsClientListSitePushSettingsSlotResponse struct {
	PushSettings
}

// WebAppsClientListSlotConfigurationNamesResponse contains the response from method WebAppsClient.ListSlotConfigurationNames.
type WebAppsClientListSlotConfigurationNamesResponse struct {
	SlotConfigNamesResource
}

// WebAppsClientListSlotDifferencesFromProductionResponse contains the response from method WebAppsClient.ListSlotDifferencesFromProduction.
type WebAppsClientListSlotDifferencesFromProductionResponse struct {
	SlotDifferenceCollection
}

// WebAppsClientListSlotDifferencesSlotResponse contains the response from method WebAppsClient.ListSlotDifferencesSlot.
type WebAppsClientListSlotDifferencesSlotResponse struct {
	SlotDifferenceCollection
}

// WebAppsClientListSlotSiteDeploymentStatusesSlotResponse contains the response from method WebAppsClient.ListSlotSiteDeploymentStatusesSlot.
type WebAppsClientListSlotSiteDeploymentStatusesSlotResponse struct {
	CsmDeploymentStatusCollection
}

// WebAppsClientListSlotsResponse contains the response from method WebAppsClient.ListSlots.
type WebAppsClientListSlotsResponse struct {
	WebAppCollection
}

// WebAppsClientListSnapshotsFromDRSecondaryResponse contains the response from method WebAppsClient.ListSnapshotsFromDRSecondary.
type WebAppsClientListSnapshotsFromDRSecondaryResponse struct {
	SnapshotCollection
}

// WebAppsClientListSnapshotsFromDRSecondarySlotResponse contains the response from method WebAppsClient.ListSnapshotsFromDRSecondarySlot.
type WebAppsClientListSnapshotsFromDRSecondarySlotResponse struct {
	SnapshotCollection
}

// WebAppsClientListSnapshotsResponse contains the response from method WebAppsClient.ListSnapshots.
type WebAppsClientListSnapshotsResponse struct {
	SnapshotCollection
}

// WebAppsClientListSnapshotsSlotResponse contains the response from method WebAppsClient.ListSnapshotsSlot.
type WebAppsClientListSnapshotsSlotResponse struct {
	SnapshotCollection
}

// WebAppsClientListSyncFunctionTriggersResponse contains the response from method WebAppsClient.ListSyncFunctionTriggers.
type WebAppsClientListSyncFunctionTriggersResponse struct {
	FunctionSecrets
}

// WebAppsClientListSyncFunctionTriggersSlotResponse contains the response from method WebAppsClient.ListSyncFunctionTriggersSlot.
type WebAppsClientListSyncFunctionTriggersSlotResponse struct {
	FunctionSecrets
}

// WebAppsClientListSyncStatusResponse contains the response from method WebAppsClient.ListSyncStatus.
type WebAppsClientListSyncStatusResponse struct {
	// placeholder for future response values
}

// WebAppsClientListSyncStatusSlotResponse contains the response from method WebAppsClient.ListSyncStatusSlot.
type WebAppsClientListSyncStatusSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientListTriggeredWebJobHistoryResponse contains the response from method WebAppsClient.ListTriggeredWebJobHistory.
type WebAppsClientListTriggeredWebJobHistoryResponse struct {
	TriggeredJobHistoryCollection
}

// WebAppsClientListTriggeredWebJobHistorySlotResponse contains the response from method WebAppsClient.ListTriggeredWebJobHistorySlot.
type WebAppsClientListTriggeredWebJobHistorySlotResponse struct {
	TriggeredJobHistoryCollection
}

// WebAppsClientListTriggeredWebJobsResponse contains the response from method WebAppsClient.ListTriggeredWebJobs.
type WebAppsClientListTriggeredWebJobsResponse struct {
	TriggeredWebJobCollection
}

// WebAppsClientListTriggeredWebJobsSlotResponse contains the response from method WebAppsClient.ListTriggeredWebJobsSlot.
type WebAppsClientListTriggeredWebJobsSlotResponse struct {
	TriggeredWebJobCollection
}

// WebAppsClientListUsagesResponse contains the response from method WebAppsClient.ListUsages.
type WebAppsClientListUsagesResponse struct {
	CsmUsageQuotaCollection
}

// WebAppsClientListUsagesSlotResponse contains the response from method WebAppsClient.ListUsagesSlot.
type WebAppsClientListUsagesSlotResponse struct {
	CsmUsageQuotaCollection
}

// WebAppsClientListVnetConnectionsResponse contains the response from method WebAppsClient.ListVnetConnections.
type WebAppsClientListVnetConnectionsResponse struct {
	// Array of VnetInfoResource
	VnetInfoResourceArray []*VnetInfoResource
}

// WebAppsClientListVnetConnectionsSlotResponse contains the response from method WebAppsClient.ListVnetConnectionsSlot.
type WebAppsClientListVnetConnectionsSlotResponse struct {
	// Array of VnetInfoResource
	VnetInfoResourceArray []*VnetInfoResource
}

// WebAppsClientListWebJobsResponse contains the response from method WebAppsClient.ListWebJobs.
type WebAppsClientListWebJobsResponse struct {
	WebJobCollection
}

// WebAppsClientListWebJobsSlotResponse contains the response from method WebAppsClient.ListWebJobsSlot.
type WebAppsClientListWebJobsSlotResponse struct {
	WebJobCollection
}

// WebAppsClientMigrateMySQLResponse contains the response from method WebAppsClient.MigrateMySQL.
type WebAppsClientMigrateMySQLResponse struct {
	Operation
}

// WebAppsClientMigrateStorageResponse contains the response from method WebAppsClient.MigrateStorage.
type WebAppsClientMigrateStorageResponse struct {
	StorageMigrationResponse
}

// WebAppsClientPutPrivateAccessVnetResponse contains the response from method WebAppsClient.PutPrivateAccessVnet.
type WebAppsClientPutPrivateAccessVnetResponse struct {
	PrivateAccess
}

// WebAppsClientPutPrivateAccessVnetSlotResponse contains the response from method WebAppsClient.PutPrivateAccessVnetSlot.
type WebAppsClientPutPrivateAccessVnetSlotResponse struct {
	PrivateAccess
}

// WebAppsClientRecoverSiteConfigurationSnapshotResponse contains the response from method WebAppsClient.RecoverSiteConfigurationSnapshot.
type WebAppsClientRecoverSiteConfigurationSnapshotResponse struct {
	// placeholder for future response values
}

// WebAppsClientRecoverSiteConfigurationSnapshotSlotResponse contains the response from method WebAppsClient.RecoverSiteConfigurationSnapshotSlot.
type WebAppsClientRecoverSiteConfigurationSnapshotSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientResetProductionSlotConfigResponse contains the response from method WebAppsClient.ResetProductionSlotConfig.
type WebAppsClientResetProductionSlotConfigResponse struct {
	// placeholder for future response values
}

// WebAppsClientResetSlotConfigurationSlotResponse contains the response from method WebAppsClient.ResetSlotConfigurationSlot.
type WebAppsClientResetSlotConfigurationSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientRestartResponse contains the response from method WebAppsClient.Restart.
type WebAppsClientRestartResponse struct {
	// placeholder for future response values
}

// WebAppsClientRestartSlotResponse contains the response from method WebAppsClient.RestartSlot.
type WebAppsClientRestartSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientRestoreFromBackupBlobResponse contains the response from method WebAppsClient.RestoreFromBackupBlob.
type WebAppsClientRestoreFromBackupBlobResponse struct {
	// placeholder for future response values
}

// WebAppsClientRestoreFromBackupBlobSlotResponse contains the response from method WebAppsClient.RestoreFromBackupBlobSlot.
type WebAppsClientRestoreFromBackupBlobSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientRestoreFromDeletedAppResponse contains the response from method WebAppsClient.RestoreFromDeletedApp.
type WebAppsClientRestoreFromDeletedAppResponse struct {
	// placeholder for future response values
}

// WebAppsClientRestoreFromDeletedAppSlotResponse contains the response from method WebAppsClient.RestoreFromDeletedAppSlot.
type WebAppsClientRestoreFromDeletedAppSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientRestoreResponse contains the response from method WebAppsClient.Restore.
type WebAppsClientRestoreResponse struct {
	// placeholder for future response values
}

// WebAppsClientRestoreSlotResponse contains the response from method WebAppsClient.RestoreSlot.
type WebAppsClientRestoreSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientRestoreSnapshotResponse contains the response from method WebAppsClient.RestoreSnapshot.
type WebAppsClientRestoreSnapshotResponse struct {
	// placeholder for future response values
}

// WebAppsClientRestoreSnapshotSlotResponse contains the response from method WebAppsClient.RestoreSnapshotSlot.
type WebAppsClientRestoreSnapshotSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientRunTriggeredWebJobResponse contains the response from method WebAppsClient.RunTriggeredWebJob.
type WebAppsClientRunTriggeredWebJobResponse struct {
	// placeholder for future response values
}

// WebAppsClientRunTriggeredWebJobSlotResponse contains the response from method WebAppsClient.RunTriggeredWebJobSlot.
type WebAppsClientRunTriggeredWebJobSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientStartContinuousWebJobResponse contains the response from method WebAppsClient.StartContinuousWebJob.
type WebAppsClientStartContinuousWebJobResponse struct {
	// placeholder for future response values
}

// WebAppsClientStartContinuousWebJobSlotResponse contains the response from method WebAppsClient.StartContinuousWebJobSlot.
type WebAppsClientStartContinuousWebJobSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientStartNetworkTraceResponse contains the response from method WebAppsClient.StartNetworkTrace.
type WebAppsClientStartNetworkTraceResponse struct {
	// Array of NetworkTrace
	NetworkTraceArray []*NetworkTrace
}

// UnmarshalJSON implements the json.Unmarshaller interface for type WebAppsClientStartNetworkTraceResponse.
func (w *WebAppsClientStartNetworkTraceResponse) UnmarshalJSON(data []byte) error {
	return json.Unmarshal(data, &w.NetworkTraceArray)
}

// WebAppsClientStartNetworkTraceSlotResponse contains the response from method WebAppsClient.StartNetworkTraceSlot.
type WebAppsClientStartNetworkTraceSlotResponse struct {
	// Array of NetworkTrace
	NetworkTraceArray []*NetworkTrace
}

// UnmarshalJSON implements the json.Unmarshaller interface for type WebAppsClientStartNetworkTraceSlotResponse.
func (w *WebAppsClientStartNetworkTraceSlotResponse) UnmarshalJSON(data []byte) error {
	return json.Unmarshal(data, &w.NetworkTraceArray)
}

// WebAppsClientStartResponse contains the response from method WebAppsClient.Start.
type WebAppsClientStartResponse struct {
	// placeholder for future response values
}

// WebAppsClientStartSlotResponse contains the response from method WebAppsClient.StartSlot.
type WebAppsClientStartSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientStartWebSiteNetworkTraceOperationResponse contains the response from method WebAppsClient.StartWebSiteNetworkTraceOperation.
type WebAppsClientStartWebSiteNetworkTraceOperationResponse struct {
	// Array of NetworkTrace
	NetworkTraceArray []*NetworkTrace
}

// UnmarshalJSON implements the json.Unmarshaller interface for type WebAppsClientStartWebSiteNetworkTraceOperationResponse.
func (w *WebAppsClientStartWebSiteNetworkTraceOperationResponse) UnmarshalJSON(data []byte) error {
	return json.Unmarshal(data, &w.NetworkTraceArray)
}

// WebAppsClientStartWebSiteNetworkTraceOperationSlotResponse contains the response from method WebAppsClient.StartWebSiteNetworkTraceOperationSlot.
type WebAppsClientStartWebSiteNetworkTraceOperationSlotResponse struct {
	// Array of NetworkTrace
	NetworkTraceArray []*NetworkTrace
}

// UnmarshalJSON implements the json.Unmarshaller interface for type WebAppsClientStartWebSiteNetworkTraceOperationSlotResponse.
func (w *WebAppsClientStartWebSiteNetworkTraceOperationSlotResponse) UnmarshalJSON(data []byte) error {
	return json.Unmarshal(data, &w.NetworkTraceArray)
}

// WebAppsClientStartWebSiteNetworkTraceResponse contains the response from method WebAppsClient.StartWebSiteNetworkTrace.
type WebAppsClientStartWebSiteNetworkTraceResponse struct {
	Value *string
}

// WebAppsClientStartWebSiteNetworkTraceSlotResponse contains the response from method WebAppsClient.StartWebSiteNetworkTraceSlot.
type WebAppsClientStartWebSiteNetworkTraceSlotResponse struct {
	Value *string
}

// WebAppsClientStopContinuousWebJobResponse contains the response from method WebAppsClient.StopContinuousWebJob.
type WebAppsClientStopContinuousWebJobResponse struct {
	// placeholder for future response values
}

// WebAppsClientStopContinuousWebJobSlotResponse contains the response from method WebAppsClient.StopContinuousWebJobSlot.
type WebAppsClientStopContinuousWebJobSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientStopNetworkTraceResponse contains the response from method WebAppsClient.StopNetworkTrace.
type WebAppsClientStopNetworkTraceResponse struct {
	// placeholder for future response values
}

// WebAppsClientStopNetworkTraceSlotResponse contains the response from method WebAppsClient.StopNetworkTraceSlot.
type WebAppsClientStopNetworkTraceSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientStopResponse contains the response from method WebAppsClient.Stop.
type WebAppsClientStopResponse struct {
	// placeholder for future response values
}

// WebAppsClientStopSlotResponse contains the response from method WebAppsClient.StopSlot.
type WebAppsClientStopSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientStopWebSiteNetworkTraceResponse contains the response from method WebAppsClient.StopWebSiteNetworkTrace.
type WebAppsClientStopWebSiteNetworkTraceResponse struct {
	// placeholder for future response values
}

// WebAppsClientStopWebSiteNetworkTraceSlotResponse contains the response from method WebAppsClient.StopWebSiteNetworkTraceSlot.
type WebAppsClientStopWebSiteNetworkTraceSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientSwapSlotResponse contains the response from method WebAppsClient.SwapSlot.
type WebAppsClientSwapSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientSwapSlotWithProductionResponse contains the response from method WebAppsClient.SwapSlotWithProduction.
type WebAppsClientSwapSlotWithProductionResponse struct {
	// placeholder for future response values
}

// WebAppsClientSyncFunctionTriggersResponse contains the response from method WebAppsClient.SyncFunctionTriggers.
type WebAppsClientSyncFunctionTriggersResponse struct {
	// placeholder for future response values
}

// WebAppsClientSyncFunctionTriggersSlotResponse contains the response from method WebAppsClient.SyncFunctionTriggersSlot.
type WebAppsClientSyncFunctionTriggersSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientSyncFunctionsResponse contains the response from method WebAppsClient.SyncFunctions.
type WebAppsClientSyncFunctionsResponse struct {
	// placeholder for future response values
}

// WebAppsClientSyncFunctionsSlotResponse contains the response from method WebAppsClient.SyncFunctionsSlot.
type WebAppsClientSyncFunctionsSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientSyncRepositoryResponse contains the response from method WebAppsClient.SyncRepository.
type WebAppsClientSyncRepositoryResponse struct {
	// placeholder for future response values
}

// WebAppsClientSyncRepositorySlotResponse contains the response from method WebAppsClient.SyncRepositorySlot.
type WebAppsClientSyncRepositorySlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientUpdateApplicationSettingsResponse contains the response from method WebAppsClient.UpdateApplicationSettings.
type WebAppsClientUpdateApplicationSettingsResponse struct {
	StringDictionary
}

// WebAppsClientUpdateApplicationSettingsSlotResponse contains the response from method WebAppsClient.UpdateApplicationSettingsSlot.
type WebAppsClientUpdateApplicationSettingsSlotResponse struct {
	StringDictionary
}

// WebAppsClientUpdateAuthSettingsResponse contains the response from method WebAppsClient.UpdateAuthSettings.
type WebAppsClientUpdateAuthSettingsResponse struct {
	SiteAuthSettings
}

// WebAppsClientUpdateAuthSettingsSlotResponse contains the response from method WebAppsClient.UpdateAuthSettingsSlot.
type WebAppsClientUpdateAuthSettingsSlotResponse struct {
	SiteAuthSettings
}

// WebAppsClientUpdateAuthSettingsV2Response contains the response from method WebAppsClient.UpdateAuthSettingsV2.
type WebAppsClientUpdateAuthSettingsV2Response struct {
	SiteAuthSettingsV2
}

// WebAppsClientUpdateAuthSettingsV2SlotResponse contains the response from method WebAppsClient.UpdateAuthSettingsV2Slot.
type WebAppsClientUpdateAuthSettingsV2SlotResponse struct {
	SiteAuthSettingsV2
}

// WebAppsClientUpdateAzureStorageAccountsResponse contains the response from method WebAppsClient.UpdateAzureStorageAccounts.
type WebAppsClientUpdateAzureStorageAccountsResponse struct {
	AzureStoragePropertyDictionaryResource
}

// WebAppsClientUpdateAzureStorageAccountsSlotResponse contains the response from method WebAppsClient.UpdateAzureStorageAccountsSlot.
type WebAppsClientUpdateAzureStorageAccountsSlotResponse struct {
	AzureStoragePropertyDictionaryResource
}

// WebAppsClientUpdateBackupConfigurationResponse contains the response from method WebAppsClient.UpdateBackupConfiguration.
type WebAppsClientUpdateBackupConfigurationResponse struct {
	BackupRequest
}

// WebAppsClientUpdateBackupConfigurationSlotResponse contains the response from method WebAppsClient.UpdateBackupConfigurationSlot.
type WebAppsClientUpdateBackupConfigurationSlotResponse struct {
	BackupRequest
}

// WebAppsClientUpdateConfigurationResponse contains the response from method WebAppsClient.UpdateConfiguration.
type WebAppsClientUpdateConfigurationResponse struct {
	SiteConfigResource
}

// WebAppsClientUpdateConfigurationSlotResponse contains the response from method WebAppsClient.UpdateConfigurationSlot.
type WebAppsClientUpdateConfigurationSlotResponse struct {
	SiteConfigResource
}

// WebAppsClientUpdateConnectionStringsResponse contains the response from method WebAppsClient.UpdateConnectionStrings.
type WebAppsClientUpdateConnectionStringsResponse struct {
	ConnectionStringDictionary
}

// WebAppsClientUpdateConnectionStringsSlotResponse contains the response from method WebAppsClient.UpdateConnectionStringsSlot.
type WebAppsClientUpdateConnectionStringsSlotResponse struct {
	ConnectionStringDictionary
}

// WebAppsClientUpdateDiagnosticLogsConfigResponse contains the response from method WebAppsClient.UpdateDiagnosticLogsConfig.
type WebAppsClientUpdateDiagnosticLogsConfigResponse struct {
	SiteLogsConfig
}

// WebAppsClientUpdateDiagnosticLogsConfigSlotResponse contains the response from method WebAppsClient.UpdateDiagnosticLogsConfigSlot.
type WebAppsClientUpdateDiagnosticLogsConfigSlotResponse struct {
	SiteLogsConfig
}

// WebAppsClientUpdateDomainOwnershipIdentifierResponse contains the response from method WebAppsClient.UpdateDomainOwnershipIdentifier.
type WebAppsClientUpdateDomainOwnershipIdentifierResponse struct {
	Identifier
}

// WebAppsClientUpdateDomainOwnershipIdentifierSlotResponse contains the response from method WebAppsClient.UpdateDomainOwnershipIdentifierSlot.
type WebAppsClientUpdateDomainOwnershipIdentifierSlotResponse struct {
	Identifier
}

// WebAppsClientUpdateFtpAllowedResponse contains the response from method WebAppsClient.UpdateFtpAllowed.
type WebAppsClientUpdateFtpAllowedResponse struct {
	CsmPublishingCredentialsPoliciesEntity
}

// WebAppsClientUpdateFtpAllowedSlotResponse contains the response from method WebAppsClient.UpdateFtpAllowedSlot.
type WebAppsClientUpdateFtpAllowedSlotResponse struct {
	CsmPublishingCredentialsPoliciesEntity
}

// WebAppsClientUpdateHybridConnectionResponse contains the response from method WebAppsClient.UpdateHybridConnection.
type WebAppsClientUpdateHybridConnectionResponse struct {
	HybridConnection
}

// WebAppsClientUpdateHybridConnectionSlotResponse contains the response from method WebAppsClient.UpdateHybridConnectionSlot.
type WebAppsClientUpdateHybridConnectionSlotResponse struct {
	HybridConnection
}

// WebAppsClientUpdateMetadataResponse contains the response from method WebAppsClient.UpdateMetadata.
type WebAppsClientUpdateMetadataResponse struct {
	StringDictionary
}

// WebAppsClientUpdateMetadataSlotResponse contains the response from method WebAppsClient.UpdateMetadataSlot.
type WebAppsClientUpdateMetadataSlotResponse struct {
	StringDictionary
}

// WebAppsClientUpdatePremierAddOnResponse contains the response from method WebAppsClient.UpdatePremierAddOn.
type WebAppsClientUpdatePremierAddOnResponse struct {
	PremierAddOn
}

// WebAppsClientUpdatePremierAddOnSlotResponse contains the response from method WebAppsClient.UpdatePremierAddOnSlot.
type WebAppsClientUpdatePremierAddOnSlotResponse struct {
	PremierAddOn
}

// WebAppsClientUpdateRelayServiceConnectionResponse contains the response from method WebAppsClient.UpdateRelayServiceConnection.
type WebAppsClientUpdateRelayServiceConnectionResponse struct {
	RelayServiceConnectionEntity
}

// WebAppsClientUpdateRelayServiceConnectionSlotResponse contains the response from method WebAppsClient.UpdateRelayServiceConnectionSlot.
type WebAppsClientUpdateRelayServiceConnectionSlotResponse struct {
	RelayServiceConnectionEntity
}

// WebAppsClientUpdateResponse contains the response from method WebAppsClient.Update.
type WebAppsClientUpdateResponse struct {
	Site
}

// WebAppsClientUpdateScmAllowedResponse contains the response from method WebAppsClient.UpdateScmAllowed.
type WebAppsClientUpdateScmAllowedResponse struct {
	CsmPublishingCredentialsPoliciesEntity
}

// WebAppsClientUpdateScmAllowedSlotResponse contains the response from method WebAppsClient.UpdateScmAllowedSlot.
type WebAppsClientUpdateScmAllowedSlotResponse struct {
	CsmPublishingCredentialsPoliciesEntity
}

// WebAppsClientUpdateSitePushSettingsResponse contains the response from method WebAppsClient.UpdateSitePushSettings.
type WebAppsClientUpdateSitePushSettingsResponse struct {
	PushSettings
}

// WebAppsClientUpdateSitePushSettingsSlotResponse contains the response from method WebAppsClient.UpdateSitePushSettingsSlot.
type WebAppsClientUpdateSitePushSettingsSlotResponse struct {
	PushSettings
}

// WebAppsClientUpdateSlotConfigurationNamesResponse contains the response from method WebAppsClient.UpdateSlotConfigurationNames.
type WebAppsClientUpdateSlotConfigurationNamesResponse struct {
	SlotConfigNamesResource
}

// WebAppsClientUpdateSlotResponse contains the response from method WebAppsClient.UpdateSlot.
type WebAppsClientUpdateSlotResponse struct {
	Site
}

// WebAppsClientUpdateSourceControlResponse contains the response from method WebAppsClient.UpdateSourceControl.
type WebAppsClientUpdateSourceControlResponse struct {
	SiteSourceControl
}

// WebAppsClientUpdateSourceControlSlotResponse contains the response from method WebAppsClient.UpdateSourceControlSlot.
type WebAppsClientUpdateSourceControlSlotResponse struct {
	SiteSourceControl
}

// WebAppsClientUpdateSwiftVirtualNetworkConnectionWithCheckResponse contains the response from method WebAppsClient.UpdateSwiftVirtualNetworkConnectionWithCheck.
type WebAppsClientUpdateSwiftVirtualNetworkConnectionWithCheckResponse struct {
	SwiftVirtualNetwork
}

// WebAppsClientUpdateSwiftVirtualNetworkConnectionWithCheckSlotResponse contains the response from method WebAppsClient.UpdateSwiftVirtualNetworkConnectionWithCheckSlot.
type WebAppsClientUpdateSwiftVirtualNetworkConnectionWithCheckSlotResponse struct {
	SwiftVirtualNetwork
}

// WebAppsClientUpdateVnetConnectionGatewayResponse contains the response from method WebAppsClient.UpdateVnetConnectionGateway.
type WebAppsClientUpdateVnetConnectionGatewayResponse struct {
	VnetGateway
}

// WebAppsClientUpdateVnetConnectionGatewaySlotResponse contains the response from method WebAppsClient.UpdateVnetConnectionGatewaySlot.
type WebAppsClientUpdateVnetConnectionGatewaySlotResponse struct {
	VnetGateway
}

// WebAppsClientUpdateVnetConnectionResponse contains the response from method WebAppsClient.UpdateVnetConnection.
type WebAppsClientUpdateVnetConnectionResponse struct {
	VnetInfoResource
}

// WebAppsClientUpdateVnetConnectionSlotResponse contains the response from method WebAppsClient.UpdateVnetConnectionSlot.
type WebAppsClientUpdateVnetConnectionSlotResponse struct {
	VnetInfoResource
}

// WebSiteManagementClientCheckNameAvailabilityResponse contains the response from method WebSiteManagementClient.CheckNameAvailability.
type WebSiteManagementClientCheckNameAvailabilityResponse struct {
	ResourceNameAvailability
}

// WebSiteManagementClientGetPublishingUserResponse contains the response from method WebSiteManagementClient.GetPublishingUser.
type WebSiteManagementClientGetPublishingUserResponse struct {
	User
}

// WebSiteManagementClientGetSourceControlResponse contains the response from method WebSiteManagementClient.GetSourceControl.
type WebSiteManagementClientGetSourceControlResponse struct {
	SourceControl
}

// WebSiteManagementClientGetSubscriptionDeploymentLocationsResponse contains the response from method WebSiteManagementClient.GetSubscriptionDeploymentLocations.
type WebSiteManagementClientGetSubscriptionDeploymentLocationsResponse struct {
	DeploymentLocations
}

// WebSiteManagementClientListBillingMetersResponse contains the response from method WebSiteManagementClient.ListBillingMeters.
type WebSiteManagementClientListBillingMetersResponse struct {
	BillingMeterCollection
}

// WebSiteManagementClientListCustomHostNameSitesResponse contains the response from method WebSiteManagementClient.ListCustomHostNameSites.
type WebSiteManagementClientListCustomHostNameSitesResponse struct {
	CustomHostnameSitesCollection
}

// WebSiteManagementClientListGeoRegionsResponse contains the response from method WebSiteManagementClient.ListGeoRegions.
type WebSiteManagementClientListGeoRegionsResponse struct {
	GeoRegionCollection
}

// WebSiteManagementClientListPremierAddOnOffersResponse contains the response from method WebSiteManagementClient.ListPremierAddOnOffers.
type WebSiteManagementClientListPremierAddOnOffersResponse struct {
	PremierAddOnOfferCollection
}

// WebSiteManagementClientListSKUsResponse contains the response from method WebSiteManagementClient.ListSKUs.
type WebSiteManagementClientListSKUsResponse struct {
	SKUInfos
}

// WebSiteManagementClientListSiteIdentifiersAssignedToHostNameResponse contains the response from method WebSiteManagementClient.ListSiteIdentifiersAssignedToHostName.
type WebSiteManagementClientListSiteIdentifiersAssignedToHostNameResponse struct {
	IdentifierCollection
}

// WebSiteManagementClientListSourceControlsResponse contains the response from method WebSiteManagementClient.ListSourceControls.
type WebSiteManagementClientListSourceControlsResponse struct {
	SourceControlCollection
}

// WebSiteManagementClientMoveResponse contains the response from method WebSiteManagementClient.Move.
type WebSiteManagementClientMoveResponse struct {
	// placeholder for future response values
}

// WebSiteManagementClientUpdatePublishingUserResponse contains the response from method WebSiteManagementClient.UpdatePublishingUser.
type WebSiteManagementClientUpdatePublishingUserResponse struct {
	User
}

// WebSiteManagementClientUpdateSourceControlResponse contains the response from method WebSiteManagementClient.UpdateSourceControl.
type WebSiteManagementClientUpdateSourceControlResponse struct {
	SourceControl
}

// WebSiteManagementClientValidateMoveResponse contains the response from method WebSiteManagementClient.ValidateMove.
type WebSiteManagementClientValidateMoveResponse struct {
	// placeholder for future response values
}

// WebSiteManagementClientValidateResponse contains the response from method WebSiteManagementClient.Validate.
type WebSiteManagementClientValidateResponse struct {
	ValidateResponse
}

// WebSiteManagementClientVerifyHostingEnvironmentVnetResponse contains the response from method WebSiteManagementClient.VerifyHostingEnvironmentVnet.
type WebSiteManagementClientVerifyHostingEnvironmentVnetResponse struct {
	VnetValidationFailureDetails
}

// WorkflowRunActionRepetitionsClientGetResponse contains the response from method WorkflowRunActionRepetitionsClient.Get.
type WorkflowRunActionRepetitionsClientGetResponse struct {
	WorkflowRunActionRepetitionDefinition
}

// WorkflowRunActionRepetitionsClientListExpressionTracesResponse contains the response from method WorkflowRunActionRepetitionsClient.ListExpressionTraces.
type WorkflowRunActionRepetitionsClientListExpressionTracesResponse struct {
	ExpressionTraces
}

// WorkflowRunActionRepetitionsClientListResponse contains the response from method WorkflowRunActionRepetitionsClient.List.
type WorkflowRunActionRepetitionsClientListResponse struct {
	WorkflowRunActionRepetitionDefinitionCollection
}

// WorkflowRunActionRepetitionsRequestHistoriesClientGetResponse contains the response from method WorkflowRunActionRepetitionsRequestHistoriesClient.Get.
type WorkflowRunActionRepetitionsRequestHistoriesClientGetResponse struct {
	RequestHistory
}

// WorkflowRunActionRepetitionsRequestHistoriesClientListResponse contains the response from method WorkflowRunActionRepetitionsRequestHistoriesClient.List.
type WorkflowRunActionRepetitionsRequestHistoriesClientListResponse struct {
	RequestHistoryListResult
}

// WorkflowRunActionScopeRepetitionsClientGetResponse contains the response from method WorkflowRunActionScopeRepetitionsClient.Get.
type WorkflowRunActionScopeRepetitionsClientGetResponse struct {
	WorkflowRunActionRepetitionDefinition
}

// WorkflowRunActionScopeRepetitionsClientListResponse contains the response from method WorkflowRunActionScopeRepetitionsClient.List.
type WorkflowRunActionScopeRepetitionsClientListResponse struct {
	WorkflowRunActionRepetitionDefinitionCollection
}

// WorkflowRunActionsClientGetResponse contains the response from method WorkflowRunActionsClient.Get.
type WorkflowRunActionsClientGetResponse struct {
	WorkflowRunAction
}

// WorkflowRunActionsClientListExpressionTracesResponse contains the response from method WorkflowRunActionsClient.ListExpressionTraces.
type WorkflowRunActionsClientListExpressionTracesResponse struct {
	ExpressionTraces
}

// WorkflowRunActionsClientListResponse contains the response from method WorkflowRunActionsClient.List.
type WorkflowRunActionsClientListResponse struct {
	WorkflowRunActionListResult
}

// WorkflowRunsClientCancelResponse contains the response from method WorkflowRunsClient.Cancel.
type WorkflowRunsClientCancelResponse struct {
	// placeholder for future response values
}

// WorkflowRunsClientGetResponse contains the response from method WorkflowRunsClient.Get.
type WorkflowRunsClientGetResponse struct {
	WorkflowRun
}

// WorkflowRunsClientListResponse contains the response from method WorkflowRunsClient.List.
type WorkflowRunsClientListResponse struct {
	WorkflowRunListResult
}

// WorkflowTriggerHistoriesClientGetResponse contains the response from method WorkflowTriggerHistoriesClient.Get.
type WorkflowTriggerHistoriesClientGetResponse struct {
	WorkflowTriggerHistory
}

// WorkflowTriggerHistoriesClientListResponse contains the response from method WorkflowTriggerHistoriesClient.List.
type WorkflowTriggerHistoriesClientListResponse struct {
	WorkflowTriggerHistoryListResult
}

// WorkflowTriggerHistoriesClientResubmitResponse contains the response from method WorkflowTriggerHistoriesClient.Resubmit.
type WorkflowTriggerHistoriesClientResubmitResponse struct {
	// placeholder for future response values
}

// WorkflowTriggersClientGetResponse contains the response from method WorkflowTriggersClient.Get.
type WorkflowTriggersClientGetResponse struct {
	WorkflowTrigger
}

// WorkflowTriggersClientGetSchemaJSONResponse contains the response from method WorkflowTriggersClient.GetSchemaJSON.
type WorkflowTriggersClientGetSchemaJSONResponse struct {
	JSONSchema
}

// WorkflowTriggersClientListCallbackURLResponse contains the response from method WorkflowTriggersClient.ListCallbackURL.
type WorkflowTriggersClientListCallbackURLResponse struct {
	WorkflowTriggerCallbackURL
}

// WorkflowTriggersClientListResponse contains the response from method WorkflowTriggersClient.List.
type WorkflowTriggersClientListResponse struct {
	WorkflowTriggerListResult
}

// WorkflowTriggersClientRunResponse contains the response from method WorkflowTriggersClient.Run.
type WorkflowTriggersClientRunResponse struct {
	// placeholder for future response values
}

// WorkflowVersionsClientGetResponse contains the response from method WorkflowVersionsClient.Get.
type WorkflowVersionsClientGetResponse struct {
	WorkflowVersion
}

// WorkflowVersionsClientListResponse contains the response from method WorkflowVersionsClient.List.
type WorkflowVersionsClientListResponse struct {
	WorkflowVersionListResult
}

// WorkflowsClientRegenerateAccessKeyResponse contains the response from method WorkflowsClient.RegenerateAccessKey.
type WorkflowsClientRegenerateAccessKeyResponse struct {
	// placeholder for future response values
}

// WorkflowsClientValidateResponse contains the response from method WorkflowsClient.Validate.
type WorkflowsClientValidateResponse struct {
	// placeholder for future response values
}
