//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.
// DO NOT EDIT.

package armautomation

import (
	"encoding/json"
	"io"
)

// AccountClientCreateOrUpdateResponse contains the response from method AccountClient.CreateOrUpdate.
type AccountClientCreateOrUpdateResponse struct {
	Account
}

// AccountClientDeleteResponse contains the response from method AccountClient.Delete.
type AccountClientDeleteResponse struct {
	// placeholder for future response values
}

// AccountClientGetResponse contains the response from method AccountClient.Get.
type AccountClientGetResponse struct {
	Account
}

// AccountClientListByResourceGroupResponse contains the response from method AccountClient.ListByResourceGroup.
type AccountClientListByResourceGroupResponse struct {
	AccountListResult
}

// AccountClientListResponse contains the response from method AccountClient.List.
type AccountClientListResponse struct {
	AccountListResult
}

// AccountClientUpdateResponse contains the response from method AccountClient.Update.
type AccountClientUpdateResponse struct {
	Account
}

// ActivityClientGetResponse contains the response from method ActivityClient.Get.
type ActivityClientGetResponse struct {
	Activity
}

// ActivityClientListByModuleResponse contains the response from method ActivityClient.ListByModule.
type ActivityClientListByModuleResponse struct {
	ActivityListResult
}

// AgentRegistrationInformationClientGetResponse contains the response from method AgentRegistrationInformationClient.Get.
type AgentRegistrationInformationClientGetResponse struct {
	AgentRegistration
}

// AgentRegistrationInformationClientRegenerateKeyResponse contains the response from method AgentRegistrationInformationClient.RegenerateKey.
type AgentRegistrationInformationClientRegenerateKeyResponse struct {
	AgentRegistration
}

// CertificateClientCreateOrUpdateResponse contains the response from method CertificateClient.CreateOrUpdate.
type CertificateClientCreateOrUpdateResponse struct {
	Certificate
}

// CertificateClientDeleteResponse contains the response from method CertificateClient.Delete.
type CertificateClientDeleteResponse struct {
	// placeholder for future response values
}

// CertificateClientGetResponse contains the response from method CertificateClient.Get.
type CertificateClientGetResponse struct {
	Certificate
}

// CertificateClientListByAutomationAccountResponse contains the response from method CertificateClient.ListByAutomationAccount.
type CertificateClientListByAutomationAccountResponse struct {
	CertificateListResult
}

// CertificateClientUpdateResponse contains the response from method CertificateClient.Update.
type CertificateClientUpdateResponse struct {
	Certificate
}

// ClientConvertGraphRunbookContentResponse contains the response from method Client.ConvertGraphRunbookContent.
type ClientConvertGraphRunbookContentResponse struct {
	GraphicalRunbookContent
}

// ConnectionClientCreateOrUpdateResponse contains the response from method ConnectionClient.CreateOrUpdate.
type ConnectionClientCreateOrUpdateResponse struct {
	Connection
}

// ConnectionClientDeleteResponse contains the response from method ConnectionClient.Delete.
type ConnectionClientDeleteResponse struct {
	// placeholder for future response values
}

// ConnectionClientGetResponse contains the response from method ConnectionClient.Get.
type ConnectionClientGetResponse struct {
	Connection
}

// ConnectionClientListByAutomationAccountResponse contains the response from method ConnectionClient.ListByAutomationAccount.
type ConnectionClientListByAutomationAccountResponse struct {
	ConnectionListResult
}

// ConnectionClientUpdateResponse contains the response from method ConnectionClient.Update.
type ConnectionClientUpdateResponse struct {
	Connection
}

// ConnectionTypeClientCreateOrUpdateResponse contains the response from method ConnectionTypeClient.CreateOrUpdate.
type ConnectionTypeClientCreateOrUpdateResponse struct {
	ConnectionType
}

// ConnectionTypeClientDeleteResponse contains the response from method ConnectionTypeClient.Delete.
type ConnectionTypeClientDeleteResponse struct {
	// placeholder for future response values
}

// ConnectionTypeClientGetResponse contains the response from method ConnectionTypeClient.Get.
type ConnectionTypeClientGetResponse struct {
	ConnectionType
}

// ConnectionTypeClientListByAutomationAccountResponse contains the response from method ConnectionTypeClient.ListByAutomationAccount.
type ConnectionTypeClientListByAutomationAccountResponse struct {
	ConnectionTypeListResult
}

// CredentialClientCreateOrUpdateResponse contains the response from method CredentialClient.CreateOrUpdate.
type CredentialClientCreateOrUpdateResponse struct {
	Credential
}

// CredentialClientDeleteResponse contains the response from method CredentialClient.Delete.
type CredentialClientDeleteResponse struct {
	// placeholder for future response values
}

// CredentialClientGetResponse contains the response from method CredentialClient.Get.
type CredentialClientGetResponse struct {
	Credential
}

// CredentialClientListByAutomationAccountResponse contains the response from method CredentialClient.ListByAutomationAccount.
type CredentialClientListByAutomationAccountResponse struct {
	CredentialListResult
}

// CredentialClientUpdateResponse contains the response from method CredentialClient.Update.
type CredentialClientUpdateResponse struct {
	Credential
}

// DeletedAutomationAccountsClientListBySubscriptionResponse contains the response from method DeletedAutomationAccountsClient.ListBySubscription.
type DeletedAutomationAccountsClientListBySubscriptionResponse struct {
	DeletedAutomationAccountListResult
}

// DscCompilationJobClientCreateResponse contains the response from method DscCompilationJobClient.Create.
type DscCompilationJobClientCreateResponse struct {
	DscCompilationJob
}

// DscCompilationJobClientGetResponse contains the response from method DscCompilationJobClient.Get.
type DscCompilationJobClientGetResponse struct {
	DscCompilationJob
}

// DscCompilationJobClientGetStreamResponse contains the response from method DscCompilationJobClient.GetStream.
type DscCompilationJobClientGetStreamResponse struct {
	JobStream
}

// DscCompilationJobClientListByAutomationAccountResponse contains the response from method DscCompilationJobClient.ListByAutomationAccount.
type DscCompilationJobClientListByAutomationAccountResponse struct {
	DscCompilationJobListResult
}

// DscCompilationJobStreamClientListByJobResponse contains the response from method DscCompilationJobStreamClient.ListByJob.
type DscCompilationJobStreamClientListByJobResponse struct {
	JobStreamListResult
}

// DscConfigurationClientCreateOrUpdateWithJSONResponse contains the response from method DscConfigurationClient.CreateOrUpdateWithJSON.
type DscConfigurationClientCreateOrUpdateWithJSONResponse struct {
	DscConfiguration
}

// DscConfigurationClientCreateOrUpdateWithTextResponse contains the response from method DscConfigurationClient.CreateOrUpdateWithText.
type DscConfigurationClientCreateOrUpdateWithTextResponse struct {
	DscConfiguration
}

// DscConfigurationClientDeleteResponse contains the response from method DscConfigurationClient.Delete.
type DscConfigurationClientDeleteResponse struct {
	// placeholder for future response values
}

// DscConfigurationClientGetContentResponse contains the response from method DscConfigurationClient.GetContent.
type DscConfigurationClientGetContentResponse struct {
	Value *string
}

// DscConfigurationClientGetResponse contains the response from method DscConfigurationClient.Get.
type DscConfigurationClientGetResponse struct {
	DscConfiguration
}

// DscConfigurationClientListByAutomationAccountResponse contains the response from method DscConfigurationClient.ListByAutomationAccount.
type DscConfigurationClientListByAutomationAccountResponse struct {
	DscConfigurationListResult
}

// DscConfigurationClientUpdateWithJSONResponse contains the response from method DscConfigurationClient.UpdateWithJSON.
type DscConfigurationClientUpdateWithJSONResponse struct {
	DscConfiguration
}

// DscConfigurationClientUpdateWithTextResponse contains the response from method DscConfigurationClient.UpdateWithText.
type DscConfigurationClientUpdateWithTextResponse struct {
	DscConfiguration
}

// DscNodeClientDeleteResponse contains the response from method DscNodeClient.Delete.
type DscNodeClientDeleteResponse struct {
	// placeholder for future response values
}

// DscNodeClientGetResponse contains the response from method DscNodeClient.Get.
type DscNodeClientGetResponse struct {
	DscNode
}

// DscNodeClientListByAutomationAccountResponse contains the response from method DscNodeClient.ListByAutomationAccount.
type DscNodeClientListByAutomationAccountResponse struct {
	DscNodeListResult
}

// DscNodeClientUpdateResponse contains the response from method DscNodeClient.Update.
type DscNodeClientUpdateResponse struct {
	DscNode
}

// DscNodeConfigurationClientCreateOrUpdateResponse contains the response from method DscNodeConfigurationClient.CreateOrUpdate.
type DscNodeConfigurationClientCreateOrUpdateResponse struct {
	DscNodeConfiguration
}

// DscNodeConfigurationClientDeleteResponse contains the response from method DscNodeConfigurationClient.Delete.
type DscNodeConfigurationClientDeleteResponse struct {
	// placeholder for future response values
}

// DscNodeConfigurationClientGetResponse contains the response from method DscNodeConfigurationClient.Get.
type DscNodeConfigurationClientGetResponse struct {
	DscNodeConfiguration
}

// DscNodeConfigurationClientListByAutomationAccountResponse contains the response from method DscNodeConfigurationClient.ListByAutomationAccount.
type DscNodeConfigurationClientListByAutomationAccountResponse struct {
	DscNodeConfigurationListResult
}

// FieldsClientListByTypeResponse contains the response from method FieldsClient.ListByType.
type FieldsClientListByTypeResponse struct {
	TypeFieldListResult
}

// HybridRunbookWorkerGroupClientCreateResponse contains the response from method HybridRunbookWorkerGroupClient.Create.
type HybridRunbookWorkerGroupClientCreateResponse struct {
	HybridRunbookWorkerGroup
}

// HybridRunbookWorkerGroupClientDeleteResponse contains the response from method HybridRunbookWorkerGroupClient.Delete.
type HybridRunbookWorkerGroupClientDeleteResponse struct {
	// placeholder for future response values
}

// HybridRunbookWorkerGroupClientGetResponse contains the response from method HybridRunbookWorkerGroupClient.Get.
type HybridRunbookWorkerGroupClientGetResponse struct {
	HybridRunbookWorkerGroup
}

// HybridRunbookWorkerGroupClientListByAutomationAccountResponse contains the response from method HybridRunbookWorkerGroupClient.ListByAutomationAccount.
type HybridRunbookWorkerGroupClientListByAutomationAccountResponse struct {
	HybridRunbookWorkerGroupsListResult
}

// HybridRunbookWorkerGroupClientUpdateResponse contains the response from method HybridRunbookWorkerGroupClient.Update.
type HybridRunbookWorkerGroupClientUpdateResponse struct {
	HybridRunbookWorkerGroup
}

// HybridRunbookWorkersClientCreateResponse contains the response from method HybridRunbookWorkersClient.Create.
type HybridRunbookWorkersClientCreateResponse struct {
	HybridRunbookWorker
}

// HybridRunbookWorkersClientDeleteResponse contains the response from method HybridRunbookWorkersClient.Delete.
type HybridRunbookWorkersClientDeleteResponse struct {
	// placeholder for future response values
}

// HybridRunbookWorkersClientGetResponse contains the response from method HybridRunbookWorkersClient.Get.
type HybridRunbookWorkersClientGetResponse struct {
	HybridRunbookWorker
}

// HybridRunbookWorkersClientListByHybridRunbookWorkerGroupResponse contains the response from method HybridRunbookWorkersClient.ListByHybridRunbookWorkerGroup.
type HybridRunbookWorkersClientListByHybridRunbookWorkerGroupResponse struct {
	HybridRunbookWorkersListResult
}

// HybridRunbookWorkersClientMoveResponse contains the response from method HybridRunbookWorkersClient.Move.
type HybridRunbookWorkersClientMoveResponse struct {
	// placeholder for future response values
}

// JobClientCreateResponse contains the response from method JobClient.Create.
type JobClientCreateResponse struct {
	Job
}

// JobClientGetOutputResponse contains the response from method JobClient.GetOutput.
type JobClientGetOutputResponse struct {
	Value *string
}

// JobClientGetResponse contains the response from method JobClient.Get.
type JobClientGetResponse struct {
	Job
}

// JobClientGetRunbookContentResponse contains the response from method JobClient.GetRunbookContent.
type JobClientGetRunbookContentResponse struct {
	Value *string
}

// JobClientListByAutomationAccountResponse contains the response from method JobClient.ListByAutomationAccount.
type JobClientListByAutomationAccountResponse struct {
	JobListResultV2
}

// JobClientResumeResponse contains the response from method JobClient.Resume.
type JobClientResumeResponse struct {
	// placeholder for future response values
}

// JobClientStopResponse contains the response from method JobClient.Stop.
type JobClientStopResponse struct {
	// placeholder for future response values
}

// JobClientSuspendResponse contains the response from method JobClient.Suspend.
type JobClientSuspendResponse struct {
	// placeholder for future response values
}

// JobScheduleClientCreateResponse contains the response from method JobScheduleClient.Create.
type JobScheduleClientCreateResponse struct {
	JobSchedule
}

// JobScheduleClientDeleteResponse contains the response from method JobScheduleClient.Delete.
type JobScheduleClientDeleteResponse struct {
	// placeholder for future response values
}

// JobScheduleClientGetResponse contains the response from method JobScheduleClient.Get.
type JobScheduleClientGetResponse struct {
	JobSchedule
}

// JobScheduleClientListByAutomationAccountResponse contains the response from method JobScheduleClient.ListByAutomationAccount.
type JobScheduleClientListByAutomationAccountResponse struct {
	JobScheduleListResult
}

// JobStreamClientGetResponse contains the response from method JobStreamClient.Get.
type JobStreamClientGetResponse struct {
	JobStream
}

// JobStreamClientListByJobResponse contains the response from method JobStreamClient.ListByJob.
type JobStreamClientListByJobResponse struct {
	JobStreamListResult
}

// KeysClientListByAutomationAccountResponse contains the response from method KeysClient.ListByAutomationAccount.
type KeysClientListByAutomationAccountResponse struct {
	KeyListResult
}

// LinkedWorkspaceClientGetResponse contains the response from method LinkedWorkspaceClient.Get.
type LinkedWorkspaceClientGetResponse struct {
	LinkedWorkspace
}

// ModuleClientCreateOrUpdateResponse contains the response from method ModuleClient.CreateOrUpdate.
type ModuleClientCreateOrUpdateResponse struct {
	Module
}

// ModuleClientDeleteResponse contains the response from method ModuleClient.Delete.
type ModuleClientDeleteResponse struct {
	// placeholder for future response values
}

// ModuleClientGetResponse contains the response from method ModuleClient.Get.
type ModuleClientGetResponse struct {
	Module
}

// ModuleClientListByAutomationAccountResponse contains the response from method ModuleClient.ListByAutomationAccount.
type ModuleClientListByAutomationAccountResponse struct {
	ModuleListResult
}

// ModuleClientUpdateResponse contains the response from method ModuleClient.Update.
type ModuleClientUpdateResponse struct {
	Module
}

// NodeCountInformationClientGetResponse contains the response from method NodeCountInformationClient.Get.
type NodeCountInformationClientGetResponse struct {
	NodeCounts
}

// NodeReportsClientGetContentResponse contains the response from method NodeReportsClient.GetContent.
type NodeReportsClientGetContentResponse struct {
	// Anything
	Interface interface{}
}

// NodeReportsClientGetResponse contains the response from method NodeReportsClient.Get.
type NodeReportsClientGetResponse struct {
	DscNodeReport
}

// NodeReportsClientListByNodeResponse contains the response from method NodeReportsClient.ListByNode.
type NodeReportsClientListByNodeResponse struct {
	DscNodeReportListResult
}

// ObjectDataTypesClientListFieldsByModuleAndTypeResponse contains the response from method ObjectDataTypesClient.ListFieldsByModuleAndType.
type ObjectDataTypesClientListFieldsByModuleAndTypeResponse struct {
	TypeFieldListResult
}

// ObjectDataTypesClientListFieldsByTypeResponse contains the response from method ObjectDataTypesClient.ListFieldsByType.
type ObjectDataTypesClientListFieldsByTypeResponse struct {
	TypeFieldListResult
}

// OperationsClientListResponse contains the response from method OperationsClient.List.
type OperationsClientListResponse struct {
	OperationListResult
}

// PrivateEndpointConnectionsClientCreateOrUpdateResponse contains the response from method PrivateEndpointConnectionsClient.CreateOrUpdate.
type PrivateEndpointConnectionsClientCreateOrUpdateResponse struct {
	PrivateEndpointConnection
}

// PrivateEndpointConnectionsClientDeleteResponse contains the response from method PrivateEndpointConnectionsClient.Delete.
type PrivateEndpointConnectionsClientDeleteResponse struct {
	// placeholder for future response values
}

// PrivateEndpointConnectionsClientGetResponse contains the response from method PrivateEndpointConnectionsClient.Get.
type PrivateEndpointConnectionsClientGetResponse struct {
	PrivateEndpointConnection
}

// PrivateEndpointConnectionsClientListByAutomationAccountResponse contains the response from method PrivateEndpointConnectionsClient.ListByAutomationAccount.
type PrivateEndpointConnectionsClientListByAutomationAccountResponse struct {
	PrivateEndpointConnectionListResult
}

// PrivateLinkResourcesClientAutomationResponse contains the response from method PrivateLinkResourcesClient.Automation.
type PrivateLinkResourcesClientAutomationResponse struct {
	PrivateLinkResourceListResult
}

// Python2PackageClientCreateOrUpdateResponse contains the response from method Python2PackageClient.CreateOrUpdate.
type Python2PackageClientCreateOrUpdateResponse struct {
	Module
}

// Python2PackageClientDeleteResponse contains the response from method Python2PackageClient.Delete.
type Python2PackageClientDeleteResponse struct {
	// placeholder for future response values
}

// Python2PackageClientGetResponse contains the response from method Python2PackageClient.Get.
type Python2PackageClientGetResponse struct {
	Module
}

// Python2PackageClientListByAutomationAccountResponse contains the response from method Python2PackageClient.ListByAutomationAccount.
type Python2PackageClientListByAutomationAccountResponse struct {
	ModuleListResult
}

// Python2PackageClientUpdateResponse contains the response from method Python2PackageClient.Update.
type Python2PackageClientUpdateResponse struct {
	Module
}

// RunbookClientCreateOrUpdateResponse contains the response from method RunbookClient.CreateOrUpdate.
type RunbookClientCreateOrUpdateResponse struct {
	Runbook
}

// RunbookClientDeleteResponse contains the response from method RunbookClient.Delete.
type RunbookClientDeleteResponse struct {
	// placeholder for future response values
}

// RunbookClientGetContentResponse contains the response from method RunbookClient.GetContent.
type RunbookClientGetContentResponse struct {
	// placeholder for future response values
}

// RunbookClientGetResponse contains the response from method RunbookClient.Get.
type RunbookClientGetResponse struct {
	Runbook
}

// RunbookClientListByAutomationAccountResponse contains the response from method RunbookClient.ListByAutomationAccount.
type RunbookClientListByAutomationAccountResponse struct {
	RunbookListResult
}

// RunbookClientPublishResponse contains the response from method RunbookClient.Publish.
type RunbookClientPublishResponse struct {
	// placeholder for future response values
}

// RunbookClientUpdateResponse contains the response from method RunbookClient.Update.
type RunbookClientUpdateResponse struct {
	Runbook
}

// RunbookDraftClientGetContentResponse contains the response from method RunbookDraftClient.GetContent.
type RunbookDraftClientGetContentResponse struct {
	// placeholder for future response values
}

// RunbookDraftClientGetResponse contains the response from method RunbookDraftClient.Get.
type RunbookDraftClientGetResponse struct {
	RunbookDraft
}

// RunbookDraftClientReplaceContentResponse contains the response from method RunbookDraftClient.ReplaceContent.
type RunbookDraftClientReplaceContentResponse struct {
	// Body contains the streaming response.
	Body io.ReadCloser
}

// UnmarshalJSON implements the json.Unmarshaller interface for type RunbookDraftClientReplaceContentResponse.
func (r *RunbookDraftClientReplaceContentResponse) UnmarshalJSON(data []byte) error {
	return json.Unmarshal(data, &r.Body)
}

// RunbookDraftClientUndoEditResponse contains the response from method RunbookDraftClient.UndoEdit.
type RunbookDraftClientUndoEditResponse struct {
	RunbookDraftUndoEditResult
}

// ScheduleClientCreateOrUpdateResponse contains the response from method ScheduleClient.CreateOrUpdate.
type ScheduleClientCreateOrUpdateResponse struct {
	Schedule
}

// ScheduleClientDeleteResponse contains the response from method ScheduleClient.Delete.
type ScheduleClientDeleteResponse struct {
	// placeholder for future response values
}

// ScheduleClientGetResponse contains the response from method ScheduleClient.Get.
type ScheduleClientGetResponse struct {
	Schedule
}

// ScheduleClientListByAutomationAccountResponse contains the response from method ScheduleClient.ListByAutomationAccount.
type ScheduleClientListByAutomationAccountResponse struct {
	ScheduleListResult
}

// ScheduleClientUpdateResponse contains the response from method ScheduleClient.Update.
type ScheduleClientUpdateResponse struct {
	Schedule
}

// SoftwareUpdateConfigurationMachineRunsClientGetByIDResponse contains the response from method SoftwareUpdateConfigurationMachineRunsClient.GetByID.
type SoftwareUpdateConfigurationMachineRunsClientGetByIDResponse struct {
	SoftwareUpdateConfigurationMachineRun
}

// SoftwareUpdateConfigurationMachineRunsClientListResponse contains the response from method SoftwareUpdateConfigurationMachineRunsClient.List.
type SoftwareUpdateConfigurationMachineRunsClientListResponse struct {
	SoftwareUpdateConfigurationMachineRunListResult
}

// SoftwareUpdateConfigurationRunsClientGetByIDResponse contains the response from method SoftwareUpdateConfigurationRunsClient.GetByID.
type SoftwareUpdateConfigurationRunsClientGetByIDResponse struct {
	SoftwareUpdateConfigurationRun
}

// SoftwareUpdateConfigurationRunsClientListResponse contains the response from method SoftwareUpdateConfigurationRunsClient.List.
type SoftwareUpdateConfigurationRunsClientListResponse struct {
	SoftwareUpdateConfigurationRunListResult
}

// SoftwareUpdateConfigurationsClientCreateResponse contains the response from method SoftwareUpdateConfigurationsClient.Create.
type SoftwareUpdateConfigurationsClientCreateResponse struct {
	SoftwareUpdateConfiguration
}

// SoftwareUpdateConfigurationsClientDeleteResponse contains the response from method SoftwareUpdateConfigurationsClient.Delete.
type SoftwareUpdateConfigurationsClientDeleteResponse struct {
	// placeholder for future response values
}

// SoftwareUpdateConfigurationsClientGetByNameResponse contains the response from method SoftwareUpdateConfigurationsClient.GetByName.
type SoftwareUpdateConfigurationsClientGetByNameResponse struct {
	SoftwareUpdateConfiguration
}

// SoftwareUpdateConfigurationsClientListResponse contains the response from method SoftwareUpdateConfigurationsClient.List.
type SoftwareUpdateConfigurationsClientListResponse struct {
	SoftwareUpdateConfigurationListResult
}

// SourceControlClientCreateOrUpdateResponse contains the response from method SourceControlClient.CreateOrUpdate.
type SourceControlClientCreateOrUpdateResponse struct {
	SourceControl
}

// SourceControlClientDeleteResponse contains the response from method SourceControlClient.Delete.
type SourceControlClientDeleteResponse struct {
	// placeholder for future response values
}

// SourceControlClientGetResponse contains the response from method SourceControlClient.Get.
type SourceControlClientGetResponse struct {
	SourceControl
}

// SourceControlClientListByAutomationAccountResponse contains the response from method SourceControlClient.ListByAutomationAccount.
type SourceControlClientListByAutomationAccountResponse struct {
	SourceControlListResult
}

// SourceControlClientUpdateResponse contains the response from method SourceControlClient.Update.
type SourceControlClientUpdateResponse struct {
	SourceControl
}

// SourceControlSyncJobClientCreateResponse contains the response from method SourceControlSyncJobClient.Create.
type SourceControlSyncJobClientCreateResponse struct {
	SourceControlSyncJob
}

// SourceControlSyncJobClientGetResponse contains the response from method SourceControlSyncJobClient.Get.
type SourceControlSyncJobClientGetResponse struct {
	SourceControlSyncJobByID
}

// SourceControlSyncJobClientListByAutomationAccountResponse contains the response from method SourceControlSyncJobClient.ListByAutomationAccount.
type SourceControlSyncJobClientListByAutomationAccountResponse struct {
	SourceControlSyncJobListResult
}

// SourceControlSyncJobStreamsClientGetResponse contains the response from method SourceControlSyncJobStreamsClient.Get.
type SourceControlSyncJobStreamsClientGetResponse struct {
	SourceControlSyncJobStreamByID
}

// SourceControlSyncJobStreamsClientListBySyncJobResponse contains the response from method SourceControlSyncJobStreamsClient.ListBySyncJob.
type SourceControlSyncJobStreamsClientListBySyncJobResponse struct {
	SourceControlSyncJobStreamsListBySyncJob
}

// StatisticsClientListByAutomationAccountResponse contains the response from method StatisticsClient.ListByAutomationAccount.
type StatisticsClientListByAutomationAccountResponse struct {
	StatisticsListResult
}

// TestJobClientCreateResponse contains the response from method TestJobClient.Create.
type TestJobClientCreateResponse struct {
	TestJob
}

// TestJobClientGetResponse contains the response from method TestJobClient.Get.
type TestJobClientGetResponse struct {
	TestJob
}

// TestJobClientResumeResponse contains the response from method TestJobClient.Resume.
type TestJobClientResumeResponse struct {
	// placeholder for future response values
}

// TestJobClientStopResponse contains the response from method TestJobClient.Stop.
type TestJobClientStopResponse struct {
	// placeholder for future response values
}

// TestJobClientSuspendResponse contains the response from method TestJobClient.Suspend.
type TestJobClientSuspendResponse struct {
	// placeholder for future response values
}

// TestJobStreamsClientGetResponse contains the response from method TestJobStreamsClient.Get.
type TestJobStreamsClientGetResponse struct {
	JobStream
}

// TestJobStreamsClientListByTestJobResponse contains the response from method TestJobStreamsClient.ListByTestJob.
type TestJobStreamsClientListByTestJobResponse struct {
	JobStreamListResult
}

// UsagesClientListByAutomationAccountResponse contains the response from method UsagesClient.ListByAutomationAccount.
type UsagesClientListByAutomationAccountResponse struct {
	UsageListResult
}

// VariableClientCreateOrUpdateResponse contains the response from method VariableClient.CreateOrUpdate.
type VariableClientCreateOrUpdateResponse struct {
	Variable
}

// VariableClientDeleteResponse contains the response from method VariableClient.Delete.
type VariableClientDeleteResponse struct {
	// placeholder for future response values
}

// VariableClientGetResponse contains the response from method VariableClient.Get.
type VariableClientGetResponse struct {
	Variable
}

// VariableClientListByAutomationAccountResponse contains the response from method VariableClient.ListByAutomationAccount.
type VariableClientListByAutomationAccountResponse struct {
	VariableListResult
}

// VariableClientUpdateResponse contains the response from method VariableClient.Update.
type VariableClientUpdateResponse struct {
	Variable
}

// WatcherClientCreateOrUpdateResponse contains the response from method WatcherClient.CreateOrUpdate.
type WatcherClientCreateOrUpdateResponse struct {
	Watcher
}

// WatcherClientDeleteResponse contains the response from method WatcherClient.Delete.
type WatcherClientDeleteResponse struct {
	// placeholder for future response values
}

// WatcherClientGetResponse contains the response from method WatcherClient.Get.
type WatcherClientGetResponse struct {
	Watcher
}

// WatcherClientListByAutomationAccountResponse contains the response from method WatcherClient.ListByAutomationAccount.
type WatcherClientListByAutomationAccountResponse struct {
	WatcherListResult
}

// WatcherClientStartResponse contains the response from method WatcherClient.Start.
type WatcherClientStartResponse struct {
	// placeholder for future response values
}

// WatcherClientStopResponse contains the response from method WatcherClient.Stop.
type WatcherClientStopResponse struct {
	// placeholder for future response values
}

// WatcherClientUpdateResponse contains the response from method WatcherClient.Update.
type WatcherClientUpdateResponse struct {
	Watcher
}

// WebhookClientCreateOrUpdateResponse contains the response from method WebhookClient.CreateOrUpdate.
type WebhookClientCreateOrUpdateResponse struct {
	Webhook
}

// WebhookClientDeleteResponse contains the response from method WebhookClient.Delete.
type WebhookClientDeleteResponse struct {
	// placeholder for future response values
}

// WebhookClientGenerateURIResponse contains the response from method WebhookClient.GenerateURI.
type WebhookClientGenerateURIResponse struct {
	Value *string
}

// WebhookClientGetResponse contains the response from method WebhookClient.Get.
type WebhookClientGetResponse struct {
	Webhook
}

// WebhookClientListByAutomationAccountResponse contains the response from method WebhookClient.ListByAutomationAccount.
type WebhookClientListByAutomationAccountResponse struct {
	WebhookListResult
}

// WebhookClientUpdateResponse contains the response from method WebhookClient.Update.
type WebhookClientUpdateResponse struct {
	Webhook
}
