//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.
// DO NOT EDIT.

package armbatch

// AccountClientCreateResponse contains the response from method AccountClient.Create.
type AccountClientCreateResponse struct {
	Account
}

// AccountClientDeleteResponse contains the response from method AccountClient.Delete.
type AccountClientDeleteResponse struct {
	// placeholder for future response values
}

// AccountClientGetDetectorResponse contains the response from method AccountClient.GetDetector.
type AccountClientGetDetectorResponse struct {
	DetectorResponse
}

// AccountClientGetKeysResponse contains the response from method AccountClient.GetKeys.
type AccountClientGetKeysResponse struct {
	AccountKeys
}

// AccountClientGetResponse contains the response from method AccountClient.Get.
type AccountClientGetResponse struct {
	Account
}

// AccountClientListByResourceGroupResponse contains the response from method AccountClient.ListByResourceGroup.
type AccountClientListByResourceGroupResponse struct {
	AccountListResult
}

// AccountClientListDetectorsResponse contains the response from method AccountClient.ListDetectors.
type AccountClientListDetectorsResponse struct {
	DetectorListResult
}

// AccountClientListOutboundNetworkDependenciesEndpointsResponse contains the response from method AccountClient.ListOutboundNetworkDependenciesEndpoints.
type AccountClientListOutboundNetworkDependenciesEndpointsResponse struct {
	OutboundEnvironmentEndpointCollection
}

// AccountClientListResponse contains the response from method AccountClient.List.
type AccountClientListResponse struct {
	AccountListResult
}

// AccountClientRegenerateKeyResponse contains the response from method AccountClient.RegenerateKey.
type AccountClientRegenerateKeyResponse struct {
	AccountKeys
}

// AccountClientSynchronizeAutoStorageKeysResponse contains the response from method AccountClient.SynchronizeAutoStorageKeys.
type AccountClientSynchronizeAutoStorageKeysResponse struct {
	// placeholder for future response values
}

// AccountClientUpdateResponse contains the response from method AccountClient.Update.
type AccountClientUpdateResponse struct {
	Account
}

// ApplicationClientCreateResponse contains the response from method ApplicationClient.Create.
type ApplicationClientCreateResponse struct {
	Application
}

// ApplicationClientDeleteResponse contains the response from method ApplicationClient.Delete.
type ApplicationClientDeleteResponse struct {
	// placeholder for future response values
}

// ApplicationClientGetResponse contains the response from method ApplicationClient.Get.
type ApplicationClientGetResponse struct {
	Application
}

// ApplicationClientListResponse contains the response from method ApplicationClient.List.
type ApplicationClientListResponse struct {
	ListApplicationsResult
}

// ApplicationClientUpdateResponse contains the response from method ApplicationClient.Update.
type ApplicationClientUpdateResponse struct {
	Application
}

// ApplicationPackageClientActivateResponse contains the response from method ApplicationPackageClient.Activate.
type ApplicationPackageClientActivateResponse struct {
	ApplicationPackage
}

// ApplicationPackageClientCreateResponse contains the response from method ApplicationPackageClient.Create.
type ApplicationPackageClientCreateResponse struct {
	ApplicationPackage
}

// ApplicationPackageClientDeleteResponse contains the response from method ApplicationPackageClient.Delete.
type ApplicationPackageClientDeleteResponse struct {
	// placeholder for future response values
}

// ApplicationPackageClientGetResponse contains the response from method ApplicationPackageClient.Get.
type ApplicationPackageClientGetResponse struct {
	ApplicationPackage
}

// ApplicationPackageClientListResponse contains the response from method ApplicationPackageClient.List.
type ApplicationPackageClientListResponse struct {
	ListApplicationPackagesResult
}

// CertificateClientCancelDeletionResponse contains the response from method CertificateClient.CancelDeletion.
type CertificateClientCancelDeletionResponse struct {
	Certificate
	// ETag contains the information returned from the ETag header response.
	ETag *string
}

// CertificateClientCreateResponse contains the response from method CertificateClient.Create.
type CertificateClientCreateResponse struct {
	Certificate
	// ETag contains the information returned from the ETag header response.
	ETag *string
}

// CertificateClientDeleteResponse contains the response from method CertificateClient.Delete.
type CertificateClientDeleteResponse struct {
	// placeholder for future response values
}

// CertificateClientGetResponse contains the response from method CertificateClient.Get.
type CertificateClientGetResponse struct {
	Certificate
	// ETag contains the information returned from the ETag header response.
	ETag *string
}

// CertificateClientListByBatchAccountResponse contains the response from method CertificateClient.ListByBatchAccount.
type CertificateClientListByBatchAccountResponse struct {
	ListCertificatesResult
}

// CertificateClientUpdateResponse contains the response from method CertificateClient.Update.
type CertificateClientUpdateResponse struct {
	Certificate
	// ETag contains the information returned from the ETag header response.
	ETag *string
}

// LocationClientCheckNameAvailabilityResponse contains the response from method LocationClient.CheckNameAvailability.
type LocationClientCheckNameAvailabilityResponse struct {
	CheckNameAvailabilityResult
}

// LocationClientGetQuotasResponse contains the response from method LocationClient.GetQuotas.
type LocationClientGetQuotasResponse struct {
	LocationQuota
}

// LocationClientListSupportedCloudServiceSKUsResponse contains the response from method LocationClient.ListSupportedCloudServiceSKUs.
type LocationClientListSupportedCloudServiceSKUsResponse struct {
	SupportedSKUsResult
}

// LocationClientListSupportedVirtualMachineSKUsResponse contains the response from method LocationClient.ListSupportedVirtualMachineSKUs.
type LocationClientListSupportedVirtualMachineSKUsResponse struct {
	SupportedSKUsResult
}

// OperationsClientListResponse contains the response from method OperationsClient.List.
type OperationsClientListResponse struct {
	OperationListResult
}

// PoolClientCreateResponse contains the response from method PoolClient.Create.
type PoolClientCreateResponse struct {
	Pool
	// ETag contains the information returned from the ETag header response.
	ETag *string
}

// PoolClientDeleteResponse contains the response from method PoolClient.Delete.
type PoolClientDeleteResponse struct {
	// placeholder for future response values
}

// PoolClientDisableAutoScaleResponse contains the response from method PoolClient.DisableAutoScale.
type PoolClientDisableAutoScaleResponse struct {
	Pool
	// ETag contains the information returned from the ETag header response.
	ETag *string
}

// PoolClientGetResponse contains the response from method PoolClient.Get.
type PoolClientGetResponse struct {
	Pool
	// ETag contains the information returned from the ETag header response.
	ETag *string
}

// PoolClientListByBatchAccountResponse contains the response from method PoolClient.ListByBatchAccount.
type PoolClientListByBatchAccountResponse struct {
	ListPoolsResult
}

// PoolClientStopResizeResponse contains the response from method PoolClient.StopResize.
type PoolClientStopResizeResponse struct {
	Pool
	// ETag contains the information returned from the ETag header response.
	ETag *string
}

// PoolClientUpdateResponse contains the response from method PoolClient.Update.
type PoolClientUpdateResponse struct {
	Pool
	// ETag contains the information returned from the ETag header response.
	ETag *string
}

// PrivateEndpointConnectionClientDeleteResponse contains the response from method PrivateEndpointConnectionClient.Delete.
type PrivateEndpointConnectionClientDeleteResponse struct {
	// placeholder for future response values
}

// PrivateEndpointConnectionClientGetResponse contains the response from method PrivateEndpointConnectionClient.Get.
type PrivateEndpointConnectionClientGetResponse struct {
	PrivateEndpointConnection
}

// PrivateEndpointConnectionClientListByBatchAccountResponse contains the response from method PrivateEndpointConnectionClient.ListByBatchAccount.
type PrivateEndpointConnectionClientListByBatchAccountResponse struct {
	ListPrivateEndpointConnectionsResult
}

// PrivateEndpointConnectionClientUpdateResponse contains the response from method PrivateEndpointConnectionClient.Update.
type PrivateEndpointConnectionClientUpdateResponse struct {
	PrivateEndpointConnection
}

// PrivateLinkResourceClientGetResponse contains the response from method PrivateLinkResourceClient.Get.
type PrivateLinkResourceClientGetResponse struct {
	PrivateLinkResource
}

// PrivateLinkResourceClientListByBatchAccountResponse contains the response from method PrivateLinkResourceClient.ListByBatchAccount.
type PrivateLinkResourceClientListByBatchAccountResponse struct {
	ListPrivateLinkResourcesResult
}
