//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armdataprotection

// BackupInstancesClientAdhocBackupResponse contains the response from method BackupInstancesClient.AdhocBackup.
type BackupInstancesClientAdhocBackupResponse struct {
	OperationJobExtendedInfo
}

// BackupInstancesClientCreateOrUpdateResponse contains the response from method BackupInstancesClient.CreateOrUpdate.
type BackupInstancesClientCreateOrUpdateResponse struct {
	BackupInstanceResource
}

// BackupInstancesClientDeleteResponse contains the response from method BackupInstancesClient.Delete.
type BackupInstancesClientDeleteResponse struct {
	// placeholder for future response values
}

// BackupInstancesClientGetBackupInstanceOperationResultResponse contains the response from method BackupInstancesClient.GetBackupInstanceOperationResult.
type BackupInstancesClientGetBackupInstanceOperationResultResponse struct {
	BackupInstanceResource
}

// BackupInstancesClientGetResponse contains the response from method BackupInstancesClient.Get.
type BackupInstancesClientGetResponse struct {
	BackupInstanceResource
}

// BackupInstancesClientListResponse contains the response from method BackupInstancesClient.List.
type BackupInstancesClientListResponse struct {
	BackupInstanceResourceList
}

// BackupInstancesClientResumeBackupsResponse contains the response from method BackupInstancesClient.ResumeBackups.
type BackupInstancesClientResumeBackupsResponse struct {
	// placeholder for future response values
}

// BackupInstancesClientResumeProtectionResponse contains the response from method BackupInstancesClient.ResumeProtection.
type BackupInstancesClientResumeProtectionResponse struct {
	// placeholder for future response values
}

// BackupInstancesClientStopProtectionResponse contains the response from method BackupInstancesClient.StopProtection.
type BackupInstancesClientStopProtectionResponse struct {
	// placeholder for future response values
}

// BackupInstancesClientSuspendBackupsResponse contains the response from method BackupInstancesClient.SuspendBackups.
type BackupInstancesClientSuspendBackupsResponse struct {
	// placeholder for future response values
}

// BackupInstancesClientSyncBackupInstanceResponse contains the response from method BackupInstancesClient.SyncBackupInstance.
type BackupInstancesClientSyncBackupInstanceResponse struct {
	// placeholder for future response values
}

// BackupInstancesClientTriggerRehydrateResponse contains the response from method BackupInstancesClient.TriggerRehydrate.
type BackupInstancesClientTriggerRehydrateResponse struct {
	// placeholder for future response values
}

// BackupInstancesClientTriggerRestoreResponse contains the response from method BackupInstancesClient.TriggerRestore.
type BackupInstancesClientTriggerRestoreResponse struct {
	OperationJobExtendedInfo
}

// BackupInstancesClientValidateForBackupResponse contains the response from method BackupInstancesClient.ValidateForBackup.
type BackupInstancesClientValidateForBackupResponse struct {
	OperationJobExtendedInfo
}

// BackupInstancesClientValidateForRestoreResponse contains the response from method BackupInstancesClient.ValidateForRestore.
type BackupInstancesClientValidateForRestoreResponse struct {
	OperationJobExtendedInfo
}

// BackupPoliciesClientCreateOrUpdateResponse contains the response from method BackupPoliciesClient.CreateOrUpdate.
type BackupPoliciesClientCreateOrUpdateResponse struct {
	BaseBackupPolicyResource
}

// BackupPoliciesClientDeleteResponse contains the response from method BackupPoliciesClient.Delete.
type BackupPoliciesClientDeleteResponse struct {
	// placeholder for future response values
}

// BackupPoliciesClientGetResponse contains the response from method BackupPoliciesClient.Get.
type BackupPoliciesClientGetResponse struct {
	BaseBackupPolicyResource
}

// BackupPoliciesClientListResponse contains the response from method BackupPoliciesClient.List.
type BackupPoliciesClientListResponse struct {
	BaseBackupPolicyResourceList
}

// BackupVaultOperationResultsClientGetResponse contains the response from method BackupVaultOperationResultsClient.Get.
type BackupVaultOperationResultsClientGetResponse struct {
	BackupVaultResource
	// AzureAsyncOperation contains the information returned from the Azure-AsyncOperation header response.
	AzureAsyncOperation *string

	// Location contains the information returned from the Location header response.
	Location *string

	// RetryAfter contains the information returned from the Retry-After header response.
	RetryAfter *int32
}

// BackupVaultsClientCheckNameAvailabilityResponse contains the response from method BackupVaultsClient.CheckNameAvailability.
type BackupVaultsClientCheckNameAvailabilityResponse struct {
	CheckNameAvailabilityResult
}

// BackupVaultsClientCreateOrUpdateResponse contains the response from method BackupVaultsClient.CreateOrUpdate.
type BackupVaultsClientCreateOrUpdateResponse struct {
	BackupVaultResource
}

// BackupVaultsClientDeleteResponse contains the response from method BackupVaultsClient.Delete.
type BackupVaultsClientDeleteResponse struct {
	// placeholder for future response values
}

// BackupVaultsClientGetInResourceGroupResponse contains the response from method BackupVaultsClient.GetInResourceGroup.
type BackupVaultsClientGetInResourceGroupResponse struct {
	BackupVaultResourceList
}

// BackupVaultsClientGetInSubscriptionResponse contains the response from method BackupVaultsClient.GetInSubscription.
type BackupVaultsClientGetInSubscriptionResponse struct {
	BackupVaultResourceList
}

// BackupVaultsClientGetResponse contains the response from method BackupVaultsClient.Get.
type BackupVaultsClientGetResponse struct {
	BackupVaultResource
}

// BackupVaultsClientUpdateResponse contains the response from method BackupVaultsClient.Update.
type BackupVaultsClientUpdateResponse struct {
	BackupVaultResource
}

// ClientCheckFeatureSupportResponse contains the response from method Client.CheckFeatureSupport.
type ClientCheckFeatureSupportResponse struct {
	FeatureValidationResponseBaseClassification
}

// UnmarshalJSON implements the json.Unmarshaller interface for type ClientCheckFeatureSupportResponse.
func (c *ClientCheckFeatureSupportResponse) UnmarshalJSON(data []byte) error {
	res, err := unmarshalFeatureValidationResponseBaseClassification(data)
	if err != nil {
		return err
	}
	c.FeatureValidationResponseBaseClassification = res
	return nil
}

// ExportJobsClientTriggerResponse contains the response from method ExportJobsClient.Trigger.
type ExportJobsClientTriggerResponse struct {
	// placeholder for future response values
}

// ExportJobsOperationResultClientGetResponse contains the response from method ExportJobsOperationResultClient.Get.
type ExportJobsOperationResultClientGetResponse struct {
	ExportJobsResult
}

// JobsClientGetResponse contains the response from method JobsClient.Get.
type JobsClientGetResponse struct {
	AzureBackupJobResource
}

// JobsClientListResponse contains the response from method JobsClient.List.
type JobsClientListResponse struct {
	AzureBackupJobResourceList
}

// OperationResultClientGetResponse contains the response from method OperationResultClient.Get.
type OperationResultClientGetResponse struct {
	OperationJobExtendedInfo
	// AzureAsyncOperation contains the information returned from the Azure-AsyncOperation header response.
	AzureAsyncOperation *string

	// Location contains the information returned from the Location header response.
	Location *string

	// RetryAfter contains the information returned from the Retry-After header response.
	RetryAfter *int32
}

// OperationStatusBackupVaultContextClientGetResponse contains the response from method OperationStatusBackupVaultContextClient.Get.
type OperationStatusBackupVaultContextClientGetResponse struct {
	OperationResource
}

// OperationStatusClientGetResponse contains the response from method OperationStatusClient.Get.
type OperationStatusClientGetResponse struct {
	OperationResource
}

// OperationStatusResourceGroupContextClientGetResponse contains the response from method OperationStatusResourceGroupContextClient.Get.
type OperationStatusResourceGroupContextClientGetResponse struct {
	OperationResource
}

// OperationsClientListResponse contains the response from method OperationsClient.List.
type OperationsClientListResponse struct {
	ClientDiscoveryResponse
}

// RecoveryPointsClientGetResponse contains the response from method RecoveryPointsClient.Get.
type RecoveryPointsClientGetResponse struct {
	AzureBackupRecoveryPointResource
}

// RecoveryPointsClientListResponse contains the response from method RecoveryPointsClient.List.
type RecoveryPointsClientListResponse struct {
	AzureBackupRecoveryPointResourceList
}

// ResourceGuardsClientDeleteResponse contains the response from method ResourceGuardsClient.Delete.
type ResourceGuardsClientDeleteResponse struct {
	// placeholder for future response values
}

// ResourceGuardsClientGetBackupSecurityPINRequestsObjectsResponse contains the response from method ResourceGuardsClient.GetBackupSecurityPINRequestsObjects.
type ResourceGuardsClientGetBackupSecurityPINRequestsObjectsResponse struct {
	DppBaseResourceList
}

// ResourceGuardsClientGetDefaultBackupSecurityPINRequestsObjectResponse contains the response from method ResourceGuardsClient.GetDefaultBackupSecurityPINRequestsObject.
type ResourceGuardsClientGetDefaultBackupSecurityPINRequestsObjectResponse struct {
	DppBaseResource
}

// ResourceGuardsClientGetDefaultDeleteProtectedItemRequestsObjectResponse contains the response from method ResourceGuardsClient.GetDefaultDeleteProtectedItemRequestsObject.
type ResourceGuardsClientGetDefaultDeleteProtectedItemRequestsObjectResponse struct {
	DppBaseResource
}

// ResourceGuardsClientGetDefaultDeleteResourceGuardProxyRequestsObjectResponse contains the response from method ResourceGuardsClient.GetDefaultDeleteResourceGuardProxyRequestsObject.
type ResourceGuardsClientGetDefaultDeleteResourceGuardProxyRequestsObjectResponse struct {
	DppBaseResource
}

// ResourceGuardsClientGetDefaultDisableSoftDeleteRequestsObjectResponse contains the response from method ResourceGuardsClient.GetDefaultDisableSoftDeleteRequestsObject.
type ResourceGuardsClientGetDefaultDisableSoftDeleteRequestsObjectResponse struct {
	DppBaseResource
}

// ResourceGuardsClientGetDefaultUpdateProtectedItemRequestsObjectResponse contains the response from method ResourceGuardsClient.GetDefaultUpdateProtectedItemRequestsObject.
type ResourceGuardsClientGetDefaultUpdateProtectedItemRequestsObjectResponse struct {
	DppBaseResource
}

// ResourceGuardsClientGetDefaultUpdateProtectionPolicyRequestsObjectResponse contains the response from method ResourceGuardsClient.GetDefaultUpdateProtectionPolicyRequestsObject.
type ResourceGuardsClientGetDefaultUpdateProtectionPolicyRequestsObjectResponse struct {
	DppBaseResource
}

// ResourceGuardsClientGetDeleteProtectedItemRequestsObjectsResponse contains the response from method ResourceGuardsClient.GetDeleteProtectedItemRequestsObjects.
type ResourceGuardsClientGetDeleteProtectedItemRequestsObjectsResponse struct {
	DppBaseResourceList
}

// ResourceGuardsClientGetDeleteResourceGuardProxyRequestsObjectsResponse contains the response from method ResourceGuardsClient.GetDeleteResourceGuardProxyRequestsObjects.
type ResourceGuardsClientGetDeleteResourceGuardProxyRequestsObjectsResponse struct {
	DppBaseResourceList
}

// ResourceGuardsClientGetDisableSoftDeleteRequestsObjectsResponse contains the response from method ResourceGuardsClient.GetDisableSoftDeleteRequestsObjects.
type ResourceGuardsClientGetDisableSoftDeleteRequestsObjectsResponse struct {
	DppBaseResourceList
}

// ResourceGuardsClientGetResourcesInResourceGroupResponse contains the response from method ResourceGuardsClient.GetResourcesInResourceGroup.
type ResourceGuardsClientGetResourcesInResourceGroupResponse struct {
	ResourceGuardResourceList
}

// ResourceGuardsClientGetResourcesInSubscriptionResponse contains the response from method ResourceGuardsClient.GetResourcesInSubscription.
type ResourceGuardsClientGetResourcesInSubscriptionResponse struct {
	ResourceGuardResourceList
}

// ResourceGuardsClientGetResponse contains the response from method ResourceGuardsClient.Get.
type ResourceGuardsClientGetResponse struct {
	ResourceGuardResource
}

// ResourceGuardsClientGetUpdateProtectedItemRequestsObjectsResponse contains the response from method ResourceGuardsClient.GetUpdateProtectedItemRequestsObjects.
type ResourceGuardsClientGetUpdateProtectedItemRequestsObjectsResponse struct {
	DppBaseResourceList
}

// ResourceGuardsClientGetUpdateProtectionPolicyRequestsObjectsResponse contains the response from method ResourceGuardsClient.GetUpdateProtectionPolicyRequestsObjects.
type ResourceGuardsClientGetUpdateProtectionPolicyRequestsObjectsResponse struct {
	DppBaseResourceList
}

// ResourceGuardsClientPatchResponse contains the response from method ResourceGuardsClient.Patch.
type ResourceGuardsClientPatchResponse struct {
	ResourceGuardResource
}

// ResourceGuardsClientPutResponse contains the response from method ResourceGuardsClient.Put.
type ResourceGuardsClientPutResponse struct {
	ResourceGuardResource
}

// RestorableTimeRangesClientFindResponse contains the response from method RestorableTimeRangesClient.Find.
type RestorableTimeRangesClientFindResponse struct {
	AzureBackupFindRestorableTimeRangesResponseResource
}
