//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armhybridnetwork

// DevicesClientCreateOrUpdateResponse contains the response from method DevicesClient.CreateOrUpdate.
type DevicesClientCreateOrUpdateResponse struct {
	Device
}

// DevicesClientDeleteResponse contains the response from method DevicesClient.Delete.
type DevicesClientDeleteResponse struct {
	// placeholder for future response values
}

// DevicesClientGetResponse contains the response from method DevicesClient.Get.
type DevicesClientGetResponse struct {
	Device
}

// DevicesClientListByResourceGroupResponse contains the response from method DevicesClient.ListByResourceGroup.
type DevicesClientListByResourceGroupResponse struct {
	DeviceListResult
}

// DevicesClientListBySubscriptionResponse contains the response from method DevicesClient.ListBySubscription.
type DevicesClientListBySubscriptionResponse struct {
	DeviceListResult
}

// DevicesClientListRegistrationKeyResponse contains the response from method DevicesClient.ListRegistrationKey.
type DevicesClientListRegistrationKeyResponse struct {
	DeviceRegistrationKey
}

// DevicesClientUpdateTagsResponse contains the response from method DevicesClient.UpdateTags.
type DevicesClientUpdateTagsResponse struct {
	Device
}

// NetworkFunctionVendorSKUsClientListBySKUResponse contains the response from method NetworkFunctionVendorSKUsClient.ListBySKU.
type NetworkFunctionVendorSKUsClientListBySKUResponse struct {
	NetworkFunctionSKUDetails
}

// NetworkFunctionVendorSKUsClientListByVendorResponse contains the response from method NetworkFunctionVendorSKUsClient.ListByVendor.
type NetworkFunctionVendorSKUsClientListByVendorResponse struct {
	NetworkFunctionSKUListResult
}

// NetworkFunctionVendorsClientListResponse contains the response from method NetworkFunctionVendorsClient.List.
type NetworkFunctionVendorsClientListResponse struct {
	NetworkFunctionVendorListResult
}

// NetworkFunctionsClientCreateOrUpdateResponse contains the response from method NetworkFunctionsClient.CreateOrUpdate.
type NetworkFunctionsClientCreateOrUpdateResponse struct {
	NetworkFunction
}

// NetworkFunctionsClientDeleteResponse contains the response from method NetworkFunctionsClient.Delete.
type NetworkFunctionsClientDeleteResponse struct {
	// placeholder for future response values
}

// NetworkFunctionsClientExecuteRequestResponse contains the response from method NetworkFunctionsClient.ExecuteRequest.
type NetworkFunctionsClientExecuteRequestResponse struct {
	// placeholder for future response values
}

// NetworkFunctionsClientGetResponse contains the response from method NetworkFunctionsClient.Get.
type NetworkFunctionsClientGetResponse struct {
	NetworkFunction
}

// NetworkFunctionsClientListByResourceGroupResponse contains the response from method NetworkFunctionsClient.ListByResourceGroup.
type NetworkFunctionsClientListByResourceGroupResponse struct {
	NetworkFunctionListResult
}

// NetworkFunctionsClientListBySubscriptionResponse contains the response from method NetworkFunctionsClient.ListBySubscription.
type NetworkFunctionsClientListBySubscriptionResponse struct {
	NetworkFunctionListResult
}

// NetworkFunctionsClientUpdateTagsResponse contains the response from method NetworkFunctionsClient.UpdateTags.
type NetworkFunctionsClientUpdateTagsResponse struct {
	NetworkFunction
}

// OperationsClientListResponse contains the response from method OperationsClient.List.
type OperationsClientListResponse struct {
	OperationListResult
}

// RoleInstancesClientGetResponse contains the response from method RoleInstancesClient.Get.
type RoleInstancesClientGetResponse struct {
	RoleInstance
}

// RoleInstancesClientListResponse contains the response from method RoleInstancesClient.List.
type RoleInstancesClientListResponse struct {
	NetworkFunctionRoleInstanceListResult
}

// RoleInstancesClientRestartResponse contains the response from method RoleInstancesClient.Restart.
type RoleInstancesClientRestartResponse struct {
	// placeholder for future response values
}

// RoleInstancesClientStartResponse contains the response from method RoleInstancesClient.Start.
type RoleInstancesClientStartResponse struct {
	// placeholder for future response values
}

// RoleInstancesClientStopResponse contains the response from method RoleInstancesClient.Stop.
type RoleInstancesClientStopResponse struct {
	// placeholder for future response values
}

// VendorNetworkFunctionsClientCreateOrUpdateResponse contains the response from method VendorNetworkFunctionsClient.CreateOrUpdate.
type VendorNetworkFunctionsClientCreateOrUpdateResponse struct {
	VendorNetworkFunction
}

// VendorNetworkFunctionsClientGetResponse contains the response from method VendorNetworkFunctionsClient.Get.
type VendorNetworkFunctionsClientGetResponse struct {
	VendorNetworkFunction
}

// VendorNetworkFunctionsClientListResponse contains the response from method VendorNetworkFunctionsClient.List.
type VendorNetworkFunctionsClientListResponse struct {
	VendorNetworkFunctionListResult
}

// VendorSKUPreviewClientCreateOrUpdateResponse contains the response from method VendorSKUPreviewClient.CreateOrUpdate.
type VendorSKUPreviewClientCreateOrUpdateResponse struct {
	PreviewSubscription
}

// VendorSKUPreviewClientDeleteResponse contains the response from method VendorSKUPreviewClient.Delete.
type VendorSKUPreviewClientDeleteResponse struct {
	// placeholder for future response values
}

// VendorSKUPreviewClientGetResponse contains the response from method VendorSKUPreviewClient.Get.
type VendorSKUPreviewClientGetResponse struct {
	PreviewSubscription
}

// VendorSKUPreviewClientListResponse contains the response from method VendorSKUPreviewClient.List.
type VendorSKUPreviewClientListResponse struct {
	PreviewSubscriptionsList
}

// VendorSKUsClientCreateOrUpdateResponse contains the response from method VendorSKUsClient.CreateOrUpdate.
type VendorSKUsClientCreateOrUpdateResponse struct {
	VendorSKU
}

// VendorSKUsClientDeleteResponse contains the response from method VendorSKUsClient.Delete.
type VendorSKUsClientDeleteResponse struct {
	// placeholder for future response values
}

// VendorSKUsClientGetResponse contains the response from method VendorSKUsClient.Get.
type VendorSKUsClientGetResponse struct {
	VendorSKU
}

// VendorSKUsClientListCredentialResponse contains the response from method VendorSKUsClient.ListCredential.
type VendorSKUsClientListCredentialResponse struct {
	SKUCredential
}

// VendorSKUsClientListResponse contains the response from method VendorSKUsClient.List.
type VendorSKUsClientListResponse struct {
	VendorSKUListResult
}

// VendorsClientCreateOrUpdateResponse contains the response from method VendorsClient.CreateOrUpdate.
type VendorsClientCreateOrUpdateResponse struct {
	Vendor
}

// VendorsClientDeleteResponse contains the response from method VendorsClient.Delete.
type VendorsClientDeleteResponse struct {
	// placeholder for future response values
}

// VendorsClientGetResponse contains the response from method VendorsClient.Get.
type VendorsClientGetResponse struct {
	Vendor
}

// VendorsClientListBySubscriptionResponse contains the response from method VendorsClient.ListBySubscription.
type VendorsClientListBySubscriptionResponse struct {
	VendorListResult
}
