//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armkeyvault

// KeysClientCreateIfNotExistResponse contains the response from method KeysClient.CreateIfNotExist.
type KeysClientCreateIfNotExistResponse struct {
	Key
}

// KeysClientGetResponse contains the response from method KeysClient.Get.
type KeysClientGetResponse struct {
	Key
}

// KeysClientGetVersionResponse contains the response from method KeysClient.GetVersion.
type KeysClientGetVersionResponse struct {
	Key
}

// KeysClientListResponse contains the response from method KeysClient.List.
type KeysClientListResponse struct {
	KeyListResult
}

// KeysClientListVersionsResponse contains the response from method KeysClient.ListVersions.
type KeysClientListVersionsResponse struct {
	KeyListResult
}

// MHSMPrivateEndpointConnectionsClientDeleteResponse contains the response from method MHSMPrivateEndpointConnectionsClient.Delete.
type MHSMPrivateEndpointConnectionsClientDeleteResponse struct {
	MHSMPrivateEndpointConnection
}

// MHSMPrivateEndpointConnectionsClientGetResponse contains the response from method MHSMPrivateEndpointConnectionsClient.Get.
type MHSMPrivateEndpointConnectionsClientGetResponse struct {
	MHSMPrivateEndpointConnection
}

// MHSMPrivateEndpointConnectionsClientListByResourceResponse contains the response from method MHSMPrivateEndpointConnectionsClient.ListByResource.
type MHSMPrivateEndpointConnectionsClientListByResourceResponse struct {
	MHSMPrivateEndpointConnectionsListResult
}

// MHSMPrivateEndpointConnectionsClientPutResponse contains the response from method MHSMPrivateEndpointConnectionsClient.Put.
type MHSMPrivateEndpointConnectionsClientPutResponse struct {
	MHSMPrivateEndpointConnection
	// AzureAsyncOperation contains the information returned from the Azure-AsyncOperation header response.
	AzureAsyncOperation *string

	// RetryAfter contains the information returned from the Retry-After header response.
	RetryAfter *int32
}

// MHSMPrivateLinkResourcesClientListByMHSMResourceResponse contains the response from method MHSMPrivateLinkResourcesClient.ListByMHSMResource.
type MHSMPrivateLinkResourcesClientListByMHSMResourceResponse struct {
	MHSMPrivateLinkResourceListResult
}

// ManagedHsmsClientCreateOrUpdateResponse contains the response from method ManagedHsmsClient.CreateOrUpdate.
type ManagedHsmsClientCreateOrUpdateResponse struct {
	ManagedHsm
}

// ManagedHsmsClientDeleteResponse contains the response from method ManagedHsmsClient.Delete.
type ManagedHsmsClientDeleteResponse struct {
	// placeholder for future response values
}

// ManagedHsmsClientGetDeletedResponse contains the response from method ManagedHsmsClient.GetDeleted.
type ManagedHsmsClientGetDeletedResponse struct {
	DeletedManagedHsm
}

// ManagedHsmsClientGetResponse contains the response from method ManagedHsmsClient.Get.
type ManagedHsmsClientGetResponse struct {
	ManagedHsm
}

// ManagedHsmsClientListByResourceGroupResponse contains the response from method ManagedHsmsClient.ListByResourceGroup.
type ManagedHsmsClientListByResourceGroupResponse struct {
	ManagedHsmListResult
}

// ManagedHsmsClientListBySubscriptionResponse contains the response from method ManagedHsmsClient.ListBySubscription.
type ManagedHsmsClientListBySubscriptionResponse struct {
	ManagedHsmListResult
}

// ManagedHsmsClientListDeletedResponse contains the response from method ManagedHsmsClient.ListDeleted.
type ManagedHsmsClientListDeletedResponse struct {
	DeletedManagedHsmListResult
}

// ManagedHsmsClientPurgeDeletedResponse contains the response from method ManagedHsmsClient.PurgeDeleted.
type ManagedHsmsClientPurgeDeletedResponse struct {
	// placeholder for future response values
}

// ManagedHsmsClientUpdateResponse contains the response from method ManagedHsmsClient.Update.
type ManagedHsmsClientUpdateResponse struct {
	ManagedHsm
}

// OperationsClientListResponse contains the response from method OperationsClient.List.
type OperationsClientListResponse struct {
	OperationListResult
}

// PrivateEndpointConnectionsClientDeleteResponse contains the response from method PrivateEndpointConnectionsClient.Delete.
type PrivateEndpointConnectionsClientDeleteResponse struct {
	PrivateEndpointConnection
}

// PrivateEndpointConnectionsClientGetResponse contains the response from method PrivateEndpointConnectionsClient.Get.
type PrivateEndpointConnectionsClientGetResponse struct {
	PrivateEndpointConnection
}

// PrivateEndpointConnectionsClientListByResourceResponse contains the response from method PrivateEndpointConnectionsClient.ListByResource.
type PrivateEndpointConnectionsClientListByResourceResponse struct {
	PrivateEndpointConnectionListResult
}

// PrivateEndpointConnectionsClientPutResponse contains the response from method PrivateEndpointConnectionsClient.Put.
type PrivateEndpointConnectionsClientPutResponse struct {
	PrivateEndpointConnection
	// AzureAsyncOperation contains the information returned from the Azure-AsyncOperation header response.
	AzureAsyncOperation *string

	// RetryAfter contains the information returned from the Retry-After header response.
	RetryAfter *int32
}

// PrivateLinkResourcesClientListByVaultResponse contains the response from method PrivateLinkResourcesClient.ListByVault.
type PrivateLinkResourcesClientListByVaultResponse struct {
	PrivateLinkResourceListResult
}

// SecretsClientCreateOrUpdateResponse contains the response from method SecretsClient.CreateOrUpdate.
type SecretsClientCreateOrUpdateResponse struct {
	Secret
}

// SecretsClientGetResponse contains the response from method SecretsClient.Get.
type SecretsClientGetResponse struct {
	Secret
}

// SecretsClientListResponse contains the response from method SecretsClient.List.
type SecretsClientListResponse struct {
	SecretListResult
}

// SecretsClientUpdateResponse contains the response from method SecretsClient.Update.
type SecretsClientUpdateResponse struct {
	Secret
}

// VaultsClientCheckNameAvailabilityResponse contains the response from method VaultsClient.CheckNameAvailability.
type VaultsClientCheckNameAvailabilityResponse struct {
	CheckNameAvailabilityResult
}

// VaultsClientCreateOrUpdateResponse contains the response from method VaultsClient.CreateOrUpdate.
type VaultsClientCreateOrUpdateResponse struct {
	Vault
}

// VaultsClientDeleteResponse contains the response from method VaultsClient.Delete.
type VaultsClientDeleteResponse struct {
	// placeholder for future response values
}

// VaultsClientGetDeletedResponse contains the response from method VaultsClient.GetDeleted.
type VaultsClientGetDeletedResponse struct {
	DeletedVault
}

// VaultsClientGetResponse contains the response from method VaultsClient.Get.
type VaultsClientGetResponse struct {
	Vault
}

// VaultsClientListByResourceGroupResponse contains the response from method VaultsClient.ListByResourceGroup.
type VaultsClientListByResourceGroupResponse struct {
	VaultListResult
}

// VaultsClientListBySubscriptionResponse contains the response from method VaultsClient.ListBySubscription.
type VaultsClientListBySubscriptionResponse struct {
	VaultListResult
}

// VaultsClientListDeletedResponse contains the response from method VaultsClient.ListDeleted.
type VaultsClientListDeletedResponse struct {
	DeletedVaultListResult
}

// VaultsClientListResponse contains the response from method VaultsClient.List.
type VaultsClientListResponse struct {
	ResourceListResult
}

// VaultsClientPurgeDeletedResponse contains the response from method VaultsClient.PurgeDeleted.
type VaultsClientPurgeDeletedResponse struct {
	// placeholder for future response values
}

// VaultsClientUpdateAccessPolicyResponse contains the response from method VaultsClient.UpdateAccessPolicy.
type VaultsClientUpdateAccessPolicyResponse struct {
	VaultAccessPolicyParameters
}

// VaultsClientUpdateResponse contains the response from method VaultsClient.Update.
type VaultsClientUpdateResponse struct {
	Vault
}
