//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.
// DO NOT EDIT.

package armmediaservices

// AccountFiltersClientCreateOrUpdateResponse contains the response from method AccountFiltersClient.CreateOrUpdate.
type AccountFiltersClientCreateOrUpdateResponse struct {
	AccountFilter
}

// AccountFiltersClientDeleteResponse contains the response from method AccountFiltersClient.Delete.
type AccountFiltersClientDeleteResponse struct {
	// placeholder for future response values
}

// AccountFiltersClientGetResponse contains the response from method AccountFiltersClient.Get.
type AccountFiltersClientGetResponse struct {
	AccountFilter
}

// AccountFiltersClientListResponse contains the response from method AccountFiltersClient.List.
type AccountFiltersClientListResponse struct {
	AccountFilterCollection
}

// AccountFiltersClientUpdateResponse contains the response from method AccountFiltersClient.Update.
type AccountFiltersClientUpdateResponse struct {
	AccountFilter
}

// AssetFiltersClientCreateOrUpdateResponse contains the response from method AssetFiltersClient.CreateOrUpdate.
type AssetFiltersClientCreateOrUpdateResponse struct {
	AssetFilter
}

// AssetFiltersClientDeleteResponse contains the response from method AssetFiltersClient.Delete.
type AssetFiltersClientDeleteResponse struct {
	// placeholder for future response values
}

// AssetFiltersClientGetResponse contains the response from method AssetFiltersClient.Get.
type AssetFiltersClientGetResponse struct {
	AssetFilter
}

// AssetFiltersClientListResponse contains the response from method AssetFiltersClient.List.
type AssetFiltersClientListResponse struct {
	AssetFilterCollection
}

// AssetFiltersClientUpdateResponse contains the response from method AssetFiltersClient.Update.
type AssetFiltersClientUpdateResponse struct {
	AssetFilter
}

// AssetTrackOperationResultsClientGetResponse contains the response from method AssetTrackOperationResultsClient.Get.
type AssetTrackOperationResultsClientGetResponse struct {
	AssetTrack
	// AzureAsyncOperation contains the information returned from the Azure-AsyncOperation header response.
	AzureAsyncOperation *string

	// Location contains the information returned from the Location header response.
	Location *string

	// RetryAfter contains the information returned from the Retry-After header response.
	RetryAfter *int32
}

// AssetTrackOperationStatusesClientGetResponse contains the response from method AssetTrackOperationStatusesClient.Get.
type AssetTrackOperationStatusesClientGetResponse struct {
	AssetTrackOperationStatus
}

// AssetsClientCreateOrUpdateResponse contains the response from method AssetsClient.CreateOrUpdate.
type AssetsClientCreateOrUpdateResponse struct {
	Asset
}

// AssetsClientDeleteResponse contains the response from method AssetsClient.Delete.
type AssetsClientDeleteResponse struct {
	// placeholder for future response values
}

// AssetsClientGetEncryptionKeyResponse contains the response from method AssetsClient.GetEncryptionKey.
type AssetsClientGetEncryptionKeyResponse struct {
	StorageEncryptedAssetDecryptionData
}

// AssetsClientGetResponse contains the response from method AssetsClient.Get.
type AssetsClientGetResponse struct {
	Asset
}

// AssetsClientListContainerSasResponse contains the response from method AssetsClient.ListContainerSas.
type AssetsClientListContainerSasResponse struct {
	AssetContainerSas
}

// AssetsClientListResponse contains the response from method AssetsClient.List.
type AssetsClientListResponse struct {
	AssetCollection
}

// AssetsClientListStreamingLocatorsResponse contains the response from method AssetsClient.ListStreamingLocators.
type AssetsClientListStreamingLocatorsResponse struct {
	ListStreamingLocatorsResponse
}

// AssetsClientUpdateResponse contains the response from method AssetsClient.Update.
type AssetsClientUpdateResponse struct {
	Asset
}

// ClientCreateOrUpdateResponse contains the response from method Client.CreateOrUpdate.
type ClientCreateOrUpdateResponse struct {
	MediaService
}

// ClientDeleteResponse contains the response from method Client.Delete.
type ClientDeleteResponse struct {
	// placeholder for future response values
}

// ClientGetResponse contains the response from method Client.Get.
type ClientGetResponse struct {
	MediaService
}

// ClientListBySubscriptionResponse contains the response from method Client.ListBySubscription.
type ClientListBySubscriptionResponse struct {
	MediaServiceCollection
}

// ClientListEdgePoliciesResponse contains the response from method Client.ListEdgePolicies.
type ClientListEdgePoliciesResponse struct {
	EdgePolicies
}

// ClientListResponse contains the response from method Client.List.
type ClientListResponse struct {
	MediaServiceCollection
}

// ClientSyncStorageKeysResponse contains the response from method Client.SyncStorageKeys.
type ClientSyncStorageKeysResponse struct {
	// placeholder for future response values
}

// ClientUpdateResponse contains the response from method Client.Update.
type ClientUpdateResponse struct {
	MediaService
}

// ContentKeyPoliciesClientCreateOrUpdateResponse contains the response from method ContentKeyPoliciesClient.CreateOrUpdate.
type ContentKeyPoliciesClientCreateOrUpdateResponse struct {
	ContentKeyPolicy
}

// ContentKeyPoliciesClientDeleteResponse contains the response from method ContentKeyPoliciesClient.Delete.
type ContentKeyPoliciesClientDeleteResponse struct {
	// placeholder for future response values
}

// ContentKeyPoliciesClientGetPolicyPropertiesWithSecretsResponse contains the response from method ContentKeyPoliciesClient.GetPolicyPropertiesWithSecrets.
type ContentKeyPoliciesClientGetPolicyPropertiesWithSecretsResponse struct {
	ContentKeyPolicyProperties
}

// ContentKeyPoliciesClientGetResponse contains the response from method ContentKeyPoliciesClient.Get.
type ContentKeyPoliciesClientGetResponse struct {
	ContentKeyPolicy
}

// ContentKeyPoliciesClientListResponse contains the response from method ContentKeyPoliciesClient.List.
type ContentKeyPoliciesClientListResponse struct {
	ContentKeyPolicyCollection
}

// ContentKeyPoliciesClientUpdateResponse contains the response from method ContentKeyPoliciesClient.Update.
type ContentKeyPoliciesClientUpdateResponse struct {
	ContentKeyPolicy
}

// JobsClientCancelJobResponse contains the response from method JobsClient.CancelJob.
type JobsClientCancelJobResponse struct {
	// placeholder for future response values
}

// JobsClientCreateResponse contains the response from method JobsClient.Create.
type JobsClientCreateResponse struct {
	Job
}

// JobsClientDeleteResponse contains the response from method JobsClient.Delete.
type JobsClientDeleteResponse struct {
	// placeholder for future response values
}

// JobsClientGetResponse contains the response from method JobsClient.Get.
type JobsClientGetResponse struct {
	Job
}

// JobsClientListResponse contains the response from method JobsClient.List.
type JobsClientListResponse struct {
	JobCollection
}

// JobsClientUpdateResponse contains the response from method JobsClient.Update.
type JobsClientUpdateResponse struct {
	Job
}

// LiveEventsClientAllocateResponse contains the response from method LiveEventsClient.Allocate.
type LiveEventsClientAllocateResponse struct {
	// placeholder for future response values
}

// LiveEventsClientAsyncOperationResponse contains the response from method LiveEventsClient.AsyncOperation.
type LiveEventsClientAsyncOperationResponse struct {
	AsyncOperationResult
}

// LiveEventsClientCreateResponse contains the response from method LiveEventsClient.Create.
type LiveEventsClientCreateResponse struct {
	LiveEvent
}

// LiveEventsClientDeleteResponse contains the response from method LiveEventsClient.Delete.
type LiveEventsClientDeleteResponse struct {
	// placeholder for future response values
}

// LiveEventsClientGetResponse contains the response from method LiveEventsClient.Get.
type LiveEventsClientGetResponse struct {
	LiveEvent
}

// LiveEventsClientListResponse contains the response from method LiveEventsClient.List.
type LiveEventsClientListResponse struct {
	LiveEventListResult
}

// LiveEventsClientOperationLocationResponse contains the response from method LiveEventsClient.OperationLocation.
type LiveEventsClientOperationLocationResponse struct {
	LiveEvent
}

// LiveEventsClientResetResponse contains the response from method LiveEventsClient.Reset.
type LiveEventsClientResetResponse struct {
	// placeholder for future response values
}

// LiveEventsClientStartResponse contains the response from method LiveEventsClient.Start.
type LiveEventsClientStartResponse struct {
	// placeholder for future response values
}

// LiveEventsClientStopResponse contains the response from method LiveEventsClient.Stop.
type LiveEventsClientStopResponse struct {
	// placeholder for future response values
}

// LiveEventsClientUpdateResponse contains the response from method LiveEventsClient.Update.
type LiveEventsClientUpdateResponse struct {
	LiveEvent
}

// LiveOutputsClientAsyncOperationResponse contains the response from method LiveOutputsClient.AsyncOperation.
type LiveOutputsClientAsyncOperationResponse struct {
	AsyncOperationResult
}

// LiveOutputsClientCreateResponse contains the response from method LiveOutputsClient.Create.
type LiveOutputsClientCreateResponse struct {
	LiveOutput
}

// LiveOutputsClientDeleteResponse contains the response from method LiveOutputsClient.Delete.
type LiveOutputsClientDeleteResponse struct {
	// placeholder for future response values
}

// LiveOutputsClientGetResponse contains the response from method LiveOutputsClient.Get.
type LiveOutputsClientGetResponse struct {
	LiveOutput
}

// LiveOutputsClientListResponse contains the response from method LiveOutputsClient.List.
type LiveOutputsClientListResponse struct {
	LiveOutputListResult
}

// LiveOutputsClientOperationLocationResponse contains the response from method LiveOutputsClient.OperationLocation.
type LiveOutputsClientOperationLocationResponse struct {
	LiveOutput
}

// LocationsClientCheckNameAvailabilityResponse contains the response from method LocationsClient.CheckNameAvailability.
type LocationsClientCheckNameAvailabilityResponse struct {
	EntityNameAvailabilityCheckOutput
}

// OperationResultsClientGetResponse contains the response from method OperationResultsClient.Get.
type OperationResultsClientGetResponse struct {
	MediaService
	// AzureAsyncOperation contains the information returned from the Azure-AsyncOperation header response.
	AzureAsyncOperation *string

	// Location contains the information returned from the Location header response.
	Location *string

	// RetryAfter contains the information returned from the Retry-After header response.
	RetryAfter *int32
}

// OperationStatusesClientGetResponse contains the response from method OperationStatusesClient.Get.
type OperationStatusesClientGetResponse struct {
	MediaServiceOperationStatus
}

// OperationsClientListResponse contains the response from method OperationsClient.List.
type OperationsClientListResponse struct {
	OperationCollection
}

// PrivateEndpointConnectionsClientCreateOrUpdateResponse contains the response from method PrivateEndpointConnectionsClient.CreateOrUpdate.
type PrivateEndpointConnectionsClientCreateOrUpdateResponse struct {
	PrivateEndpointConnection
}

// PrivateEndpointConnectionsClientDeleteResponse contains the response from method PrivateEndpointConnectionsClient.Delete.
type PrivateEndpointConnectionsClientDeleteResponse struct {
	// placeholder for future response values
}

// PrivateEndpointConnectionsClientGetResponse contains the response from method PrivateEndpointConnectionsClient.Get.
type PrivateEndpointConnectionsClientGetResponse struct {
	PrivateEndpointConnection
}

// PrivateEndpointConnectionsClientListResponse contains the response from method PrivateEndpointConnectionsClient.List.
type PrivateEndpointConnectionsClientListResponse struct {
	PrivateEndpointConnectionListResult
}

// PrivateLinkResourcesClientGetResponse contains the response from method PrivateLinkResourcesClient.Get.
type PrivateLinkResourcesClientGetResponse struct {
	PrivateLinkResource
}

// PrivateLinkResourcesClientListResponse contains the response from method PrivateLinkResourcesClient.List.
type PrivateLinkResourcesClientListResponse struct {
	PrivateLinkResourceListResult
}

// StreamingEndpointsClientAsyncOperationResponse contains the response from method StreamingEndpointsClient.AsyncOperation.
type StreamingEndpointsClientAsyncOperationResponse struct {
	AsyncOperationResult
}

// StreamingEndpointsClientCreateResponse contains the response from method StreamingEndpointsClient.Create.
type StreamingEndpointsClientCreateResponse struct {
	StreamingEndpoint
}

// StreamingEndpointsClientDeleteResponse contains the response from method StreamingEndpointsClient.Delete.
type StreamingEndpointsClientDeleteResponse struct {
	// placeholder for future response values
}

// StreamingEndpointsClientGetResponse contains the response from method StreamingEndpointsClient.Get.
type StreamingEndpointsClientGetResponse struct {
	StreamingEndpoint
}

// StreamingEndpointsClientListResponse contains the response from method StreamingEndpointsClient.List.
type StreamingEndpointsClientListResponse struct {
	StreamingEndpointListResult
}

// StreamingEndpointsClientOperationLocationResponse contains the response from method StreamingEndpointsClient.OperationLocation.
type StreamingEndpointsClientOperationLocationResponse struct {
	StreamingEndpoint
}

// StreamingEndpointsClientSKUsResponse contains the response from method StreamingEndpointsClient.SKUs.
type StreamingEndpointsClientSKUsResponse struct {
	StreamingEndpointSKUInfoListResult
}

// StreamingEndpointsClientScaleResponse contains the response from method StreamingEndpointsClient.Scale.
type StreamingEndpointsClientScaleResponse struct {
	// placeholder for future response values
}

// StreamingEndpointsClientStartResponse contains the response from method StreamingEndpointsClient.Start.
type StreamingEndpointsClientStartResponse struct {
	// placeholder for future response values
}

// StreamingEndpointsClientStopResponse contains the response from method StreamingEndpointsClient.Stop.
type StreamingEndpointsClientStopResponse struct {
	// placeholder for future response values
}

// StreamingEndpointsClientUpdateResponse contains the response from method StreamingEndpointsClient.Update.
type StreamingEndpointsClientUpdateResponse struct {
	StreamingEndpoint
}

// StreamingLocatorsClientCreateResponse contains the response from method StreamingLocatorsClient.Create.
type StreamingLocatorsClientCreateResponse struct {
	StreamingLocator
}

// StreamingLocatorsClientDeleteResponse contains the response from method StreamingLocatorsClient.Delete.
type StreamingLocatorsClientDeleteResponse struct {
	// placeholder for future response values
}

// StreamingLocatorsClientGetResponse contains the response from method StreamingLocatorsClient.Get.
type StreamingLocatorsClientGetResponse struct {
	StreamingLocator
}

// StreamingLocatorsClientListContentKeysResponse contains the response from method StreamingLocatorsClient.ListContentKeys.
type StreamingLocatorsClientListContentKeysResponse struct {
	ListContentKeysResponse
}

// StreamingLocatorsClientListPathsResponse contains the response from method StreamingLocatorsClient.ListPaths.
type StreamingLocatorsClientListPathsResponse struct {
	ListPathsResponse
}

// StreamingLocatorsClientListResponse contains the response from method StreamingLocatorsClient.List.
type StreamingLocatorsClientListResponse struct {
	StreamingLocatorCollection
}

// StreamingPoliciesClientCreateResponse contains the response from method StreamingPoliciesClient.Create.
type StreamingPoliciesClientCreateResponse struct {
	StreamingPolicy
}

// StreamingPoliciesClientDeleteResponse contains the response from method StreamingPoliciesClient.Delete.
type StreamingPoliciesClientDeleteResponse struct {
	// placeholder for future response values
}

// StreamingPoliciesClientGetResponse contains the response from method StreamingPoliciesClient.Get.
type StreamingPoliciesClientGetResponse struct {
	StreamingPolicy
}

// StreamingPoliciesClientListResponse contains the response from method StreamingPoliciesClient.List.
type StreamingPoliciesClientListResponse struct {
	StreamingPolicyCollection
}

// TracksClientCreateOrUpdateResponse contains the response from method TracksClient.CreateOrUpdate.
type TracksClientCreateOrUpdateResponse struct {
	AssetTrack
}

// TracksClientDeleteResponse contains the response from method TracksClient.Delete.
type TracksClientDeleteResponse struct {
	// placeholder for future response values
}

// TracksClientGetResponse contains the response from method TracksClient.Get.
type TracksClientGetResponse struct {
	AssetTrack
}

// TracksClientListResponse contains the response from method TracksClient.List.
type TracksClientListResponse struct {
	AssetTrackCollection
}

// TracksClientUpdateResponse contains the response from method TracksClient.Update.
type TracksClientUpdateResponse struct {
	AssetTrack
}

// TracksClientUpdateTrackDataResponse contains the response from method TracksClient.UpdateTrackData.
type TracksClientUpdateTrackDataResponse struct {
	// placeholder for future response values
}

// TransformsClientCreateOrUpdateResponse contains the response from method TransformsClient.CreateOrUpdate.
type TransformsClientCreateOrUpdateResponse struct {
	Transform
}

// TransformsClientDeleteResponse contains the response from method TransformsClient.Delete.
type TransformsClientDeleteResponse struct {
	// placeholder for future response values
}

// TransformsClientGetResponse contains the response from method TransformsClient.Get.
type TransformsClientGetResponse struct {
	Transform
}

// TransformsClientListResponse contains the response from method TransformsClient.List.
type TransformsClientListResponse struct {
	TransformCollection
}

// TransformsClientUpdateResponse contains the response from method TransformsClient.Update.
type TransformsClientUpdateResponse struct {
	Transform
}
