//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armdeploymentscripts

import "encoding/json"

func unmarshalDeploymentScriptClassification(rawMsg json.RawMessage) (DeploymentScriptClassification, error) {
	if rawMsg == nil {
		return nil, nil
	}
	var m map[string]interface{}
	if err := json.Unmarshal(rawMsg, &m); err != nil {
		return nil, err
	}
	var b DeploymentScriptClassification
	switch m["kind"] {
	case string(ScriptTypeAzureCLI):
		b = &AzureCliScript{}
	case string(ScriptTypeAzurePowerShell):
		b = &AzurePowerShellScript{}
	default:
		b = &DeploymentScript{}
	}
	return b, json.Unmarshal(rawMsg, b)
}

func unmarshalDeploymentScriptClassificationArray(rawMsg json.RawMessage) ([]DeploymentScriptClassification, error) {
	if rawMsg == nil {
		return nil, nil
	}
	var rawMessages []json.RawMessage
	if err := json.Unmarshal(rawMsg, &rawMessages); err != nil {
		return nil, err
	}
	fArray := make([]DeploymentScriptClassification, len(rawMessages))
	for index, rawMessage := range rawMessages {
		f, err := unmarshalDeploymentScriptClassification(rawMessage)
		if err != nil {
			return nil, err
		}
		fArray[index] = f
	}
	return fArray, nil
}
