//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armstoragesync

// CloudEndpointsClientCreateResponse contains the response from method CloudEndpointsClient.Create.
type CloudEndpointsClientCreateResponse struct {
	CloudEndpoint
}

// CloudEndpointsClientDeleteResponse contains the response from method CloudEndpointsClient.Delete.
type CloudEndpointsClientDeleteResponse struct {
	// placeholder for future response values
}

// CloudEndpointsClientGetResponse contains the response from method CloudEndpointsClient.Get.
type CloudEndpointsClientGetResponse struct {
	CloudEndpoint
	// XMSCorrelationRequestID contains the information returned from the x-ms-correlation-request-id header response.
	XMSCorrelationRequestID *string

	// XMSRequestID contains the information returned from the x-ms-request-id header response.
	XMSRequestID *string
}

// CloudEndpointsClientListBySyncGroupResponse contains the response from method CloudEndpointsClient.ListBySyncGroup.
type CloudEndpointsClientListBySyncGroupResponse struct {
	CloudEndpointArray
	// XMSCorrelationRequestID contains the information returned from the x-ms-correlation-request-id header response.
	XMSCorrelationRequestID *string

	// XMSRequestID contains the information returned from the x-ms-request-id header response.
	XMSRequestID *string
}

// CloudEndpointsClientPostBackupResponse contains the response from method CloudEndpointsClient.PostBackup.
type CloudEndpointsClientPostBackupResponse struct {
	PostBackupResponse
}

// CloudEndpointsClientPostRestoreResponse contains the response from method CloudEndpointsClient.PostRestore.
type CloudEndpointsClientPostRestoreResponse struct {
	// placeholder for future response values
}

// CloudEndpointsClientPreBackupResponse contains the response from method CloudEndpointsClient.PreBackup.
type CloudEndpointsClientPreBackupResponse struct {
	// placeholder for future response values
}

// CloudEndpointsClientPreRestoreResponse contains the response from method CloudEndpointsClient.PreRestore.
type CloudEndpointsClientPreRestoreResponse struct {
	// placeholder for future response values
}

// CloudEndpointsClientRestoreheartbeatResponse contains the response from method CloudEndpointsClient.Restoreheartbeat.
type CloudEndpointsClientRestoreheartbeatResponse struct {
	// XMSCorrelationRequestID contains the information returned from the x-ms-correlation-request-id header response.
	XMSCorrelationRequestID *string

	// XMSRequestID contains the information returned from the x-ms-request-id header response.
	XMSRequestID *string
}

// CloudEndpointsClientTriggerChangeDetectionResponse contains the response from method CloudEndpointsClient.TriggerChangeDetection.
type CloudEndpointsClientTriggerChangeDetectionResponse struct {
	// placeholder for future response values
}

// MicrosoftStorageSyncClientLocationOperationStatusResponse contains the response from method MicrosoftStorageSyncClient.LocationOperationStatus.
type MicrosoftStorageSyncClientLocationOperationStatusResponse struct {
	LocationOperationStatus
	// XMSCorrelationRequestID contains the information returned from the x-ms-correlation-request-id header response.
	XMSCorrelationRequestID *string

	// XMSRequestID contains the information returned from the x-ms-request-id header response.
	XMSRequestID *string
}

// OperationStatusClientGetResponse contains the response from method OperationStatusClient.Get.
type OperationStatusClientGetResponse struct {
	OperationStatus
	// XMSCorrelationRequestID contains the information returned from the x-ms-correlation-request-id header response.
	XMSCorrelationRequestID *string

	// XMSRequestID contains the information returned from the x-ms-request-id header response.
	XMSRequestID *string
}

// OperationsClientListResponse contains the response from method OperationsClient.List.
type OperationsClientListResponse struct {
	OperationEntityListResult
	// XMSCorrelationRequestID contains the information returned from the x-ms-correlation-request-id header response.
	XMSCorrelationRequestID *string

	// XMSRequestID contains the information returned from the x-ms-request-id header response.
	XMSRequestID *string
}

// PrivateEndpointConnectionsClientCreateResponse contains the response from method PrivateEndpointConnectionsClient.Create.
type PrivateEndpointConnectionsClientCreateResponse struct {
	PrivateEndpointConnection
}

// PrivateEndpointConnectionsClientDeleteResponse contains the response from method PrivateEndpointConnectionsClient.Delete.
type PrivateEndpointConnectionsClientDeleteResponse struct {
	// placeholder for future response values
}

// PrivateEndpointConnectionsClientGetResponse contains the response from method PrivateEndpointConnectionsClient.Get.
type PrivateEndpointConnectionsClientGetResponse struct {
	PrivateEndpointConnection
}

// PrivateEndpointConnectionsClientListByStorageSyncServiceResponse contains the response from method PrivateEndpointConnectionsClient.ListByStorageSyncService.
type PrivateEndpointConnectionsClientListByStorageSyncServiceResponse struct {
	PrivateEndpointConnectionListResult
	// XMSCorrelationRequestID contains the information returned from the x-ms-correlation-request-id header response.
	XMSCorrelationRequestID *string

	// XMSRequestID contains the information returned from the x-ms-request-id header response.
	XMSRequestID *string
}

// PrivateLinkResourcesClientListByStorageSyncServiceResponse contains the response from method PrivateLinkResourcesClient.ListByStorageSyncService.
type PrivateLinkResourcesClientListByStorageSyncServiceResponse struct {
	PrivateLinkResourceListResult
}

// RegisteredServersClientCreateResponse contains the response from method RegisteredServersClient.Create.
type RegisteredServersClientCreateResponse struct {
	RegisteredServer
}

// RegisteredServersClientDeleteResponse contains the response from method RegisteredServersClient.Delete.
type RegisteredServersClientDeleteResponse struct {
	// placeholder for future response values
}

// RegisteredServersClientGetResponse contains the response from method RegisteredServersClient.Get.
type RegisteredServersClientGetResponse struct {
	RegisteredServer
	// XMSCorrelationRequestID contains the information returned from the x-ms-correlation-request-id header response.
	XMSCorrelationRequestID *string

	// XMSRequestID contains the information returned from the x-ms-request-id header response.
	XMSRequestID *string
}

// RegisteredServersClientListByStorageSyncServiceResponse contains the response from method RegisteredServersClient.ListByStorageSyncService.
type RegisteredServersClientListByStorageSyncServiceResponse struct {
	RegisteredServerArray
	// XMSCorrelationRequestID contains the information returned from the x-ms-correlation-request-id header response.
	XMSCorrelationRequestID *string

	// XMSRequestID contains the information returned from the x-ms-request-id header response.
	XMSRequestID *string
}

// RegisteredServersClientTriggerRolloverResponse contains the response from method RegisteredServersClient.TriggerRollover.
type RegisteredServersClientTriggerRolloverResponse struct {
	// placeholder for future response values
}

// ServerEndpointsClientCreateResponse contains the response from method ServerEndpointsClient.Create.
type ServerEndpointsClientCreateResponse struct {
	ServerEndpoint
}

// ServerEndpointsClientDeleteResponse contains the response from method ServerEndpointsClient.Delete.
type ServerEndpointsClientDeleteResponse struct {
	// placeholder for future response values
}

// ServerEndpointsClientGetResponse contains the response from method ServerEndpointsClient.Get.
type ServerEndpointsClientGetResponse struct {
	ServerEndpoint
	// XMSCorrelationRequestID contains the information returned from the x-ms-correlation-request-id header response.
	XMSCorrelationRequestID *string

	// XMSRequestID contains the information returned from the x-ms-request-id header response.
	XMSRequestID *string
}

// ServerEndpointsClientListBySyncGroupResponse contains the response from method ServerEndpointsClient.ListBySyncGroup.
type ServerEndpointsClientListBySyncGroupResponse struct {
	ServerEndpointArray
	// Location contains the information returned from the Location header response.
	Location *string

	// XMSCorrelationRequestID contains the information returned from the x-ms-correlation-request-id header response.
	XMSCorrelationRequestID *string

	// XMSRequestID contains the information returned from the x-ms-request-id header response.
	XMSRequestID *string
}

// ServerEndpointsClientRecallActionResponse contains the response from method ServerEndpointsClient.RecallAction.
type ServerEndpointsClientRecallActionResponse struct {
	// placeholder for future response values
}

// ServerEndpointsClientUpdateResponse contains the response from method ServerEndpointsClient.Update.
type ServerEndpointsClientUpdateResponse struct {
	ServerEndpoint
}

// ServicesClientCheckNameAvailabilityResponse contains the response from method ServicesClient.CheckNameAvailability.
type ServicesClientCheckNameAvailabilityResponse struct {
	CheckNameAvailabilityResult
}

// ServicesClientCreateResponse contains the response from method ServicesClient.Create.
type ServicesClientCreateResponse struct {
	Service
}

// ServicesClientDeleteResponse contains the response from method ServicesClient.Delete.
type ServicesClientDeleteResponse struct {
	// placeholder for future response values
}

// ServicesClientGetResponse contains the response from method ServicesClient.Get.
type ServicesClientGetResponse struct {
	Service
	// XMSCorrelationRequestID contains the information returned from the x-ms-correlation-request-id header response.
	XMSCorrelationRequestID *string

	// XMSRequestID contains the information returned from the x-ms-request-id header response.
	XMSRequestID *string
}

// ServicesClientListByResourceGroupResponse contains the response from method ServicesClient.ListByResourceGroup.
type ServicesClientListByResourceGroupResponse struct {
	ServiceArray
	// XMSCorrelationRequestID contains the information returned from the x-ms-correlation-request-id header response.
	XMSCorrelationRequestID *string

	// XMSRequestID contains the information returned from the x-ms-request-id header response.
	XMSRequestID *string
}

// ServicesClientListBySubscriptionResponse contains the response from method ServicesClient.ListBySubscription.
type ServicesClientListBySubscriptionResponse struct {
	ServiceArray
	// XMSCorrelationRequestID contains the information returned from the x-ms-correlation-request-id header response.
	XMSCorrelationRequestID *string

	// XMSRequestID contains the information returned from the x-ms-request-id header response.
	XMSRequestID *string
}

// ServicesClientUpdateResponse contains the response from method ServicesClient.Update.
type ServicesClientUpdateResponse struct {
	Service
}

// SyncGroupsClientCreateResponse contains the response from method SyncGroupsClient.Create.
type SyncGroupsClientCreateResponse struct {
	SyncGroup
	// XMSCorrelationRequestID contains the information returned from the x-ms-correlation-request-id header response.
	XMSCorrelationRequestID *string

	// XMSRequestID contains the information returned from the x-ms-request-id header response.
	XMSRequestID *string
}

// SyncGroupsClientDeleteResponse contains the response from method SyncGroupsClient.Delete.
type SyncGroupsClientDeleteResponse struct {
	// XMSCorrelationRequestID contains the information returned from the x-ms-correlation-request-id header response.
	XMSCorrelationRequestID *string

	// XMSRequestID contains the information returned from the x-ms-request-id header response.
	XMSRequestID *string
}

// SyncGroupsClientGetResponse contains the response from method SyncGroupsClient.Get.
type SyncGroupsClientGetResponse struct {
	SyncGroup
	// XMSCorrelationRequestID contains the information returned from the x-ms-correlation-request-id header response.
	XMSCorrelationRequestID *string

	// XMSRequestID contains the information returned from the x-ms-request-id header response.
	XMSRequestID *string
}

// SyncGroupsClientListByStorageSyncServiceResponse contains the response from method SyncGroupsClient.ListByStorageSyncService.
type SyncGroupsClientListByStorageSyncServiceResponse struct {
	SyncGroupArray
	// XMSCorrelationRequestID contains the information returned from the x-ms-correlation-request-id header response.
	XMSCorrelationRequestID *string

	// XMSRequestID contains the information returned from the x-ms-request-id header response.
	XMSRequestID *string
}

// WorkflowsClientAbortResponse contains the response from method WorkflowsClient.Abort.
type WorkflowsClientAbortResponse struct {
	// XMSCorrelationRequestID contains the information returned from the x-ms-correlation-request-id header response.
	XMSCorrelationRequestID *string

	// XMSRequestID contains the information returned from the x-ms-request-id header response.
	XMSRequestID *string
}

// WorkflowsClientGetResponse contains the response from method WorkflowsClient.Get.
type WorkflowsClientGetResponse struct {
	Workflow
	// XMSCorrelationRequestID contains the information returned from the x-ms-correlation-request-id header response.
	XMSCorrelationRequestID *string

	// XMSRequestID contains the information returned from the x-ms-request-id header response.
	XMSRequestID *string
}

// WorkflowsClientListByStorageSyncServiceResponse contains the response from method WorkflowsClient.ListByStorageSyncService.
type WorkflowsClientListByStorageSyncServiceResponse struct {
	WorkflowArray
	// XMSCorrelationRequestID contains the information returned from the x-ms-correlation-request-id header response.
	XMSCorrelationRequestID *string

	// XMSRequestID contains the information returned from the x-ms-request-id header response.
	XMSRequestID *string
}
