//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armsynapse

import "encoding/json"

// AzureADOnlyAuthenticationsClientCreateResponse contains the response from method AzureADOnlyAuthenticationsClient.Create.
type AzureADOnlyAuthenticationsClientCreateResponse struct {
	AzureADOnlyAuthentication
}

// AzureADOnlyAuthenticationsClientGetResponse contains the response from method AzureADOnlyAuthenticationsClient.Get.
type AzureADOnlyAuthenticationsClientGetResponse struct {
	AzureADOnlyAuthentication
}

// AzureADOnlyAuthenticationsClientListResponse contains the response from method AzureADOnlyAuthenticationsClient.List.
type AzureADOnlyAuthenticationsClientListResponse struct {
	AzureADOnlyAuthenticationListResult
}

// BigDataPoolsClientCreateOrUpdateResponse contains the response from method BigDataPoolsClient.CreateOrUpdate.
type BigDataPoolsClientCreateOrUpdateResponse struct {
	BigDataPoolResourceInfo
}

// BigDataPoolsClientDeleteResponse contains the response from method BigDataPoolsClient.Delete.
type BigDataPoolsClientDeleteResponse struct {
	// Anything
	Interface interface{}
}

// UnmarshalJSON implements the json.Unmarshaller interface for type BigDataPoolsClientDeleteResponse.
func (b *BigDataPoolsClientDeleteResponse) UnmarshalJSON(data []byte) error {
	return json.Unmarshal(data, &b.Interface)
}

// BigDataPoolsClientGetResponse contains the response from method BigDataPoolsClient.Get.
type BigDataPoolsClientGetResponse struct {
	BigDataPoolResourceInfo
}

// BigDataPoolsClientListByWorkspaceResponse contains the response from method BigDataPoolsClient.ListByWorkspace.
type BigDataPoolsClientListByWorkspaceResponse struct {
	BigDataPoolResourceInfoListResult
}

// BigDataPoolsClientUpdateResponse contains the response from method BigDataPoolsClient.Update.
type BigDataPoolsClientUpdateResponse struct {
	BigDataPoolResourceInfo
}

// DataMaskingPoliciesClientCreateOrUpdateResponse contains the response from method DataMaskingPoliciesClient.CreateOrUpdate.
type DataMaskingPoliciesClientCreateOrUpdateResponse struct {
	DataMaskingPolicy
}

// DataMaskingPoliciesClientGetResponse contains the response from method DataMaskingPoliciesClient.Get.
type DataMaskingPoliciesClientGetResponse struct {
	DataMaskingPolicy
}

// DataMaskingRulesClientCreateOrUpdateResponse contains the response from method DataMaskingRulesClient.CreateOrUpdate.
type DataMaskingRulesClientCreateOrUpdateResponse struct {
	DataMaskingRule
}

// DataMaskingRulesClientGetResponse contains the response from method DataMaskingRulesClient.Get.
type DataMaskingRulesClientGetResponse struct {
	DataMaskingRule
}

// DataMaskingRulesClientListBySQLPoolResponse contains the response from method DataMaskingRulesClient.ListBySQLPool.
type DataMaskingRulesClientListBySQLPoolResponse struct {
	DataMaskingRuleListResult
}

// ExtendedSQLPoolBlobAuditingPoliciesClientCreateOrUpdateResponse contains the response from method ExtendedSQLPoolBlobAuditingPoliciesClient.CreateOrUpdate.
type ExtendedSQLPoolBlobAuditingPoliciesClientCreateOrUpdateResponse struct {
	ExtendedSQLPoolBlobAuditingPolicy
}

// ExtendedSQLPoolBlobAuditingPoliciesClientGetResponse contains the response from method ExtendedSQLPoolBlobAuditingPoliciesClient.Get.
type ExtendedSQLPoolBlobAuditingPoliciesClientGetResponse struct {
	ExtendedSQLPoolBlobAuditingPolicy
}

// ExtendedSQLPoolBlobAuditingPoliciesClientListBySQLPoolResponse contains the response from method ExtendedSQLPoolBlobAuditingPoliciesClient.ListBySQLPool.
type ExtendedSQLPoolBlobAuditingPoliciesClientListBySQLPoolResponse struct {
	ExtendedSQLPoolBlobAuditingPolicyListResult
}

// IPFirewallRulesClientCreateOrUpdateResponse contains the response from method IPFirewallRulesClient.CreateOrUpdate.
type IPFirewallRulesClientCreateOrUpdateResponse struct {
	IPFirewallRuleInfo
}

// IPFirewallRulesClientDeleteResponse contains the response from method IPFirewallRulesClient.Delete.
type IPFirewallRulesClientDeleteResponse struct {
	// Anything
	Interface interface{}
}

// UnmarshalJSON implements the json.Unmarshaller interface for type IPFirewallRulesClientDeleteResponse.
func (i *IPFirewallRulesClientDeleteResponse) UnmarshalJSON(data []byte) error {
	return json.Unmarshal(data, &i.Interface)
}

// IPFirewallRulesClientGetResponse contains the response from method IPFirewallRulesClient.Get.
type IPFirewallRulesClientGetResponse struct {
	IPFirewallRuleInfo
}

// IPFirewallRulesClientListByWorkspaceResponse contains the response from method IPFirewallRulesClient.ListByWorkspace.
type IPFirewallRulesClientListByWorkspaceResponse struct {
	IPFirewallRuleInfoListResult
}

// IPFirewallRulesClientReplaceAllResponse contains the response from method IPFirewallRulesClient.ReplaceAll.
type IPFirewallRulesClientReplaceAllResponse struct {
	ReplaceAllFirewallRulesOperationResponse
}

// IntegrationRuntimeAuthKeysClientListResponse contains the response from method IntegrationRuntimeAuthKeysClient.List.
type IntegrationRuntimeAuthKeysClientListResponse struct {
	IntegrationRuntimeAuthKeys
}

// IntegrationRuntimeAuthKeysClientRegenerateResponse contains the response from method IntegrationRuntimeAuthKeysClient.Regenerate.
type IntegrationRuntimeAuthKeysClientRegenerateResponse struct {
	IntegrationRuntimeAuthKeys
}

// IntegrationRuntimeConnectionInfosClientGetResponse contains the response from method IntegrationRuntimeConnectionInfosClient.Get.
type IntegrationRuntimeConnectionInfosClientGetResponse struct {
	IntegrationRuntimeConnectionInfo
}

// IntegrationRuntimeCredentialsClientSyncResponse contains the response from method IntegrationRuntimeCredentialsClient.Sync.
type IntegrationRuntimeCredentialsClientSyncResponse struct {
	// placeholder for future response values
}

// IntegrationRuntimeMonitoringDataClientListResponse contains the response from method IntegrationRuntimeMonitoringDataClient.List.
type IntegrationRuntimeMonitoringDataClientListResponse struct {
	IntegrationRuntimeMonitoringData
}

// IntegrationRuntimeNodeIPAddressClientGetResponse contains the response from method IntegrationRuntimeNodeIPAddressClient.Get.
type IntegrationRuntimeNodeIPAddressClientGetResponse struct {
	IntegrationRuntimeNodeIPAddress
}

// IntegrationRuntimeNodesClientDeleteResponse contains the response from method IntegrationRuntimeNodesClient.Delete.
type IntegrationRuntimeNodesClientDeleteResponse struct {
	// placeholder for future response values
}

// IntegrationRuntimeNodesClientGetResponse contains the response from method IntegrationRuntimeNodesClient.Get.
type IntegrationRuntimeNodesClientGetResponse struct {
	SelfHostedIntegrationRuntimeNode
}

// IntegrationRuntimeNodesClientUpdateResponse contains the response from method IntegrationRuntimeNodesClient.Update.
type IntegrationRuntimeNodesClientUpdateResponse struct {
	SelfHostedIntegrationRuntimeNode
}

// IntegrationRuntimeObjectMetadataClientListResponse contains the response from method IntegrationRuntimeObjectMetadataClient.List.
type IntegrationRuntimeObjectMetadataClientListResponse struct {
	SsisObjectMetadataListResponse
}

// IntegrationRuntimeObjectMetadataClientRefreshResponse contains the response from method IntegrationRuntimeObjectMetadataClient.Refresh.
type IntegrationRuntimeObjectMetadataClientRefreshResponse struct {
	SsisObjectMetadataStatusResponse
}

// IntegrationRuntimeStatusClientGetResponse contains the response from method IntegrationRuntimeStatusClient.Get.
type IntegrationRuntimeStatusClientGetResponse struct {
	IntegrationRuntimeStatusResponse
}

// IntegrationRuntimesClientCreateResponse contains the response from method IntegrationRuntimesClient.Create.
type IntegrationRuntimesClientCreateResponse struct {
	IntegrationRuntimeResource
}

// IntegrationRuntimesClientDeleteResponse contains the response from method IntegrationRuntimesClient.Delete.
type IntegrationRuntimesClientDeleteResponse struct {
	// placeholder for future response values
}

// IntegrationRuntimesClientDisableInteractiveQueryResponse contains the response from method IntegrationRuntimesClient.DisableInteractiveQuery.
type IntegrationRuntimesClientDisableInteractiveQueryResponse struct {
	// placeholder for future response values
}

// IntegrationRuntimesClientEnableInteractiveQueryResponse contains the response from method IntegrationRuntimesClient.EnableInteractiveQuery.
type IntegrationRuntimesClientEnableInteractiveQueryResponse struct {
	// placeholder for future response values
}

// IntegrationRuntimesClientGetResponse contains the response from method IntegrationRuntimesClient.Get.
type IntegrationRuntimesClientGetResponse struct {
	IntegrationRuntimeResource
}

// IntegrationRuntimesClientListByWorkspaceResponse contains the response from method IntegrationRuntimesClient.ListByWorkspace.
type IntegrationRuntimesClientListByWorkspaceResponse struct {
	IntegrationRuntimeListResponse
}

// IntegrationRuntimesClientListOutboundNetworkDependenciesEndpointsResponse contains the response from method IntegrationRuntimesClient.ListOutboundNetworkDependenciesEndpoints.
type IntegrationRuntimesClientListOutboundNetworkDependenciesEndpointsResponse struct {
	IntegrationRuntimeOutboundNetworkDependenciesEndpointsResponse
}

// IntegrationRuntimesClientStartResponse contains the response from method IntegrationRuntimesClient.Start.
type IntegrationRuntimesClientStartResponse struct {
	IntegrationRuntimeStatusResponse
}

// IntegrationRuntimesClientStopResponse contains the response from method IntegrationRuntimesClient.Stop.
type IntegrationRuntimesClientStopResponse struct {
	// placeholder for future response values
}

// IntegrationRuntimesClientUpdateResponse contains the response from method IntegrationRuntimesClient.Update.
type IntegrationRuntimesClientUpdateResponse struct {
	IntegrationRuntimeResource
}

// IntegrationRuntimesClientUpgradeResponse contains the response from method IntegrationRuntimesClient.Upgrade.
type IntegrationRuntimesClientUpgradeResponse struct {
	// placeholder for future response values
}

// KeysClientCreateOrUpdateResponse contains the response from method KeysClient.CreateOrUpdate.
type KeysClientCreateOrUpdateResponse struct {
	Key
}

// KeysClientDeleteResponse contains the response from method KeysClient.Delete.
type KeysClientDeleteResponse struct {
	Key
}

// KeysClientGetResponse contains the response from method KeysClient.Get.
type KeysClientGetResponse struct {
	Key
}

// KeysClientListByWorkspaceResponse contains the response from method KeysClient.ListByWorkspace.
type KeysClientListByWorkspaceResponse struct {
	KeyInfoListResult
}

// KustoOperationsClientListResponse contains the response from method KustoOperationsClient.List.
type KustoOperationsClientListResponse struct {
	OperationListResult
}

// KustoPoolAttachedDatabaseConfigurationsClientCreateOrUpdateResponse contains the response from method KustoPoolAttachedDatabaseConfigurationsClient.CreateOrUpdate.
type KustoPoolAttachedDatabaseConfigurationsClientCreateOrUpdateResponse struct {
	AttachedDatabaseConfiguration
}

// KustoPoolAttachedDatabaseConfigurationsClientDeleteResponse contains the response from method KustoPoolAttachedDatabaseConfigurationsClient.Delete.
type KustoPoolAttachedDatabaseConfigurationsClientDeleteResponse struct {
	// placeholder for future response values
}

// KustoPoolAttachedDatabaseConfigurationsClientGetResponse contains the response from method KustoPoolAttachedDatabaseConfigurationsClient.Get.
type KustoPoolAttachedDatabaseConfigurationsClientGetResponse struct {
	AttachedDatabaseConfiguration
}

// KustoPoolAttachedDatabaseConfigurationsClientListByKustoPoolResponse contains the response from method KustoPoolAttachedDatabaseConfigurationsClient.ListByKustoPool.
type KustoPoolAttachedDatabaseConfigurationsClientListByKustoPoolResponse struct {
	AttachedDatabaseConfigurationListResult
}

// KustoPoolChildResourceClientCheckNameAvailabilityResponse contains the response from method KustoPoolChildResourceClient.CheckNameAvailability.
type KustoPoolChildResourceClientCheckNameAvailabilityResponse struct {
	CheckNameResult
}

// KustoPoolDataConnectionsClientCheckNameAvailabilityResponse contains the response from method KustoPoolDataConnectionsClient.CheckNameAvailability.
type KustoPoolDataConnectionsClientCheckNameAvailabilityResponse struct {
	CheckNameResult
}

// KustoPoolDataConnectionsClientCreateOrUpdateResponse contains the response from method KustoPoolDataConnectionsClient.CreateOrUpdate.
type KustoPoolDataConnectionsClientCreateOrUpdateResponse struct {
	DataConnectionClassification
}

// UnmarshalJSON implements the json.Unmarshaller interface for type KustoPoolDataConnectionsClientCreateOrUpdateResponse.
func (k *KustoPoolDataConnectionsClientCreateOrUpdateResponse) UnmarshalJSON(data []byte) error {
	res, err := unmarshalDataConnectionClassification(data)
	if err != nil {
		return err
	}
	k.DataConnectionClassification = res
	return nil
}

// KustoPoolDataConnectionsClientDataConnectionValidationResponse contains the response from method KustoPoolDataConnectionsClient.DataConnectionValidation.
type KustoPoolDataConnectionsClientDataConnectionValidationResponse struct {
	DataConnectionValidationListResult
}

// KustoPoolDataConnectionsClientDeleteResponse contains the response from method KustoPoolDataConnectionsClient.Delete.
type KustoPoolDataConnectionsClientDeleteResponse struct {
	// placeholder for future response values
}

// KustoPoolDataConnectionsClientGetResponse contains the response from method KustoPoolDataConnectionsClient.Get.
type KustoPoolDataConnectionsClientGetResponse struct {
	DataConnectionClassification
}

// UnmarshalJSON implements the json.Unmarshaller interface for type KustoPoolDataConnectionsClientGetResponse.
func (k *KustoPoolDataConnectionsClientGetResponse) UnmarshalJSON(data []byte) error {
	res, err := unmarshalDataConnectionClassification(data)
	if err != nil {
		return err
	}
	k.DataConnectionClassification = res
	return nil
}

// KustoPoolDataConnectionsClientListByDatabaseResponse contains the response from method KustoPoolDataConnectionsClient.ListByDatabase.
type KustoPoolDataConnectionsClientListByDatabaseResponse struct {
	DataConnectionListResult
}

// KustoPoolDataConnectionsClientUpdateResponse contains the response from method KustoPoolDataConnectionsClient.Update.
type KustoPoolDataConnectionsClientUpdateResponse struct {
	DataConnectionClassification
}

// UnmarshalJSON implements the json.Unmarshaller interface for type KustoPoolDataConnectionsClientUpdateResponse.
func (k *KustoPoolDataConnectionsClientUpdateResponse) UnmarshalJSON(data []byte) error {
	res, err := unmarshalDataConnectionClassification(data)
	if err != nil {
		return err
	}
	k.DataConnectionClassification = res
	return nil
}

// KustoPoolDatabasePrincipalAssignmentsClientCheckNameAvailabilityResponse contains the response from method KustoPoolDatabasePrincipalAssignmentsClient.CheckNameAvailability.
type KustoPoolDatabasePrincipalAssignmentsClientCheckNameAvailabilityResponse struct {
	CheckNameResult
}

// KustoPoolDatabasePrincipalAssignmentsClientCreateOrUpdateResponse contains the response from method KustoPoolDatabasePrincipalAssignmentsClient.CreateOrUpdate.
type KustoPoolDatabasePrincipalAssignmentsClientCreateOrUpdateResponse struct {
	DatabasePrincipalAssignment
}

// KustoPoolDatabasePrincipalAssignmentsClientDeleteResponse contains the response from method KustoPoolDatabasePrincipalAssignmentsClient.Delete.
type KustoPoolDatabasePrincipalAssignmentsClientDeleteResponse struct {
	// placeholder for future response values
}

// KustoPoolDatabasePrincipalAssignmentsClientGetResponse contains the response from method KustoPoolDatabasePrincipalAssignmentsClient.Get.
type KustoPoolDatabasePrincipalAssignmentsClientGetResponse struct {
	DatabasePrincipalAssignment
}

// KustoPoolDatabasePrincipalAssignmentsClientListResponse contains the response from method KustoPoolDatabasePrincipalAssignmentsClient.List.
type KustoPoolDatabasePrincipalAssignmentsClientListResponse struct {
	DatabasePrincipalAssignmentListResult
}

// KustoPoolDatabasesClientCreateOrUpdateResponse contains the response from method KustoPoolDatabasesClient.CreateOrUpdate.
type KustoPoolDatabasesClientCreateOrUpdateResponse struct {
	DatabaseClassification
}

// UnmarshalJSON implements the json.Unmarshaller interface for type KustoPoolDatabasesClientCreateOrUpdateResponse.
func (k *KustoPoolDatabasesClientCreateOrUpdateResponse) UnmarshalJSON(data []byte) error {
	res, err := unmarshalDatabaseClassification(data)
	if err != nil {
		return err
	}
	k.DatabaseClassification = res
	return nil
}

// KustoPoolDatabasesClientDeleteResponse contains the response from method KustoPoolDatabasesClient.Delete.
type KustoPoolDatabasesClientDeleteResponse struct {
	// placeholder for future response values
}

// KustoPoolDatabasesClientGetResponse contains the response from method KustoPoolDatabasesClient.Get.
type KustoPoolDatabasesClientGetResponse struct {
	DatabaseClassification
}

// UnmarshalJSON implements the json.Unmarshaller interface for type KustoPoolDatabasesClientGetResponse.
func (k *KustoPoolDatabasesClientGetResponse) UnmarshalJSON(data []byte) error {
	res, err := unmarshalDatabaseClassification(data)
	if err != nil {
		return err
	}
	k.DatabaseClassification = res
	return nil
}

// KustoPoolDatabasesClientListByKustoPoolResponse contains the response from method KustoPoolDatabasesClient.ListByKustoPool.
type KustoPoolDatabasesClientListByKustoPoolResponse struct {
	DatabaseListResult
}

// KustoPoolDatabasesClientUpdateResponse contains the response from method KustoPoolDatabasesClient.Update.
type KustoPoolDatabasesClientUpdateResponse struct {
	DatabaseClassification
}

// UnmarshalJSON implements the json.Unmarshaller interface for type KustoPoolDatabasesClientUpdateResponse.
func (k *KustoPoolDatabasesClientUpdateResponse) UnmarshalJSON(data []byte) error {
	res, err := unmarshalDatabaseClassification(data)
	if err != nil {
		return err
	}
	k.DatabaseClassification = res
	return nil
}

// KustoPoolPrincipalAssignmentsClientCheckNameAvailabilityResponse contains the response from method KustoPoolPrincipalAssignmentsClient.CheckNameAvailability.
type KustoPoolPrincipalAssignmentsClientCheckNameAvailabilityResponse struct {
	CheckNameResult
}

// KustoPoolPrincipalAssignmentsClientCreateOrUpdateResponse contains the response from method KustoPoolPrincipalAssignmentsClient.CreateOrUpdate.
type KustoPoolPrincipalAssignmentsClientCreateOrUpdateResponse struct {
	ClusterPrincipalAssignment
}

// KustoPoolPrincipalAssignmentsClientDeleteResponse contains the response from method KustoPoolPrincipalAssignmentsClient.Delete.
type KustoPoolPrincipalAssignmentsClientDeleteResponse struct {
	// placeholder for future response values
}

// KustoPoolPrincipalAssignmentsClientGetResponse contains the response from method KustoPoolPrincipalAssignmentsClient.Get.
type KustoPoolPrincipalAssignmentsClientGetResponse struct {
	ClusterPrincipalAssignment
}

// KustoPoolPrincipalAssignmentsClientListResponse contains the response from method KustoPoolPrincipalAssignmentsClient.List.
type KustoPoolPrincipalAssignmentsClientListResponse struct {
	ClusterPrincipalAssignmentListResult
}

// KustoPoolsClientAddLanguageExtensionsResponse contains the response from method KustoPoolsClient.AddLanguageExtensions.
type KustoPoolsClientAddLanguageExtensionsResponse struct {
	// placeholder for future response values
}

// KustoPoolsClientCheckNameAvailabilityResponse contains the response from method KustoPoolsClient.CheckNameAvailability.
type KustoPoolsClientCheckNameAvailabilityResponse struct {
	CheckNameResult
}

// KustoPoolsClientCreateOrUpdateResponse contains the response from method KustoPoolsClient.CreateOrUpdate.
type KustoPoolsClientCreateOrUpdateResponse struct {
	KustoPool
}

// KustoPoolsClientDeleteResponse contains the response from method KustoPoolsClient.Delete.
type KustoPoolsClientDeleteResponse struct {
	// placeholder for future response values
}

// KustoPoolsClientDetachFollowerDatabasesResponse contains the response from method KustoPoolsClient.DetachFollowerDatabases.
type KustoPoolsClientDetachFollowerDatabasesResponse struct {
	// placeholder for future response values
}

// KustoPoolsClientGetResponse contains the response from method KustoPoolsClient.Get.
type KustoPoolsClientGetResponse struct {
	KustoPool
}

// KustoPoolsClientListByWorkspaceResponse contains the response from method KustoPoolsClient.ListByWorkspace.
type KustoPoolsClientListByWorkspaceResponse struct {
	KustoPoolListResult
}

// KustoPoolsClientListFollowerDatabasesResponse contains the response from method KustoPoolsClient.ListFollowerDatabases.
type KustoPoolsClientListFollowerDatabasesResponse struct {
	FollowerDatabaseListResult
}

// KustoPoolsClientListLanguageExtensionsResponse contains the response from method KustoPoolsClient.ListLanguageExtensions.
type KustoPoolsClientListLanguageExtensionsResponse struct {
	LanguageExtensionsList
}

// KustoPoolsClientListSKUsByResourceResponse contains the response from method KustoPoolsClient.ListSKUsByResource.
type KustoPoolsClientListSKUsByResourceResponse struct {
	ListResourceSKUsResult
}

// KustoPoolsClientListSKUsResponse contains the response from method KustoPoolsClient.ListSKUs.
type KustoPoolsClientListSKUsResponse struct {
	SKUDescriptionList
}

// KustoPoolsClientRemoveLanguageExtensionsResponse contains the response from method KustoPoolsClient.RemoveLanguageExtensions.
type KustoPoolsClientRemoveLanguageExtensionsResponse struct {
	// placeholder for future response values
}

// KustoPoolsClientStartResponse contains the response from method KustoPoolsClient.Start.
type KustoPoolsClientStartResponse struct {
	// placeholder for future response values
}

// KustoPoolsClientStopResponse contains the response from method KustoPoolsClient.Stop.
type KustoPoolsClientStopResponse struct {
	// placeholder for future response values
}

// KustoPoolsClientUpdateResponse contains the response from method KustoPoolsClient.Update.
type KustoPoolsClientUpdateResponse struct {
	KustoPool
}

// LibrariesClientListByWorkspaceResponse contains the response from method LibrariesClient.ListByWorkspace.
type LibrariesClientListByWorkspaceResponse struct {
	LibraryListResponse
}

// LibraryClientGetResponse contains the response from method LibraryClient.Get.
type LibraryClientGetResponse struct {
	LibraryResource
}

// OperationsClientCheckNameAvailabilityResponse contains the response from method OperationsClient.CheckNameAvailability.
type OperationsClientCheckNameAvailabilityResponse struct {
	CheckNameAvailabilityResponse
}

// OperationsClientGetAzureAsyncHeaderResultResponse contains the response from method OperationsClient.GetAzureAsyncHeaderResult.
type OperationsClientGetAzureAsyncHeaderResultResponse struct {
	OperationResource
}

// OperationsClientGetLocationHeaderResultResponse contains the response from method OperationsClient.GetLocationHeaderResult.
type OperationsClientGetLocationHeaderResultResponse struct {
	// placeholder for future response values
}

// OperationsClientListResponse contains the response from method OperationsClient.List.
type OperationsClientListResponse struct {
	// Array of AvailableRpOperation
	AvailableRpOperationArray []*AvailableRpOperation
}

// PrivateEndpointConnectionsClientCreateResponse contains the response from method PrivateEndpointConnectionsClient.Create.
type PrivateEndpointConnectionsClientCreateResponse struct {
	PrivateEndpointConnection
}

// PrivateEndpointConnectionsClientDeleteResponse contains the response from method PrivateEndpointConnectionsClient.Delete.
type PrivateEndpointConnectionsClientDeleteResponse struct {
	OperationResource
}

// PrivateEndpointConnectionsClientGetResponse contains the response from method PrivateEndpointConnectionsClient.Get.
type PrivateEndpointConnectionsClientGetResponse struct {
	PrivateEndpointConnection
}

// PrivateEndpointConnectionsClientListResponse contains the response from method PrivateEndpointConnectionsClient.List.
type PrivateEndpointConnectionsClientListResponse struct {
	PrivateEndpointConnectionList
}

// PrivateEndpointConnectionsPrivateLinkHubClientGetResponse contains the response from method PrivateEndpointConnectionsPrivateLinkHubClient.Get.
type PrivateEndpointConnectionsPrivateLinkHubClientGetResponse struct {
	PrivateEndpointConnectionForPrivateLinkHub
}

// PrivateEndpointConnectionsPrivateLinkHubClientListResponse contains the response from method PrivateEndpointConnectionsPrivateLinkHubClient.List.
type PrivateEndpointConnectionsPrivateLinkHubClientListResponse struct {
	PrivateEndpointConnectionForPrivateLinkHubResourceCollectionResponse
}

// PrivateLinkHubPrivateLinkResourcesClientGetResponse contains the response from method PrivateLinkHubPrivateLinkResourcesClient.Get.
type PrivateLinkHubPrivateLinkResourcesClientGetResponse struct {
	PrivateLinkResource
}

// PrivateLinkHubPrivateLinkResourcesClientListResponse contains the response from method PrivateLinkHubPrivateLinkResourcesClient.List.
type PrivateLinkHubPrivateLinkResourcesClientListResponse struct {
	PrivateLinkResourceListResult
}

// PrivateLinkHubsClientCreateOrUpdateResponse contains the response from method PrivateLinkHubsClient.CreateOrUpdate.
type PrivateLinkHubsClientCreateOrUpdateResponse struct {
	PrivateLinkHub
}

// PrivateLinkHubsClientDeleteResponse contains the response from method PrivateLinkHubsClient.Delete.
type PrivateLinkHubsClientDeleteResponse struct {
	// placeholder for future response values
}

// PrivateLinkHubsClientGetResponse contains the response from method PrivateLinkHubsClient.Get.
type PrivateLinkHubsClientGetResponse struct {
	PrivateLinkHub
}

// PrivateLinkHubsClientListByResourceGroupResponse contains the response from method PrivateLinkHubsClient.ListByResourceGroup.
type PrivateLinkHubsClientListByResourceGroupResponse struct {
	PrivateLinkHubInfoListResult
}

// PrivateLinkHubsClientListResponse contains the response from method PrivateLinkHubsClient.List.
type PrivateLinkHubsClientListResponse struct {
	PrivateLinkHubInfoListResult
}

// PrivateLinkHubsClientUpdateResponse contains the response from method PrivateLinkHubsClient.Update.
type PrivateLinkHubsClientUpdateResponse struct {
	PrivateLinkHub
}

// PrivateLinkResourcesClientGetResponse contains the response from method PrivateLinkResourcesClient.Get.
type PrivateLinkResourcesClientGetResponse struct {
	PrivateLinkResource
}

// PrivateLinkResourcesClientListResponse contains the response from method PrivateLinkResourcesClient.List.
type PrivateLinkResourcesClientListResponse struct {
	PrivateLinkResourceListResult
}

// RestorableDroppedSQLPoolsClientGetResponse contains the response from method RestorableDroppedSQLPoolsClient.Get.
type RestorableDroppedSQLPoolsClientGetResponse struct {
	RestorableDroppedSQLPool
}

// RestorableDroppedSQLPoolsClientListByWorkspaceResponse contains the response from method RestorableDroppedSQLPoolsClient.ListByWorkspace.
type RestorableDroppedSQLPoolsClientListByWorkspaceResponse struct {
	RestorableDroppedSQLPoolListResult
}

// SQLPoolBlobAuditingPoliciesClientCreateOrUpdateResponse contains the response from method SQLPoolBlobAuditingPoliciesClient.CreateOrUpdate.
type SQLPoolBlobAuditingPoliciesClientCreateOrUpdateResponse struct {
	SQLPoolBlobAuditingPolicy
}

// SQLPoolBlobAuditingPoliciesClientGetResponse contains the response from method SQLPoolBlobAuditingPoliciesClient.Get.
type SQLPoolBlobAuditingPoliciesClientGetResponse struct {
	SQLPoolBlobAuditingPolicy
}

// SQLPoolBlobAuditingPoliciesClientListBySQLPoolResponse contains the response from method SQLPoolBlobAuditingPoliciesClient.ListBySQLPool.
type SQLPoolBlobAuditingPoliciesClientListBySQLPoolResponse struct {
	SQLPoolBlobAuditingPolicyListResult
}

// SQLPoolColumnsClientGetResponse contains the response from method SQLPoolColumnsClient.Get.
type SQLPoolColumnsClientGetResponse struct {
	SQLPoolColumn
}

// SQLPoolConnectionPoliciesClientGetResponse contains the response from method SQLPoolConnectionPoliciesClient.Get.
type SQLPoolConnectionPoliciesClientGetResponse struct {
	SQLPoolConnectionPolicy
}

// SQLPoolDataWarehouseUserActivitiesClientGetResponse contains the response from method SQLPoolDataWarehouseUserActivitiesClient.Get.
type SQLPoolDataWarehouseUserActivitiesClientGetResponse struct {
	DataWarehouseUserActivities
}

// SQLPoolGeoBackupPoliciesClientCreateOrUpdateResponse contains the response from method SQLPoolGeoBackupPoliciesClient.CreateOrUpdate.
type SQLPoolGeoBackupPoliciesClientCreateOrUpdateResponse struct {
	GeoBackupPolicy
}

// SQLPoolGeoBackupPoliciesClientGetResponse contains the response from method SQLPoolGeoBackupPoliciesClient.Get.
type SQLPoolGeoBackupPoliciesClientGetResponse struct {
	GeoBackupPolicy
}

// SQLPoolGeoBackupPoliciesClientListResponse contains the response from method SQLPoolGeoBackupPoliciesClient.List.
type SQLPoolGeoBackupPoliciesClientListResponse struct {
	GeoBackupPolicyListResult
}

// SQLPoolMaintenanceWindowOptionsClientGetResponse contains the response from method SQLPoolMaintenanceWindowOptionsClient.Get.
type SQLPoolMaintenanceWindowOptionsClientGetResponse struct {
	MaintenanceWindowOptions
}

// SQLPoolMaintenanceWindowsClientCreateOrUpdateResponse contains the response from method SQLPoolMaintenanceWindowsClient.CreateOrUpdate.
type SQLPoolMaintenanceWindowsClientCreateOrUpdateResponse struct {
	// placeholder for future response values
}

// SQLPoolMaintenanceWindowsClientGetResponse contains the response from method SQLPoolMaintenanceWindowsClient.Get.
type SQLPoolMaintenanceWindowsClientGetResponse struct {
	MaintenanceWindows
}

// SQLPoolMetadataSyncConfigsClientCreateResponse contains the response from method SQLPoolMetadataSyncConfigsClient.Create.
type SQLPoolMetadataSyncConfigsClientCreateResponse struct {
	MetadataSyncConfig
}

// SQLPoolMetadataSyncConfigsClientGetResponse contains the response from method SQLPoolMetadataSyncConfigsClient.Get.
type SQLPoolMetadataSyncConfigsClientGetResponse struct {
	MetadataSyncConfig
}

// SQLPoolOperationResultsClientGetLocationHeaderResultResponse contains the response from method SQLPoolOperationResultsClient.GetLocationHeaderResult.
type SQLPoolOperationResultsClientGetLocationHeaderResultResponse struct {
	// Anything
	Interface interface{}
}

// SQLPoolOperationsClientListResponse contains the response from method SQLPoolOperationsClient.List.
type SQLPoolOperationsClientListResponse struct {
	SQLPoolBlobAuditingPolicySQLPoolOperationListResult
}

// SQLPoolRecommendedSensitivityLabelsClientUpdateResponse contains the response from method SQLPoolRecommendedSensitivityLabelsClient.Update.
type SQLPoolRecommendedSensitivityLabelsClientUpdateResponse struct {
	// placeholder for future response values
}

// SQLPoolReplicationLinksClientGetByNameResponse contains the response from method SQLPoolReplicationLinksClient.GetByName.
type SQLPoolReplicationLinksClientGetByNameResponse struct {
	ReplicationLink
}

// SQLPoolReplicationLinksClientListResponse contains the response from method SQLPoolReplicationLinksClient.List.
type SQLPoolReplicationLinksClientListResponse struct {
	ReplicationLinkListResult
}

// SQLPoolRestorePointsClientCreateResponse contains the response from method SQLPoolRestorePointsClient.Create.
type SQLPoolRestorePointsClientCreateResponse struct {
	RestorePoint
}

// SQLPoolRestorePointsClientDeleteResponse contains the response from method SQLPoolRestorePointsClient.Delete.
type SQLPoolRestorePointsClientDeleteResponse struct {
	// placeholder for future response values
}

// SQLPoolRestorePointsClientGetResponse contains the response from method SQLPoolRestorePointsClient.Get.
type SQLPoolRestorePointsClientGetResponse struct {
	RestorePoint
}

// SQLPoolRestorePointsClientListResponse contains the response from method SQLPoolRestorePointsClient.List.
type SQLPoolRestorePointsClientListResponse struct {
	RestorePointListResult
}

// SQLPoolSchemasClientGetResponse contains the response from method SQLPoolSchemasClient.Get.
type SQLPoolSchemasClientGetResponse struct {
	SQLPoolSchema
}

// SQLPoolSchemasClientListResponse contains the response from method SQLPoolSchemasClient.List.
type SQLPoolSchemasClientListResponse struct {
	SQLPoolSchemaListResult
}

// SQLPoolSecurityAlertPoliciesClientCreateOrUpdateResponse contains the response from method SQLPoolSecurityAlertPoliciesClient.CreateOrUpdate.
type SQLPoolSecurityAlertPoliciesClientCreateOrUpdateResponse struct {
	SQLPoolSecurityAlertPolicy
}

// SQLPoolSecurityAlertPoliciesClientGetResponse contains the response from method SQLPoolSecurityAlertPoliciesClient.Get.
type SQLPoolSecurityAlertPoliciesClientGetResponse struct {
	SQLPoolSecurityAlertPolicy
}

// SQLPoolSecurityAlertPoliciesClientListResponse contains the response from method SQLPoolSecurityAlertPoliciesClient.List.
type SQLPoolSecurityAlertPoliciesClientListResponse struct {
	ListSQLPoolSecurityAlertPolicies
}

// SQLPoolSensitivityLabelsClientCreateOrUpdateResponse contains the response from method SQLPoolSensitivityLabelsClient.CreateOrUpdate.
type SQLPoolSensitivityLabelsClientCreateOrUpdateResponse struct {
	SensitivityLabel
}

// SQLPoolSensitivityLabelsClientDeleteResponse contains the response from method SQLPoolSensitivityLabelsClient.Delete.
type SQLPoolSensitivityLabelsClientDeleteResponse struct {
	// placeholder for future response values
}

// SQLPoolSensitivityLabelsClientDisableRecommendationResponse contains the response from method SQLPoolSensitivityLabelsClient.DisableRecommendation.
type SQLPoolSensitivityLabelsClientDisableRecommendationResponse struct {
	// placeholder for future response values
}

// SQLPoolSensitivityLabelsClientEnableRecommendationResponse contains the response from method SQLPoolSensitivityLabelsClient.EnableRecommendation.
type SQLPoolSensitivityLabelsClientEnableRecommendationResponse struct {
	// placeholder for future response values
}

// SQLPoolSensitivityLabelsClientGetResponse contains the response from method SQLPoolSensitivityLabelsClient.Get.
type SQLPoolSensitivityLabelsClientGetResponse struct {
	SensitivityLabel
}

// SQLPoolSensitivityLabelsClientListCurrentResponse contains the response from method SQLPoolSensitivityLabelsClient.ListCurrent.
type SQLPoolSensitivityLabelsClientListCurrentResponse struct {
	SensitivityLabelListResult
}

// SQLPoolSensitivityLabelsClientListRecommendedResponse contains the response from method SQLPoolSensitivityLabelsClient.ListRecommended.
type SQLPoolSensitivityLabelsClientListRecommendedResponse struct {
	SensitivityLabelListResult
}

// SQLPoolSensitivityLabelsClientUpdateResponse contains the response from method SQLPoolSensitivityLabelsClient.Update.
type SQLPoolSensitivityLabelsClientUpdateResponse struct {
	// placeholder for future response values
}

// SQLPoolTableColumnsClientListByTableNameResponse contains the response from method SQLPoolTableColumnsClient.ListByTableName.
type SQLPoolTableColumnsClientListByTableNameResponse struct {
	SQLPoolColumnListResult
}

// SQLPoolTablesClientGetResponse contains the response from method SQLPoolTablesClient.Get.
type SQLPoolTablesClientGetResponse struct {
	SQLPoolTable
}

// SQLPoolTablesClientListBySchemaResponse contains the response from method SQLPoolTablesClient.ListBySchema.
type SQLPoolTablesClientListBySchemaResponse struct {
	SQLPoolTableListResult
}

// SQLPoolTransparentDataEncryptionsClientCreateOrUpdateResponse contains the response from method SQLPoolTransparentDataEncryptionsClient.CreateOrUpdate.
type SQLPoolTransparentDataEncryptionsClientCreateOrUpdateResponse struct {
	TransparentDataEncryption
}

// SQLPoolTransparentDataEncryptionsClientGetResponse contains the response from method SQLPoolTransparentDataEncryptionsClient.Get.
type SQLPoolTransparentDataEncryptionsClientGetResponse struct {
	TransparentDataEncryption
}

// SQLPoolTransparentDataEncryptionsClientListResponse contains the response from method SQLPoolTransparentDataEncryptionsClient.List.
type SQLPoolTransparentDataEncryptionsClientListResponse struct {
	TransparentDataEncryptionListResult
}

// SQLPoolUsagesClientListResponse contains the response from method SQLPoolUsagesClient.List.
type SQLPoolUsagesClientListResponse struct {
	SQLPoolUsageListResult
}

// SQLPoolVulnerabilityAssessmentRuleBaselinesClientCreateOrUpdateResponse contains the response from method SQLPoolVulnerabilityAssessmentRuleBaselinesClient.CreateOrUpdate.
type SQLPoolVulnerabilityAssessmentRuleBaselinesClientCreateOrUpdateResponse struct {
	SQLPoolVulnerabilityAssessmentRuleBaseline
}

// SQLPoolVulnerabilityAssessmentRuleBaselinesClientDeleteResponse contains the response from method SQLPoolVulnerabilityAssessmentRuleBaselinesClient.Delete.
type SQLPoolVulnerabilityAssessmentRuleBaselinesClientDeleteResponse struct {
	// placeholder for future response values
}

// SQLPoolVulnerabilityAssessmentRuleBaselinesClientGetResponse contains the response from method SQLPoolVulnerabilityAssessmentRuleBaselinesClient.Get.
type SQLPoolVulnerabilityAssessmentRuleBaselinesClientGetResponse struct {
	SQLPoolVulnerabilityAssessmentRuleBaseline
}

// SQLPoolVulnerabilityAssessmentScansClientExportResponse contains the response from method SQLPoolVulnerabilityAssessmentScansClient.Export.
type SQLPoolVulnerabilityAssessmentScansClientExportResponse struct {
	SQLPoolVulnerabilityAssessmentScansExport
}

// SQLPoolVulnerabilityAssessmentScansClientGetResponse contains the response from method SQLPoolVulnerabilityAssessmentScansClient.Get.
type SQLPoolVulnerabilityAssessmentScansClientGetResponse struct {
	VulnerabilityAssessmentScanRecord
}

// SQLPoolVulnerabilityAssessmentScansClientInitiateScanResponse contains the response from method SQLPoolVulnerabilityAssessmentScansClient.InitiateScan.
type SQLPoolVulnerabilityAssessmentScansClientInitiateScanResponse struct {
	// placeholder for future response values
}

// SQLPoolVulnerabilityAssessmentScansClientListResponse contains the response from method SQLPoolVulnerabilityAssessmentScansClient.List.
type SQLPoolVulnerabilityAssessmentScansClientListResponse struct {
	VulnerabilityAssessmentScanRecordListResult
}

// SQLPoolVulnerabilityAssessmentsClientCreateOrUpdateResponse contains the response from method SQLPoolVulnerabilityAssessmentsClient.CreateOrUpdate.
type SQLPoolVulnerabilityAssessmentsClientCreateOrUpdateResponse struct {
	SQLPoolVulnerabilityAssessment
}

// SQLPoolVulnerabilityAssessmentsClientDeleteResponse contains the response from method SQLPoolVulnerabilityAssessmentsClient.Delete.
type SQLPoolVulnerabilityAssessmentsClientDeleteResponse struct {
	// placeholder for future response values
}

// SQLPoolVulnerabilityAssessmentsClientGetResponse contains the response from method SQLPoolVulnerabilityAssessmentsClient.Get.
type SQLPoolVulnerabilityAssessmentsClientGetResponse struct {
	SQLPoolVulnerabilityAssessment
}

// SQLPoolVulnerabilityAssessmentsClientListResponse contains the response from method SQLPoolVulnerabilityAssessmentsClient.List.
type SQLPoolVulnerabilityAssessmentsClientListResponse struct {
	SQLPoolVulnerabilityAssessmentListResult
}

// SQLPoolWorkloadClassifierClientCreateOrUpdateResponse contains the response from method SQLPoolWorkloadClassifierClient.CreateOrUpdate.
type SQLPoolWorkloadClassifierClientCreateOrUpdateResponse struct {
	WorkloadClassifier
}

// SQLPoolWorkloadClassifierClientDeleteResponse contains the response from method SQLPoolWorkloadClassifierClient.Delete.
type SQLPoolWorkloadClassifierClientDeleteResponse struct {
	// placeholder for future response values
}

// SQLPoolWorkloadClassifierClientGetResponse contains the response from method SQLPoolWorkloadClassifierClient.Get.
type SQLPoolWorkloadClassifierClientGetResponse struct {
	WorkloadClassifier
}

// SQLPoolWorkloadClassifierClientListResponse contains the response from method SQLPoolWorkloadClassifierClient.List.
type SQLPoolWorkloadClassifierClientListResponse struct {
	WorkloadClassifierListResult
}

// SQLPoolWorkloadGroupClientCreateOrUpdateResponse contains the response from method SQLPoolWorkloadGroupClient.CreateOrUpdate.
type SQLPoolWorkloadGroupClientCreateOrUpdateResponse struct {
	WorkloadGroup
}

// SQLPoolWorkloadGroupClientDeleteResponse contains the response from method SQLPoolWorkloadGroupClient.Delete.
type SQLPoolWorkloadGroupClientDeleteResponse struct {
	// placeholder for future response values
}

// SQLPoolWorkloadGroupClientGetResponse contains the response from method SQLPoolWorkloadGroupClient.Get.
type SQLPoolWorkloadGroupClientGetResponse struct {
	WorkloadGroup
}

// SQLPoolWorkloadGroupClientListResponse contains the response from method SQLPoolWorkloadGroupClient.List.
type SQLPoolWorkloadGroupClientListResponse struct {
	WorkloadGroupListResult
}

// SQLPoolsClientCreateResponse contains the response from method SQLPoolsClient.Create.
type SQLPoolsClientCreateResponse struct {
	SQLPool
}

// SQLPoolsClientDeleteResponse contains the response from method SQLPoolsClient.Delete.
type SQLPoolsClientDeleteResponse struct {
	// Anything
	Interface interface{}
}

// UnmarshalJSON implements the json.Unmarshaller interface for type SQLPoolsClientDeleteResponse.
func (s *SQLPoolsClientDeleteResponse) UnmarshalJSON(data []byte) error {
	return json.Unmarshal(data, &s.Interface)
}

// SQLPoolsClientGetResponse contains the response from method SQLPoolsClient.Get.
type SQLPoolsClientGetResponse struct {
	SQLPool
}

// SQLPoolsClientListByWorkspaceResponse contains the response from method SQLPoolsClient.ListByWorkspace.
type SQLPoolsClientListByWorkspaceResponse struct {
	SQLPoolInfoListResult
}

// SQLPoolsClientPauseResponse contains the response from method SQLPoolsClient.Pause.
type SQLPoolsClientPauseResponse struct {
	// Anything
	Interface interface{}
}

// UnmarshalJSON implements the json.Unmarshaller interface for type SQLPoolsClientPauseResponse.
func (s *SQLPoolsClientPauseResponse) UnmarshalJSON(data []byte) error {
	return json.Unmarshal(data, &s.Interface)
}

// SQLPoolsClientRenameResponse contains the response from method SQLPoolsClient.Rename.
type SQLPoolsClientRenameResponse struct {
	// placeholder for future response values
}

// SQLPoolsClientResumeResponse contains the response from method SQLPoolsClient.Resume.
type SQLPoolsClientResumeResponse struct {
	// Anything
	Interface interface{}
}

// UnmarshalJSON implements the json.Unmarshaller interface for type SQLPoolsClientResumeResponse.
func (s *SQLPoolsClientResumeResponse) UnmarshalJSON(data []byte) error {
	return json.Unmarshal(data, &s.Interface)
}

// SQLPoolsClientUpdateResponse contains the response from method SQLPoolsClient.Update.
type SQLPoolsClientUpdateResponse struct {
	SQLPool
}

// SparkConfigurationClientGetResponse contains the response from method SparkConfigurationClient.Get.
type SparkConfigurationClientGetResponse struct {
	SparkConfigurationResource
}

// SparkConfigurationsClientListByWorkspaceResponse contains the response from method SparkConfigurationsClient.ListByWorkspace.
type SparkConfigurationsClientListByWorkspaceResponse struct {
	SparkConfigurationListResponse
}

// WorkspaceAADAdminsClientCreateOrUpdateResponse contains the response from method WorkspaceAADAdminsClient.CreateOrUpdate.
type WorkspaceAADAdminsClientCreateOrUpdateResponse struct {
	WorkspaceAADAdminInfo
}

// WorkspaceAADAdminsClientDeleteResponse contains the response from method WorkspaceAADAdminsClient.Delete.
type WorkspaceAADAdminsClientDeleteResponse struct {
	// placeholder for future response values
}

// WorkspaceAADAdminsClientGetResponse contains the response from method WorkspaceAADAdminsClient.Get.
type WorkspaceAADAdminsClientGetResponse struct {
	WorkspaceAADAdminInfo
}

// WorkspaceManagedIdentitySQLControlSettingsClientCreateOrUpdateResponse contains the response from method WorkspaceManagedIdentitySQLControlSettingsClient.CreateOrUpdate.
type WorkspaceManagedIdentitySQLControlSettingsClientCreateOrUpdateResponse struct {
	ManagedIdentitySQLControlSettingsModel
}

// WorkspaceManagedIdentitySQLControlSettingsClientGetResponse contains the response from method WorkspaceManagedIdentitySQLControlSettingsClient.Get.
type WorkspaceManagedIdentitySQLControlSettingsClientGetResponse struct {
	ManagedIdentitySQLControlSettingsModel
}

// WorkspaceManagedSQLServerBlobAuditingPoliciesClientCreateOrUpdateResponse contains the response from method WorkspaceManagedSQLServerBlobAuditingPoliciesClient.CreateOrUpdate.
type WorkspaceManagedSQLServerBlobAuditingPoliciesClientCreateOrUpdateResponse struct {
	ServerBlobAuditingPolicy
}

// WorkspaceManagedSQLServerBlobAuditingPoliciesClientGetResponse contains the response from method WorkspaceManagedSQLServerBlobAuditingPoliciesClient.Get.
type WorkspaceManagedSQLServerBlobAuditingPoliciesClientGetResponse struct {
	ServerBlobAuditingPolicy
}

// WorkspaceManagedSQLServerBlobAuditingPoliciesClientListByWorkspaceResponse contains the response from method WorkspaceManagedSQLServerBlobAuditingPoliciesClient.ListByWorkspace.
type WorkspaceManagedSQLServerBlobAuditingPoliciesClientListByWorkspaceResponse struct {
	ServerBlobAuditingPolicyListResult
}

// WorkspaceManagedSQLServerDedicatedSQLMinimalTLSSettingsClientGetResponse contains the response from method WorkspaceManagedSQLServerDedicatedSQLMinimalTLSSettingsClient.Get.
type WorkspaceManagedSQLServerDedicatedSQLMinimalTLSSettingsClientGetResponse struct {
	DedicatedSQLminimalTLSSettings
}

// WorkspaceManagedSQLServerDedicatedSQLMinimalTLSSettingsClientListResponse contains the response from method WorkspaceManagedSQLServerDedicatedSQLMinimalTLSSettingsClient.List.
type WorkspaceManagedSQLServerDedicatedSQLMinimalTLSSettingsClientListResponse struct {
	DedicatedSQLminimalTLSSettingsListResult
}

// WorkspaceManagedSQLServerDedicatedSQLMinimalTLSSettingsClientUpdateResponse contains the response from method WorkspaceManagedSQLServerDedicatedSQLMinimalTLSSettingsClient.Update.
type WorkspaceManagedSQLServerDedicatedSQLMinimalTLSSettingsClientUpdateResponse struct {
	DedicatedSQLminimalTLSSettings
}

// WorkspaceManagedSQLServerEncryptionProtectorClientCreateOrUpdateResponse contains the response from method WorkspaceManagedSQLServerEncryptionProtectorClient.CreateOrUpdate.
type WorkspaceManagedSQLServerEncryptionProtectorClientCreateOrUpdateResponse struct {
	EncryptionProtector
}

// WorkspaceManagedSQLServerEncryptionProtectorClientGetResponse contains the response from method WorkspaceManagedSQLServerEncryptionProtectorClient.Get.
type WorkspaceManagedSQLServerEncryptionProtectorClientGetResponse struct {
	EncryptionProtector
}

// WorkspaceManagedSQLServerEncryptionProtectorClientListResponse contains the response from method WorkspaceManagedSQLServerEncryptionProtectorClient.List.
type WorkspaceManagedSQLServerEncryptionProtectorClientListResponse struct {
	EncryptionProtectorListResult
}

// WorkspaceManagedSQLServerEncryptionProtectorClientRevalidateResponse contains the response from method WorkspaceManagedSQLServerEncryptionProtectorClient.Revalidate.
type WorkspaceManagedSQLServerEncryptionProtectorClientRevalidateResponse struct {
	// placeholder for future response values
}

// WorkspaceManagedSQLServerExtendedBlobAuditingPoliciesClientCreateOrUpdateResponse contains the response from method WorkspaceManagedSQLServerExtendedBlobAuditingPoliciesClient.CreateOrUpdate.
type WorkspaceManagedSQLServerExtendedBlobAuditingPoliciesClientCreateOrUpdateResponse struct {
	ExtendedServerBlobAuditingPolicy
}

// WorkspaceManagedSQLServerExtendedBlobAuditingPoliciesClientGetResponse contains the response from method WorkspaceManagedSQLServerExtendedBlobAuditingPoliciesClient.Get.
type WorkspaceManagedSQLServerExtendedBlobAuditingPoliciesClientGetResponse struct {
	ExtendedServerBlobAuditingPolicy
}

// WorkspaceManagedSQLServerExtendedBlobAuditingPoliciesClientListByWorkspaceResponse contains the response from method WorkspaceManagedSQLServerExtendedBlobAuditingPoliciesClient.ListByWorkspace.
type WorkspaceManagedSQLServerExtendedBlobAuditingPoliciesClientListByWorkspaceResponse struct {
	ExtendedServerBlobAuditingPolicyListResult
}

// WorkspaceManagedSQLServerRecoverableSQLPoolsClientGetResponse contains the response from method WorkspaceManagedSQLServerRecoverableSQLPoolsClient.Get.
type WorkspaceManagedSQLServerRecoverableSQLPoolsClientGetResponse struct {
	RecoverableSQLPool
}

// WorkspaceManagedSQLServerRecoverableSQLPoolsClientListResponse contains the response from method WorkspaceManagedSQLServerRecoverableSQLPoolsClient.List.
type WorkspaceManagedSQLServerRecoverableSQLPoolsClientListResponse struct {
	RecoverableSQLPoolListResult
}

// WorkspaceManagedSQLServerSecurityAlertPolicyClientCreateOrUpdateResponse contains the response from method WorkspaceManagedSQLServerSecurityAlertPolicyClient.CreateOrUpdate.
type WorkspaceManagedSQLServerSecurityAlertPolicyClientCreateOrUpdateResponse struct {
	ServerSecurityAlertPolicy
}

// WorkspaceManagedSQLServerSecurityAlertPolicyClientGetResponse contains the response from method WorkspaceManagedSQLServerSecurityAlertPolicyClient.Get.
type WorkspaceManagedSQLServerSecurityAlertPolicyClientGetResponse struct {
	ServerSecurityAlertPolicy
}

// WorkspaceManagedSQLServerSecurityAlertPolicyClientListResponse contains the response from method WorkspaceManagedSQLServerSecurityAlertPolicyClient.List.
type WorkspaceManagedSQLServerSecurityAlertPolicyClientListResponse struct {
	ServerSecurityAlertPolicyListResult
}

// WorkspaceManagedSQLServerUsagesClientListResponse contains the response from method WorkspaceManagedSQLServerUsagesClient.List.
type WorkspaceManagedSQLServerUsagesClientListResponse struct {
	ServerUsageListResult
}

// WorkspaceManagedSQLServerVulnerabilityAssessmentsClientCreateOrUpdateResponse contains the response from method WorkspaceManagedSQLServerVulnerabilityAssessmentsClient.CreateOrUpdate.
type WorkspaceManagedSQLServerVulnerabilityAssessmentsClientCreateOrUpdateResponse struct {
	ServerVulnerabilityAssessment
}

// WorkspaceManagedSQLServerVulnerabilityAssessmentsClientDeleteResponse contains the response from method WorkspaceManagedSQLServerVulnerabilityAssessmentsClient.Delete.
type WorkspaceManagedSQLServerVulnerabilityAssessmentsClientDeleteResponse struct {
	// placeholder for future response values
}

// WorkspaceManagedSQLServerVulnerabilityAssessmentsClientGetResponse contains the response from method WorkspaceManagedSQLServerVulnerabilityAssessmentsClient.Get.
type WorkspaceManagedSQLServerVulnerabilityAssessmentsClientGetResponse struct {
	ServerVulnerabilityAssessment
}

// WorkspaceManagedSQLServerVulnerabilityAssessmentsClientListResponse contains the response from method WorkspaceManagedSQLServerVulnerabilityAssessmentsClient.List.
type WorkspaceManagedSQLServerVulnerabilityAssessmentsClientListResponse struct {
	ServerVulnerabilityAssessmentListResult
}

// WorkspaceSQLAADAdminsClientCreateOrUpdateResponse contains the response from method WorkspaceSQLAADAdminsClient.CreateOrUpdate.
type WorkspaceSQLAADAdminsClientCreateOrUpdateResponse struct {
	WorkspaceAADAdminInfo
}

// WorkspaceSQLAADAdminsClientDeleteResponse contains the response from method WorkspaceSQLAADAdminsClient.Delete.
type WorkspaceSQLAADAdminsClientDeleteResponse struct {
	// placeholder for future response values
}

// WorkspaceSQLAADAdminsClientGetResponse contains the response from method WorkspaceSQLAADAdminsClient.Get.
type WorkspaceSQLAADAdminsClientGetResponse struct {
	WorkspaceAADAdminInfo
}

// WorkspacesClientCreateOrUpdateResponse contains the response from method WorkspacesClient.CreateOrUpdate.
type WorkspacesClientCreateOrUpdateResponse struct {
	Workspace
}

// WorkspacesClientDeleteResponse contains the response from method WorkspacesClient.Delete.
type WorkspacesClientDeleteResponse struct {
	// Anything
	Interface interface{}
}

// UnmarshalJSON implements the json.Unmarshaller interface for type WorkspacesClientDeleteResponse.
func (w *WorkspacesClientDeleteResponse) UnmarshalJSON(data []byte) error {
	return json.Unmarshal(data, &w.Interface)
}

// WorkspacesClientGetResponse contains the response from method WorkspacesClient.Get.
type WorkspacesClientGetResponse struct {
	Workspace
}

// WorkspacesClientListByResourceGroupResponse contains the response from method WorkspacesClient.ListByResourceGroup.
type WorkspacesClientListByResourceGroupResponse struct {
	WorkspaceInfoListResult
}

// WorkspacesClientListResponse contains the response from method WorkspacesClient.List.
type WorkspacesClientListResponse struct {
	WorkspaceInfoListResult
}

// WorkspacesClientUpdateResponse contains the response from method WorkspacesClient.Update.
type WorkspacesClientUpdateResponse struct {
	Workspace
}
