//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armvideoanalyzer

// AccessPoliciesClientCreateOrUpdateResponse contains the response from method AccessPoliciesClient.CreateOrUpdate.
type AccessPoliciesClientCreateOrUpdateResponse struct {
	AccessPolicyEntity
}

// AccessPoliciesClientDeleteResponse contains the response from method AccessPoliciesClient.Delete.
type AccessPoliciesClientDeleteResponse struct {
	// placeholder for future response values
}

// AccessPoliciesClientGetResponse contains the response from method AccessPoliciesClient.Get.
type AccessPoliciesClientGetResponse struct {
	AccessPolicyEntity
}

// AccessPoliciesClientListResponse contains the response from method AccessPoliciesClient.List.
type AccessPoliciesClientListResponse struct {
	AccessPolicyEntityCollection
}

// AccessPoliciesClientUpdateResponse contains the response from method AccessPoliciesClient.Update.
type AccessPoliciesClientUpdateResponse struct {
	AccessPolicyEntity
}

// EdgeModulesClientCreateOrUpdateResponse contains the response from method EdgeModulesClient.CreateOrUpdate.
type EdgeModulesClientCreateOrUpdateResponse struct {
	EdgeModuleEntity
}

// EdgeModulesClientDeleteResponse contains the response from method EdgeModulesClient.Delete.
type EdgeModulesClientDeleteResponse struct {
	// placeholder for future response values
}

// EdgeModulesClientGetResponse contains the response from method EdgeModulesClient.Get.
type EdgeModulesClientGetResponse struct {
	EdgeModuleEntity
}

// EdgeModulesClientListProvisioningTokenResponse contains the response from method EdgeModulesClient.ListProvisioningToken.
type EdgeModulesClientListProvisioningTokenResponse struct {
	EdgeModuleProvisioningToken
}

// EdgeModulesClientListResponse contains the response from method EdgeModulesClient.List.
type EdgeModulesClientListResponse struct {
	EdgeModuleEntityCollection
}

// LivePipelineOperationStatusesClientGetResponse contains the response from method LivePipelineOperationStatusesClient.Get.
type LivePipelineOperationStatusesClientGetResponse struct {
	LivePipelineOperationStatus
}

// LivePipelinesClientActivateResponse contains the response from method LivePipelinesClient.Activate.
type LivePipelinesClientActivateResponse struct {
	// placeholder for future response values
}

// LivePipelinesClientCreateOrUpdateResponse contains the response from method LivePipelinesClient.CreateOrUpdate.
type LivePipelinesClientCreateOrUpdateResponse struct {
	LivePipeline
}

// LivePipelinesClientDeactivateResponse contains the response from method LivePipelinesClient.Deactivate.
type LivePipelinesClientDeactivateResponse struct {
	// placeholder for future response values
}

// LivePipelinesClientDeleteResponse contains the response from method LivePipelinesClient.Delete.
type LivePipelinesClientDeleteResponse struct {
	// placeholder for future response values
}

// LivePipelinesClientGetResponse contains the response from method LivePipelinesClient.Get.
type LivePipelinesClientGetResponse struct {
	LivePipeline
}

// LivePipelinesClientListResponse contains the response from method LivePipelinesClient.List.
type LivePipelinesClientListResponse struct {
	LivePipelineCollection
}

// LivePipelinesClientUpdateResponse contains the response from method LivePipelinesClient.Update.
type LivePipelinesClientUpdateResponse struct {
	LivePipeline
}

// LocationsClientCheckNameAvailabilityResponse contains the response from method LocationsClient.CheckNameAvailability.
type LocationsClientCheckNameAvailabilityResponse struct {
	CheckNameAvailabilityResponse
}

// OperationResultsClientGetResponse contains the response from method OperationResultsClient.Get.
type OperationResultsClientGetResponse struct {
	VideoAnalyzer
}

// OperationStatusesClientGetResponse contains the response from method OperationStatusesClient.Get.
type OperationStatusesClientGetResponse struct {
	OperationStatus
}

// OperationsClientListResponse contains the response from method OperationsClient.List.
type OperationsClientListResponse struct {
	OperationCollection
}

// PipelineJobOperationStatusesClientGetResponse contains the response from method PipelineJobOperationStatusesClient.Get.
type PipelineJobOperationStatusesClientGetResponse struct {
	PipelineJobOperationStatus
}

// PipelineJobsClientCancelResponse contains the response from method PipelineJobsClient.Cancel.
type PipelineJobsClientCancelResponse struct {
	// placeholder for future response values
}

// PipelineJobsClientCreateOrUpdateResponse contains the response from method PipelineJobsClient.CreateOrUpdate.
type PipelineJobsClientCreateOrUpdateResponse struct {
	PipelineJob
}

// PipelineJobsClientDeleteResponse contains the response from method PipelineJobsClient.Delete.
type PipelineJobsClientDeleteResponse struct {
	// placeholder for future response values
}

// PipelineJobsClientGetResponse contains the response from method PipelineJobsClient.Get.
type PipelineJobsClientGetResponse struct {
	PipelineJob
}

// PipelineJobsClientListResponse contains the response from method PipelineJobsClient.List.
type PipelineJobsClientListResponse struct {
	PipelineJobCollection
}

// PipelineJobsClientUpdateResponse contains the response from method PipelineJobsClient.Update.
type PipelineJobsClientUpdateResponse struct {
	PipelineJob
}

// PipelineTopologiesClientCreateOrUpdateResponse contains the response from method PipelineTopologiesClient.CreateOrUpdate.
type PipelineTopologiesClientCreateOrUpdateResponse struct {
	PipelineTopology
}

// PipelineTopologiesClientDeleteResponse contains the response from method PipelineTopologiesClient.Delete.
type PipelineTopologiesClientDeleteResponse struct {
	// placeholder for future response values
}

// PipelineTopologiesClientGetResponse contains the response from method PipelineTopologiesClient.Get.
type PipelineTopologiesClientGetResponse struct {
	PipelineTopology
}

// PipelineTopologiesClientListResponse contains the response from method PipelineTopologiesClient.List.
type PipelineTopologiesClientListResponse struct {
	PipelineTopologyCollection
}

// PipelineTopologiesClientUpdateResponse contains the response from method PipelineTopologiesClient.Update.
type PipelineTopologiesClientUpdateResponse struct {
	PipelineTopology
}

// PrivateEndpointConnectionsClientCreateOrUpdateResponse contains the response from method PrivateEndpointConnectionsClient.CreateOrUpdate.
type PrivateEndpointConnectionsClientCreateOrUpdateResponse struct {
	PrivateEndpointConnection
	// AzureAsyncOperation contains the information returned from the Azure-AsyncOperation header response.
	AzureAsyncOperation *string

	// Location contains the information returned from the Location header response.
	Location *string

	// RetryAfter contains the information returned from the Retry-After header response.
	RetryAfter *int32
}

// PrivateEndpointConnectionsClientDeleteResponse contains the response from method PrivateEndpointConnectionsClient.Delete.
type PrivateEndpointConnectionsClientDeleteResponse struct {
	// placeholder for future response values
}

// PrivateEndpointConnectionsClientGetResponse contains the response from method PrivateEndpointConnectionsClient.Get.
type PrivateEndpointConnectionsClientGetResponse struct {
	PrivateEndpointConnection
}

// PrivateEndpointConnectionsClientListResponse contains the response from method PrivateEndpointConnectionsClient.List.
type PrivateEndpointConnectionsClientListResponse struct {
	PrivateEndpointConnectionListResult
}

// PrivateEndpointConnectionsOperationResultsClientGetResponse contains the response from method PrivateEndpointConnectionsOperationResultsClient.Get.
type PrivateEndpointConnectionsOperationResultsClientGetResponse struct {
	PrivateEndpointConnection
}

// PrivateEndpointConnectionsOperationStatusesClientGetResponse contains the response from method PrivateEndpointConnectionsOperationStatusesClient.Get.
type PrivateEndpointConnectionsOperationStatusesClientGetResponse struct {
	PrivateEndpointConnectionOperationStatus
}

// PrivateLinkResourcesClientGetResponse contains the response from method PrivateLinkResourcesClient.Get.
type PrivateLinkResourcesClientGetResponse struct {
	PrivateLinkResource
}

// PrivateLinkResourcesClientListResponse contains the response from method PrivateLinkResourcesClient.List.
type PrivateLinkResourcesClientListResponse struct {
	PrivateLinkResourceListResult
}

// VideoAnalyzersClientCreateOrUpdateResponse contains the response from method VideoAnalyzersClient.CreateOrUpdate.
type VideoAnalyzersClientCreateOrUpdateResponse struct {
	VideoAnalyzer
}

// VideoAnalyzersClientDeleteResponse contains the response from method VideoAnalyzersClient.Delete.
type VideoAnalyzersClientDeleteResponse struct {
	// placeholder for future response values
}

// VideoAnalyzersClientGetResponse contains the response from method VideoAnalyzersClient.Get.
type VideoAnalyzersClientGetResponse struct {
	VideoAnalyzer
}

// VideoAnalyzersClientListBySubscriptionResponse contains the response from method VideoAnalyzersClient.ListBySubscription.
type VideoAnalyzersClientListBySubscriptionResponse struct {
	Collection
}

// VideoAnalyzersClientListResponse contains the response from method VideoAnalyzersClient.List.
type VideoAnalyzersClientListResponse struct {
	Collection
}

// VideoAnalyzersClientUpdateResponse contains the response from method VideoAnalyzersClient.Update.
type VideoAnalyzersClientUpdateResponse struct {
	VideoAnalyzer
}

// VideosClientCreateOrUpdateResponse contains the response from method VideosClient.CreateOrUpdate.
type VideosClientCreateOrUpdateResponse struct {
	VideoEntity
}

// VideosClientDeleteResponse contains the response from method VideosClient.Delete.
type VideosClientDeleteResponse struct {
	// placeholder for future response values
}

// VideosClientGetResponse contains the response from method VideosClient.Get.
type VideosClientGetResponse struct {
	VideoEntity
}

// VideosClientListContentTokenResponse contains the response from method VideosClient.ListContentToken.
type VideosClientListContentTokenResponse struct {
	VideoContentToken
}

// VideosClientListResponse contains the response from method VideosClient.List.
type VideosClientListResponse struct {
	VideoEntityCollection
}

// VideosClientUpdateResponse contains the response from method VideosClient.Update.
type VideosClientUpdateResponse struct {
	VideoEntity
}
